// fourier_basis_fn.h

#if !defined( _fourier_basis_fn_h )
#define _fourier_basis_fn_h

#include "basis_fn.h"

using namespace std;
///
class Fourier_Basis_Fn : public Basis_Fn

{
  public:
   ///
   Fourier_Basis_Fn();
   ///
   Fourier_Basis_Fn( double* v, int terms, int* cmp, int* pw, int* sgn, int* actv_dim = NULL ); // creates a terms-way interaction basis fn with knots at v, on data components cmp with powers pw and signs sn.
   ///
   Fourier_Basis_Fn( double d, int cmp, int pw, int sgn, int* actv_dim = NULL ); // creates a 1-way interaction basis fn with knot at d, on data component cmp with power pw and sign sn.
   ///
   virtual ~Fourier_Basis_Fn();
   ///

   static void set_argument_coefficients( double* new_arg_coeffs, int num_arg_coeffs );
   
   static void zap_argument_coefficients();
   
   virtual double evaluate( double* x, int* actv_dim = NULL, int order_integral = 0, int integral_component = 0 );//evaluate the order_integral'th integral of the basis fn in the intergral_component direction for the gsl::vector x.

 private:

 protected:

   static double* argument_coefficients;//if used, basis is e.g. cos(*argument_coefficient.t) rather than default cos(j.t).

   static int num_argument_coefficients;//the length of this vector.
};   

#endif

