#include "mcmc_constrained_basis_fn_regression.h"

MCMC_Constrained_Basis_Fn_Regression::MCMC_Constrained_Basis_Fn_Regression( int argc, char **argv )
      : MCMC_Basis_Fn_Regression( argc, argv )
{
   positive_negative = 1;
   for( int i = 1; i < argc; i++ )
   {
      if ( strstr( argv[i], "help" ) )
      {
         cout << "positivenegative=" << positive_negative  << "   (If equal to 1, performs isotonic regression; if -1, uses antitonic regression; otherwise if 0, uses antitonic regression)" << endl;
         return;
      }
      if( InitialStringMatch( argv[i], "positivenegative =" ) )
         StringToLong( &positive_negative , argv[i] );
   }
   initialise();
}

MCMC_Constrained_Basis_Fn_Regression::MCMC_Constrained_Basis_Fn_Regression( gsl_matrix* X1, gsl_matrix* Y1 )
        : MCMC_Basis_Fn_Regression( X1, Y1 )
{
   initialise();
}

MCMC_Constrained_Basis_Fn_Regression::MCMC_Constrained_Basis_Fn_Regression( gsl_matrix* X1, gsl_matrix* Y1, gsl_matrix* D1 )
        : MCMC_Basis_Fn_Regression( X1, Y1, D1 )
{
   initialise();
}

MCMC_Constrained_Basis_Fn_Regression::~MCMC_Constrained_Basis_Fn_Regression()
{
}

void MCMC_Constrained_Basis_Fn_Regression::initialise()
{
//   storing_basis_function_coefficients = true;
   if( storing_basis_function_coefficients && SHIFT_COEFFICIENT < 0 )
      SHIFT_COEFFICIENT = add_move( "Shift basis fn. coefficient" );
}

void MCMC_Constrained_Basis_Fn_Regression::post_move_updates()
{
   if( !storing_basis_function_coefficients )
      draw_betas_from_posterior();//automatically sets basis coefficients.
}

void MCMC_Constrained_Basis_Fn_Regression::update_ergodic_averages()
{
   MCMC_Basis_Fn_Regression::update_ergodic_averages();
   if( positive_negative > 0 )
      predict_from_model = isotonic;
   else if( positive_negative < 0 )
      predict_from_model = antitonic;
   else
      predict_from_model = isotonic || antitonic;
}

