#include "mcmc_local_basis_fn_regression.h"

MCMC_Local_Basis_Fn_Regression::MCMC_Local_Basis_Fn_Regression( int argc, char **argv )
      : GLM_MVN( argc, argv )
{
   for( int i = 1; i < argc; i++ )
   {
      if ( strstr( argv[i], "help" ) )
      {
      }
   }
   initialise();
}

MCMC_Local_Basis_Fn_Regression::MCMC_Local_Basis_Fn_Regression( gsl_matrix* X1, gsl_matrix* Y1 )
        : GLM_MVN( X1, Y1 )
{
   initialise();
}

MCMC_Local_Basis_Fn_Regression::MCMC_Local_Basis_Fn_Regression( gsl_matrix* X1, gsl_matrix* Y1, gsl_matrix* D1 )
        : GLM_MVN( X1, Y1, D1 )
{
   initialise();
}

MCMC_Local_Basis_Fn_Regression::~MCMC_Local_Basis_Fn_Regression()
{
}

void MCMC_Local_Basis_Fn_Regression::initialise()
{
//    gsl_matrix* test_points = &gsl_matrix_submatrix( X, regression_n, 0, n - regression_n, p ).matrix;
//    gsl_matrix* training_points = &gsl_matrix_submatrix( X, 0, 0, regression_n, p ).matrix;
   create_test_grid();
   double** distances = calculate_squared_euclidean_distances( test_grid_points, X, test_grid_size );
   size_t** nearest_data_to_test_points = 0;
   create_array( nearest_data_to_test_points, test_grid_size, n );
   for( int i = 0; i < test_grid_size; i++ )
      gsl_sort_index ( nearest_data_to_test_points[ i ], distances[ i ], 1, n );
   print_array( nearest_data_to_test_points, test_grid_size, n );

   calculate_log_posterior();
   if( !storing_basis_function_coefficients )
      set_basis_coefficients( m_star );
   make_grid_predictions();
   write_predictions();
}

void MCMC_Local_Basis_Fn_Regression::post_move_updates()
{
   if( !storing_basis_function_coefficients )
      draw_betas_from_posterior();//automatically sets basis coefficients.
}

void MCMC_Local_Basis_Fn_Regression::update_ergodic_averages()
{
   GLM_MVN::update_ergodic_averages();
}

