#include "glm_mvn_clustering.h"

GLM_MVN_Clustering::GLM_MVN_Clustering( int argc, char **argv )
      : GLM_MVN( argc, argv )
{
   desired_num_clusters = 1;
   minimum_num_clusters = 1;
   minimum_cluster_size = 1;
   maximum_cluster_size = num_subjects;
   no_optimal_clusters_totally_missing_experiments = false;
   bic_criterion = 2;
   euclidean_or_correlation_clustering = 0;
   euclidean_not_correlation = true;
   average_complete_single_link = 0;
   worst_first = false;
   aim_for_positive_closeness = true;
   nn_constraint = false;
   non_negative_nearest_neighbours = true;
   singletons_require_best_friend = 0;
   require_outstanding_merge = false;
   stochastic_agglomeration = 0;
   heller_algorithm = false;
   heller_pi = 0.5;
   heller_log_odds = 0;
   heller_odds = 0;
   heller_reverse_odds = 0;
   heller_dirichlet_alpha = 1;
   heller_d = log_heller_dirichlet_alpha = 0;
   heller_log_r = 0;
   store_targets_in_cluster = false;
   dirichlet_process = 0;
   dirichlet_parameter = 1;
   heteroskedastic = 1;
   number_distinct = 0;
   number_unmergeable = 0;
   randomised_unmergeable = 0;
   nn_equivalence_relation_partition = NULL;
   nn_equivalence_relation_partition_size = 0;
   number_of_labels = 0;
   cluster_by_labels = 0;
   maximal_probs = 0;
   hier_discrim = 0;
   nearest_neighbour_discrim = 0;
   simulate_data = 0;
   experiment_vote = num_experiments;
   change_basis_variance_for_vote = false;//gram_schmidt
   weight_by_missing_values = true;
   subject_experiment_weights = true;
   NOBs = 0;
   YTYs = Y_totals = YTDs = DTDs = YTDVDTYs = 0;
   association_matrix = 0;
   subject_labels = 0;
   a_star_lookup = ln_gamma_a_star_lookup = 0;
   a_star_lookup1 = ln_gamma_a_star_lookup1 = 0;
   a_star_vector = b_star_vector = NULL;
   a_star_vector1 = b_star_vector1 = NULL;
   log_vote_probs = NULL;
   zero_vote_prob = NULL;
   error_prior_contribution_differences = NULL;
   error_prior_contribution_difference_ranks = NULL;
   log_prior_num_clusters = log_prior_cluster_size = 0;
   num_obsns_working = num_obsns_working2 = 0;
   yty_cols = p_y * num_experiments;
   ytd_cols = num_design_cols;
   if( !treat_experiments_as_different_dimensions )
       ytd_cols *= num_experiments;
   yty_working = ytd_working = dtd_working = 0;
   random_effect_rows = 0;
   closeness_matrix = 0;
   single_subject_closeness_matrix = 0;
   single_subject_closest_subject = 0;
   subjects_first_merge = 0;
   current_clustering = 0;
   optimal_clustering = 0;
   best_clustering = 0;
   subject_cluster_types = NULL;
   cluster_probs = 0;
   proposed_subject_list = NULL;
   vstar_working = 0;
   non_conjugate_model = 0;
   storing_non_conjugate_precision_matrices = num_subjects;//2;
   unimodal_bic_function = false;//random_effects_model;
   storing_cluster_closenesses = true;
   store_when_subjects_first_merge = false;
   order_cluster_subjects = true;
   merge_through_input_partition = false;
   output_all_partitions = false;
   preserve_tree = 0;
   conditional_tree_distribution = 4;
   tree_prior_parameter = 99;//.01;
   functional_tree_prior_parameter = 0;
   store_data_throughout_tree = 1;
   dendro_output_format = 0;
   md_write_smallest_subjects = 0;
   prob_stop_cascading = .2;
   cascade_move_clusters = 1*0;
   stop_cascading_at_model = 0;
   tree_shift_distribution = 1;
   preserve_model_with_tree_shifts = 0;
   max_analytic_num_clusters = 1;//12;
   membership_probabilities_required = false;
   check_at_each_max_map_allocation_sweeps = max_map_allocation_sweeps = 0;
   map_allocation_sweep = 0;
   total_number_of_reallocations = 0;
   subject_ever_reallocated = 0;
   variable_dimension_allocation_sweeps = true;
   variable_dimension_allocation_sweeps_at_each_merger = false;
   one_reallocation_per_sweep = true;
   reallocate_worst_each_sweep = 1;
   merge_after_each_sweep = true;
   reallocate_subjects_at_random = false;
   originally_check_allocations_at_each_merger = check_allocations_at_each_merger = false;
   checking_memberships_during_clustering = false;
   rebuild_tree_after_sweeps = true;
   trying_best_singleton = false;
   subject_not_allowed_to_move = -1;
   subject2_not_allowed_to_move = -1;
   try_best_singletons = 0;
   made_gain_from_best_singletons = false;
   gibbs_two_mean_separation = 0;
   gibbs_sweep_power = 1;
   intermediate_gibbs_scans = 0;
   deterministic_initial_split = false;
   reduce_closeness_matrix = true;
   single_subject_closeness_contributions = 0;
   single_subject_hldvs = 0;
   exclude_singleton_clusters = uniform_background = singleton_clusters_uniformly_distributed = false;
   background_prob = 0.5;
   log_nonbackground_penalty = 0;
   retain_singleton_clusters = false;
   single_subject_cluster_ptrs = 0;
   timing_agglomerative_clustering = false;
   *Cluster_Output_Filename = 0;
   *Cluster_Variance_Filename = 0;
   *Cluster_Cov_Filename = 0;
   *Cluster_Means_Filename = 0;
   *Cluster_X_Output_Filename = 0;
   *Cluster_Missing_Values_Filename = 0;
   *Missing_Value_Predictions_Filename = 0;
   *Cluster_Error_Covariances_Filename = 0;
   *Partition_Output_Filename = 0;
   *All_Partitions_Output_Filename = 0;
   *Partition_Input_Filename = 0;
   *Cluster_Sizes_Filename = 0;
   *Subject_Labels_Filename = 0;
   *Cluster_Labels_Filename = 0;
   *Cluster_Subjects_Filename = 0;
   *Merger_Details_Filename = 0;
   *Bare_Merger_Details_Filename = 0;
   *Input_Merger_Details_Filename = 0;
   *Dendrogram_Output_Filename = 0;
   *Dendrogram_Cutpoint_Filename = 0;
   *Dendrogram_Scores_Filename = 0;
   *Subjects_First_Merge_Filename = 0;
   *Association_Matrix_Filename = 0;
   *Closeness_Matrix_Filename = 0;
   *Single_Subject_Contributions_Filename = 0;
   *Single_Subject_Nearest_Neighbour_Filename = 0;
   *NN_equivalence_relation_partition_Filename = 0;
   *Cluster_Nearest_Neighbour_Filename = 0;
   *Cluster_Closeness_Filename = 0;
   *Membership_Probability_Filename = 0;
   *Misallocated_Subject_Filename = 0;
   *Lift_Chart_Filename = 0;
   *Simulated_Data_Filename = 0;
   *Subject_Allocations_Filename = 0;
   *Subject_Misallocation_History_Filename = 0;
   *Votes_Filename = 0;
   *Vote_Probabilities_Filename = 0;
   *Agglomerative_Timing_Filename = 0;

   for( int i = 1; i < argc; i++ )
   {
      if ( strstr( argv[i], "help" ) )
      {
         cout << "numberofclusters=" << desired_num_clusters << "   (Minimum number of clusters we'll allow in hierarchical clustering)" << endl;
	 cout << "minimumclustersize=" << minimum_cluster_size << "   (Minimum size of clusters we'll allow in an optimal clustering)" << endl;
	 cout << "maximumclustersize=" << maximum_cluster_size << "   (Maximum size of clusters we'll allow in an optimal clustering)" << endl;
         cout << "noemptyexptclusters=" << no_optimal_clusters_totally_missing_experiments << "   (If true, do not allow optimal clusterings where a cluster has entirely missing values for 1 or more experiments)" << endl;
         cout << "bic=" << bic_criterion << "   (If =2, choose number of clusters to maximise marginal likelihood (recommended); if =1, maximises a penalised M.L.)" << endl;
         cout << "euclideanclustering=" << euclidean_or_correlation_clustering << "   (If non-zero, then if 1 just do standard euclidean hierarchical clustering, else if 2 just do correlation hierarchical clustering)" << endl;
	 cout << "averagecompletesinglelink=" << average_complete_single_link << "   (If non-zero, then if 1 do average-link clustering, if 2 do complete-link clustering, else if 3 do single-link clustering, all on the initial closeness matrix for the single subject clusters)" << endl;
         cout << "worstfirst=" << worst_first << "   (If non-zero, runs agglomerative clustering where it is not the two closest clusters that are merged, but the neighbour pair with the worst but still positive closeness)" << endl;
         cout << "aimforpositivecloseness=" << aim_for_positive_closeness<< "   (If non-zero, and worstfirst is non-zero, at least looks for a positive closeness if available)" << endl;
         cout << "singletonsrequirebestfriend=" << singletons_require_best_friend <<  "   (If non zero, then a singleton can only merge with the cluster which contains its nearest subject; if equal to 2 and both clusters are singletons, then each must be nearest neighbours to one another)" << endl;
         cout << "nearestneighbourconstraint=" << nn_constraint <<  "   (If true, two clusters can merge only if they each have subjects where one is the nearest neighbour of one the other (not necessarily both ways)" << endl;
         cout << "nonnegativenearestneighbours=" << non_negative_nearest_neighbours <<  "   (If true, a subject has no nearest neighbour if its closest subject has negative closeness)" << endl;
         cout << "requireoutstandingmerge=" << require_outstanding_merge <<   "   (If true, then we take not the best merger but merge the cluster which has the greatest difference in score from its optimal merge against all the alternatives)" << endl;
         cout << "helleralgorithm=" << heller_algorithm << "   (If non-zero, runs the clustering algorithm of Heller and Ghahramani)" << endl;
         cout << "stochasticagglomeration=" << stochastic_agglomeration << "   (If non-zero, each merge in agglomerative clustering is stochastic, with probability proportional to posterior score; if equal to 1, consider mergers of any cluster with their nearest; if 2, consider any merger)" << endl;
         cout << "hellerpi=" << heller_pi << "   (Value of pi probability if using the clustering algorithm of Heller and Ghahramani)" << endl;
	 cout << "hellerdirichletparameter=" << heller_dirichlet_alpha << "  (Value of DP parameter if using the clustering algorithm of Heller and Ghahramani)" << endl;
         cout << "dirichletprocess=" << dirichlet_process << "   (If non-zero, the spline coefficients follow a Dirichlet process)" << endl;
         cout << "dirichletparameter=" << dirichlet_parameter << "   (Parameter of the dirichlet distribution controlling the number of clusters)" << endl;
	 cout << "uniformbackground=" << uniform_background << "   (If true, then the data in any singleton clusters are assumed to be uniformly distributed over the data space)" << endl;
         cout << "backgroundprob" << background_prob << "   (The probability that a subject is from the Uniform background model)" << endl;
         cout << "experimentvote=" << experiment_vote << "   (the number of experiments assigned to a_, b_ rather than a_1, b_1, and so driving the clustering.)"<< endl;
	 cout << "voteprobsfile" << Vote_Probabilities_Filename << "   (File for reading in the probability of each experiment having a strong say in the clustering.)" << endl;
         cout << "missingvalueweights" << weight_by_missing_values <<  "   (If missing values have been provided, weight subject according to them)" << endl;
         cout <<  "probabilitystopcascading=" << prob_stop_cascading << "   (When cascading down tree, stop cascading with this probability)" << endl;
         cout <<  "maxanalyticnumclusters=" << max_analytic_num_clusters << "   (The maximum number of subjects for which we would attempt to find the marginal probabilities analytically, summing over all possible cluster configurations)" << endl;
         cout << "clusteroutputfile=" << Cluster_Output_Filename << "   (File which final clustering is written to. Each row is an observation - first column contains a cluster number, subsequent columns the observed responses for that observation)" << endl;
         cout << "clustervariancefile=" << Cluster_Variance_Filename << "   (File which final clustering posterior variances are written to)" << endl;
         cout << "clustercovfile=" << Cluster_Cov_Filename << "   (File which final clustering posterior covariance matrices are written to)" << endl;
         cout << "clustermeansfile=" << Cluster_Means_Filename << "   (File which final clustering posterior means are written to)" << endl;
         cout << "partitionoutputfile=" << Partition_Output_Filename << "   (File which final clustering partition is written to. Each row is a cluster, containg a list of the subject numbers allocated to it)" << endl;
         cout << "partitioninputfile=" << Partition_Input_Filename << "   (File which initial clustering partition is read in from. Each row is a cluster, containg a list of the subject numbers allocated to it)" << endl;
         cout << "clusterpredictoroutputfile=" << Cluster_X_Output_Filename << "   (Accompanying file to clusteroutputfile. Each row is an observation -  first column contains a cluster number, subsequent columns the corresponding predictors for that observation)" << endl;
         cout << "clustersizesfile=" << Cluster_Sizes_Filename << "   (File in which to write the sizes of the clusters in the final model)" << endl;
         cout << "heteroskedastic=" << heteroskedastic << "   (If =1, a separate noise variance for each experiment in each cluster; if =2, same for each experiment but different across clusters;  if =0 same for all.)" << endl;
//          cout << "numberdistinct=" << number_distinct << endl;
         cout << "numberunmergeable=" << number_unmergeable << "   (The last (or, if randomisedunmergeable is non-zero, a random selection of) this many subjects will not be allowed to merge with other clusters, say if we want to make predictions for them as to which cluster they belong to)" << endl;
         cout << "randomisedunmergeable=" << randomised_unmergeable << endl;
//          cout << "numberofclusterlabels=" << number_of_labels << endl;
         cout << "subjectlabelsfile=" << Subject_Labels_Filename << "   (A file containing a list of labels we may want to attach to the first so many subjects and their clusters)" << endl;
         cout << "clusterlabelsfile=" << Cluster_Labels_Filename << "   (Output file to which a list of cluster labels of the final clustering will be written)" << endl;
         cout << "clustersubjectsfile=" << Cluster_Subjects_Filename << "   (Output file to which a list of the subjects in each cluster of the final clustering will be written)" << endl;
         cout << "clusterbylabels=" << cluster_by_labels << "   (If non-zero, we only allow clusters with the same labels to merge)" << endl;
//          cout << "maximalprobabilities=" << maximal_probs << endl;
//          cout << "hierarchicaldiscrimination=" << hier_discrim << endl;
//         cout << "simulatedata=" << simulate_data << endl;
         cout << "unimodalbicfunction=" << unimodal_bic_function << endl;
         cout << "nonconjugatemodel=" << non_conjugate_model << "   (If non-zero, do not model the spline coefficients as having covariance matrix which is multiplied by the noise variance - loses conjugacy, meaning numberical integration or MCMC will be required. Y~N(Xb,sigma), b~N(0,V) => Y~N(0,sigma*I + XVX').)" << endl;
         cout << "storingclusterclosenesses=" << storing_cluster_closenesses << "   (If=0, do not store the closeness of clusters to one another - saves lots of memory for huge data sets, but more time consuming)" << endl;
	 cout << "storesubjectsfirstmerge=" << store_when_subjects_first_merge << "   (If true, then write to file as a matrix the level in the hierarchy where any two subjects merge)" << endl;
         cout << "orderclustersubjects=" << order_cluster_subjects << "   (If non-zero, then within each cluster maintain a good order for abosrbed clusters so that neighbouring clusters in the dendrogram are close" << endl;
         cout << "mergethroughinputpartition=" << merge_through_input_partition << "   (If true, then when reading in an initial partition, mark the subject in each cluster with a type and then immdediately split up the partition into singletons and do constrained agglomerative clustering passing through the input partition)" << endl;
	 cout <<  "outputallpartitions" << output_all_partitions << "   (If true, write the partition at each level of AC to file)" << endl;
         cout << "preservetree=" << preserve_tree << "   (If non zero, do not delete clusters when merging but contain them within 'super-clusters' - uses more memory, but aids mixing in MCMC)" << endl;
         cout << "conditionaltreedistribution=" << conditional_tree_distribution << "   (Non-zero if the distribution chosen for the tree is uniform on all those compatible with the current model)" << endl;
         cout << "treepriorparameter=" << tree_prior_parameter << "   (Parameter for tree prior distribution, controlling how strongly the differences between parent and child configurations are weighted)" << endl;
         cout << "storedataintree=" << store_data_throughout_tree << "   (If non zero and preserving tree, each parent cluster stores its own data (eg. yty matrix).)" << endl;
         cout << "treeshiftdistribution=" << tree_shift_distribution << "   (If non zero and preserving tree, direction probabilities for a cluster cascading down tree will proportional to closeness, otherwise uniform.)" << endl;
         cout << "preservemodelwithtreeshifts=" << preserve_model_with_tree_shifts << "   (If true, then if cluster picked to shift is somewhere below a cluster in the model in the tree, it will be shifted somewhere below that cluster.)" << endl;
         cout << "reallocationsweeps=" << max_map_allocation_sweeps << "   (If > 0, do this many sweeps of iteratively allocating subjects to their most probable cluster, where after each sweep these probabilities are recalculated.)" << endl;
	 cout << "reallocationsweepsateach=" << check_at_each_max_map_allocation_sweeps << "   (For specifying a different number of realloction sweeps during agglomerative clustering than after.)" << endl;
         cout << "variabledimensionreallocationsweeps=" << variable_dimension_allocation_sweeps << "   (If true, allow the reallocations sweeps after agglomerative clustering to create new clusters containing a single subject.)" << endl;
         cout << "variabledimensionsweepsateach=" << variable_dimension_allocation_sweeps_at_each_merger << "   (If true and doing iterative reallocation at each step of agglomerative clustering, allow the reallocations sweeps to create new clusters containing a single subject.)" << endl;
         cout << "onereallocationpersweep=" << one_reallocation_per_sweep << "   (If true, at each sweep only reallocate the first misallocated subject.)" << endl;
         cout << "reallocateworsteachsweep=" << reallocate_worst_each_sweep << "   (If one reallocation per sweep, then: if 1 (-1), at each sweep only reallocate the misallocated subject with highest (lowes) prob of belonging to another particular cluster; if 2 (-2), only reallocate the misallocated subject with lowest (highest) prob of belonging to its current cluster; if 0, reallocate the first misallocated subject.)" << endl;
         cout << "mergeaftereachsweep=" << merge_after_each_sweep << "   (If true, after each sweep do agglomerative clustering to see if any clusters should now merge.)" << endl;
         cout << "randomlyreallocate=" << reallocate_subjects_at_random << "   (If true, randomly reallocate subject to clusters with prob proporitonal to their membership prob.)" << endl;
         cout << "sweepateachmerger=" << check_allocations_at_each_merger << "   (If true, do iterative reallocation at each step of agglomerative clustering.)" << endl;
         cout << "rebuildtree=" << rebuild_tree_after_sweeps << "   (If true, then after reallocating subjects to different clusters, rebuild the dendrogram around the new clustering - and perhaps find a better new one at a different level of the hierarchy.)" << endl;
	 cout << "trybestsingletons=" << try_best_singletons << "   (If non-zero, then in turn move the top (this many) most probable subjects to become a singleton cluster and then try reallocating; a negative number will mean all singletons are tried.)" << endl;
         cout << "gibbstwomeanseparation=" << gibbs_two_mean_separation << "   (If non zero and not preserving tree, split a cluster by 2 means clustering on furthest points, then perform one tempered gibbs sweep on the allocations.)" << endl;
         cout << "gibbssweeppower=" << gibbs_sweep_power << "   (Power which probabilities are raised to in gibbs sweep.)" << endl;
         cout << "intermediategibbsscans=" << intermediate_gibbs_scans << "   (The number of intermediate gibbs scans that are taken before final gibbs scan if using gibbstwomeanseparation.)" << endl;
         cout << "deterministicinitialsplit=" << deterministic_initial_split << "   (If true and using gibbstwomeanseparation, initially split a cluster by finding the two most distant subjects, and then successively allocate each of the remaining subjects to their nearest cluster, otherwise split totally randomly.)" << endl;
         cout << "reduceclosenessmatrix=" << reduce_closeness_matrix << "   (If true, then delete rows of closeness matrix after merging in agglomerative clustering.)" << endl;
         cout << "timingclustering=" << timing_agglomerative_clustering << "   (If true, then record the time taken for each iteration of first run of agglomerative clustering.)" << endl;
//         cout << "simulateddatafile=" << Simulated_Data_Filename << endl;
         cout << "mergerdetailsfile=" << Merger_Details_Filename << "   (Contains the details of each merger that occured in the hierarchical clustering, first column has the resulting number of clusters, the next 2 columns have the smallest subject numbers of each cluster, and the final two columns contain the resulting marginal likelihoods and BIC scores)" << endl;
	 cout << "inputmergerdetailsfile=" << Merger_Details_Filename << "   (Should contain the details of each merger required, in a four column format)" << endl;
         cout << "associationmatrixfile=" << Association_Matrix_Filename << "   (File for writing the averaged subject association matrix)" << endl;
         cout << "closenessmatrixfile=" << Closeness_Matrix_Filename << "   (File for writing the cluster closeness matrix)" << endl;
         cout << "singlesubjectcontributionsfile=" << Single_Subject_Contributions_Filename << "   (File for writing the closeness contributions for each of the individual subjects)" << endl;
         cout << "singlesubjectnearestneighbourfile=" << Single_Subject_Nearest_Neighbour_Filename << "   (File for writing the closest other subject for each of the individual subjects)" << endl;
         cout << "clusternearestneighbourfile=" << Cluster_Nearest_Neighbour_Filename << "   (File for writing the closest other cluster for each of the reported clusters)" << endl;
         cout << "membershipprobabilityfile=" << Membership_Probability_Filename << "   (File for writing the cluster membership probabilities)" << endl;
         cout << "dendrogramoutputfile=" << Dendrogram_Output_Filename << "   (File for writing the (subject permutations)/(cluster number & data) to after ordering according to agglomerative clustering)" << endl;
         cout << "dendrogramcutpointfile=" << Dendrogram_Cutpoint_Filename << "   (File for writing the order of the cutpoints in the Dendrogram_Output_Filename in the hierarchical clustering)" << endl;
         cout << "dendrogramoutputfileformat=" << dendro_output_format << "   (If non-zero write the output to the dendrogramoutputfile as rows of cluster number and subject responses, othewise write subject numbers in new order)" << endl;
         cout << "mergerdetailsformat=" << md_write_smallest_subjects << "   (When writing merger details, if non-zero, write the smallest subjects of the two clusters being merged to file. otherwise, write their first and last subjects)" << endl;
         cout << "subjectallocationsfile=" << Subject_Allocations_Filename << "   (Contains two columns, the first giving the cluster number, the second a subject (data row) number allocated to that cluster)" << endl;
//          cout << "liftchartfile=" << Lift_Chart_Filename << endl;
         return;
      }
      if( InitialStringMatch( argv[i], "numberofclusters=" ) )
         StringToLong( &desired_num_clusters, argv[i] );
      if( InitialStringMatch( argv[i], "minimumclustersize=" ) )
         StringToLong( &minimum_cluster_size, argv[i] );
      if( InitialStringMatch( argv[i], "maximumclustersize=" ) )
         StringToLong( &maximum_cluster_size, argv[i] );
      if( InitialStringMatch( argv[i], "bic=" ) )
         StringToLong( &bic_criterion, argv[i] );
      if( InitialStringMatch( argv[i], "noemptyexptclusters" ) )
         StringToBool( &no_optimal_clusters_totally_missing_experiments, argv[i] );
      if( InitialStringMatch( argv[i], "euclideanclustering=" ) )
         StringToLong( &euclidean_or_correlation_clustering, argv[i] );
      if( InitialStringMatch( argv[i], "euclideannotcorrelation" ) )
         StringToBool( &euclidean_not_correlation, argv[i] );
      if( InitialStringMatch( argv[i], "averagecompletesinglelink" ) )
         StringToLong( &average_complete_single_link, argv[i] );
      if( InitialStringMatch( argv[i], "worstfirst=" ) )
         StringToBool( &worst_first, argv[i] );
      if( InitialStringMatch( argv[i], "aimforpositivecloseness=" ) )
         StringToBool( &aim_for_positive_closeness, argv[i] );
      if( InitialStringMatch( argv[i], "singletonsrequirebestfriend=" ) )
         StringToLong( &singletons_require_best_friend, argv[i] );
      if( InitialStringMatch( argv[i], "nearestneighbourconstraint=" ) )
         StringToBool( &nn_constraint, argv[i] );
      if( InitialStringMatch( argv[i], "nonnegativenearestneighbours=" ) )
         StringToBool( &non_negative_nearest_neighbours, argv[i] );
      if( InitialStringMatch( argv[i], "requireoutstandingmerge=" ) )
         StringToBool( &require_outstanding_merge, argv[i] );
      if( InitialStringMatch( argv[i], "stochasticagglomeration=" ) )
         StringToLong( &stochastic_agglomeration, argv[i] );
      if( InitialStringMatch( argv[i], "helleralgorithm=" ) )
         StringToBool( &heller_algorithm, argv[i] );
      if( InitialStringMatch( argv[i], "hellerpi=" ) )
         StringToDouble( &heller_pi, argv[i] );
      if( InitialStringMatch( argv[i], "hellerdirichletparameter=" ) )
         StringToDouble( &heller_dirichlet_alpha, argv[i] );
      if( InitialStringMatch( argv[i], "dirichletprocess" ) )
         StringToBool( &dirichlet_process, argv[i] );
      if( InitialStringMatch( argv[i], "dirichletparameter=" ) )
         StringToDouble( &dirichlet_parameter, argv[i] );
      if( InitialStringMatch( argv[i], "experimentvote=" ) )
         StringToNumber( &experiment_vote, argv[i] );
      if( InitialStringMatch( argv[i], "uniformbackground=" ) )
         StringToBool( &uniform_background, argv[i] );
      if( InitialStringMatch( argv[i], "backgroundprob=" ) )
         StringToDouble( &background_prob, argv[i] );
      if( InitialStringMatch( argv[i], "missingvalueweights" ) )
         StringToBool( &weight_by_missing_values, argv[i] );
      if( InitialStringMatch( argv[i], "probabilitystopcascading=" ) )
         StringToDouble( &prob_stop_cascading, argv[i] );
      if( InitialStringMatch( argv[i], "maxanalyticnumclusters=" ) )
         StringToDouble( &max_analytic_num_clusters, argv[i] );
      if( InitialStringMatch( argv[i], "clusteroutputfile=" ) )
         StringToString( Cluster_Output_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clustervariancefile=" ) )
         StringToString( Cluster_Variance_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clustercovfile=" ) )
         StringToString( Cluster_Cov_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clustermeansfile=" ) )
         StringToString( Cluster_Means_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clusterpredictoroutputfile=" ) )
         StringToString( Cluster_X_Output_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "partitionoutputfile=" ) )
         StringToString( Partition_Output_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "partitioninputfile=" ) )
         StringToString( Partition_Input_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clustersizesfile=" ) )
         StringToString( Cluster_Sizes_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "heteroskedastic=" ) )
         StringToLong( &heteroskedastic, argv[i] );
      if( InitialStringMatch( argv[i], "numberdistinct=" ) )
         StringToLong( &number_distinct, argv[i] );
      if( InitialStringMatch( argv[i], "numberunmergeable=" ) )
         StringToLong( &number_unmergeable, argv[i] );
      if( InitialStringMatch( argv[i], "randomisedunmergeable=" ) )
         StringToBool( &randomised_unmergeable, argv[i] );
      if( InitialStringMatch( argv[i], "numberofclusterlabels=" ) )
         StringToLong( &number_of_labels, argv[i] );
      if( InitialStringMatch( argv[i], "subjectlabelsfile=" ) )
         StringToString( Subject_Labels_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clusterlabelsfile=" ) )
         StringToString( Cluster_Labels_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clustersubjectsfile=" ) )
         StringToString( Cluster_Subjects_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clusterbylabels=" ) )
         StringToBool( &cluster_by_labels, argv[i] );
      if( InitialStringMatch( argv[i], "maximalprobabilities=" ) )
         StringToBool( &maximal_probs, argv[i] );
      if( InitialStringMatch( argv[i], "hierarchicaldiscrimination=" ) )
         StringToBool( &hier_discrim, argv[i] );
      if( InitialStringMatch( argv[i], "nearestneighbourdiscrimination=" ) )
         StringToLong( &nearest_neighbour_discrim, argv[i] );
      if( InitialStringMatch( argv[i], "simulatedata=" ) )
         StringToBool( &simulate_data, argv[i] );
      if( InitialStringMatch( argv[i], "nonconjugatemodel=" ) )
         StringToBool( &non_conjugate_model, argv[i] );
      if( InitialStringMatch( argv[i], "unimodalbicfunction=" ) )
         StringToBool( &unimodal_bic_function, argv[i] );
      if( InitialStringMatch( argv[i], "storingclusterclosenesses=" ) )
         StringToBool( &storing_cluster_closenesses, argv[i] );
      if( InitialStringMatch( argv[i], "storesubjectsfirstmerge=" ) )
         StringToBool( &store_when_subjects_first_merge, argv[i] );
      if( InitialStringMatch( argv[i], "orderclustersubjects=" ) )
         StringToBool( &order_cluster_subjects, argv[i] );
      if( InitialStringMatch( argv[i], "mergethroughinputpartition=" ) )
         StringToBool( &merge_through_input_partition, argv[i] );
      if( InitialStringMatch( argv[i], "outputallpartitions=" ) )
         StringToBool( &output_all_partitions, argv[i] );
      if( InitialStringMatch( argv[i], "preservetree=" ) )
         StringToBool( &preserve_tree, argv[i] );
      if( InitialStringMatch( argv[i], "conditionaltreedistribution=" ) )
         StringToLong( &conditional_tree_distribution, argv[i] );
      if( InitialStringMatch( argv[i], "treepriorparameter=" ) )
         StringToDouble( &tree_prior_parameter, argv[i] );
      if( InitialStringMatch( argv[i], "storedataintree=" ) )
         StringToBool( &store_data_throughout_tree, argv[i] );
      if( InitialStringMatch( argv[i], "treeshiftdistribution=" ) )
         StringToLong( &tree_shift_distribution, argv[i] );
      if( InitialStringMatch( argv[i], "preservemodelwithtreeshifts=" ) )
         StringToBool( &preserve_model_with_tree_shifts, argv[i] );
      if( InitialStringMatch( argv[i], "reallocationsweeps=" ) )
         StringToLong( &max_map_allocation_sweeps, argv[i] );
      if( InitialStringMatch( argv[i], "reallocationsweepsateach=" ) )
         StringToLong( &check_at_each_max_map_allocation_sweeps, argv[i] );
      if( InitialStringMatch( argv[i], "variabledimensionreallocationsweeps=" ) )
         StringToBool( &variable_dimension_allocation_sweeps, argv[i] );
      if( InitialStringMatch( argv[i], "variabledimensionsweepsateach=" ) )
         StringToBool( &variable_dimension_allocation_sweeps_at_each_merger, argv[i] );
      if( InitialStringMatch( argv[i], "onereallocationpersweep=" ) )
         StringToBool( &one_reallocation_per_sweep, argv[i] );
      if( InitialStringMatch( argv[i], "reallocateworsteachsweep=" ) )
         StringToLong( &reallocate_worst_each_sweep, argv[i] );
      if( InitialStringMatch( argv[i], "mergeaftereachsweep=" ) )
         StringToBool( &merge_after_each_sweep, argv[i] );
      if( InitialStringMatch( argv[i], "randomlyreallocate=" ) )
         StringToBool( &reallocate_subjects_at_random, argv[i] );
      if( InitialStringMatch( argv[i], "sweepateachmerger=" ) )
         StringToBool( &check_allocations_at_each_merger, argv[i] );
      if( InitialStringMatch( argv[i], "rebuildtree=" ) )
         StringToBool( &rebuild_tree_after_sweeps, argv[i] );
      if( InitialStringMatch( argv[i], "trybestsingletons=" ) )
         StringToLong( &try_best_singletons, argv[i] );
      if( InitialStringMatch( argv[i], "gibbstwomeanseparation=" ) )
         StringToBool( &gibbs_two_mean_separation, argv[i] );
      if( InitialStringMatch( argv[i], "gibbssweeppower=" ) )
         StringToDouble( &gibbs_sweep_power, argv[i] );
      if( InitialStringMatch( argv[i], "intermediategibbsscans=" ) )
         StringToLong( &intermediate_gibbs_scans, argv[i] );
      if( InitialStringMatch( argv[i], "deterministicinitialsplit=" ) )
         StringToBool( &deterministic_initial_split, argv[i] );
      if( InitialStringMatch( argv[i], "reduceclosenessmatrix=" ) )
         StringToBool( &reduce_closeness_matrix, argv[i] );
      if( InitialStringMatch( argv[i], "simulateddatafile=" ) )
         StringToString( Simulated_Data_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "mergerdetailsfile=" ) )
         StringToString( Merger_Details_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "inputmergerdetailsfile=" ) )
         StringToString( Input_Merger_Details_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "dendrogramoutputfile=" ) )
         StringToString( Dendrogram_Output_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "dendrogramcutpointfile=" ) )
         StringToString( Dendrogram_Cutpoint_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "associationmatrixfile=" ) )
         StringToString( Association_Matrix_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "closenessmatrixfile=" ) )
         StringToString( Closeness_Matrix_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "singlesubjectcontributionsfile=" ) )
         StringToString( Single_Subject_Contributions_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "singlesubjectnearestneighbourfile=" ) )
         StringToString( Single_Subject_Nearest_Neighbour_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "clusternearestneighbourfile=" ) )
         StringToString( Cluster_Nearest_Neighbour_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "membershipprobabilityfile=" ) )
         StringToString( Membership_Probability_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "dendrogramoutputformat=" ) )
         StringToBool( &dendro_output_format, argv[i] );
      if( InitialStringMatch( argv[i], "mergerdetailsformat=" ) )
         StringToBool( &md_write_smallest_subjects, argv[i] );
      if( InitialStringMatch( argv[i], "subjectallocationsfile=" ) )
         StringToString( Subject_Allocations_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "liftchartfile=" ) )
         StringToString( Lift_Chart_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "voteprobsfile=" ) )
         StringToString( Vote_Probabilities_Filename, argv[i] );
      if( InitialStringMatch( argv[i], "timingclustering=" ) )
         StringToBool( &timing_agglomerative_clustering, argv[i] );
   }
   if( desired_num_clusters > 1 )
      bic_criterion = 0;
   if( require_outstanding_merge )
   {
      stochastic_agglomeration = 0;
//      singletons_require_best_friend = 0; 
   }
   if( nn_constraint && singletons_require_best_friend )//== 2 )
      singletons_require_best_friend = 0;//1;
   if( nn_constraint || singletons_require_best_friend )
   {
      if( singletons_require_best_friend && check_allocations_at_each_merger )
         one_reallocation_per_sweep = true;
      if( average_complete_single_link )
         average_complete_single_link = 3;//only the single-link type constraint has been implemented - any nearest neighbour will do.
   }
   if( print_to_screen )
   {
      if( average_complete_single_link == 1 )
	 cout << "Average-link clustering" << endl;
      else if( average_complete_single_link == 2 )
	 cout << "Complete-link clustering" << endl;
      else if( average_complete_single_link == 3 )
	 cout << "Single-link clustering" << endl;
      if( heller_algorithm )
         cout << "Using BHC algorithm of Heller and Ghahramani (2005), with Dirichlet parameter alpha=" << heller_dirichlet_alpha << endl;
      if( stochastic_agglomeration )
         cout << "Stochastic Agglomerative Clustering. Randomly choosing clusters to merge with probability proportional to the resulting gain in marginal probability" << endl;
      if( bic_criterion == 1 )
         cout << "Choosing the number of clusters automatically using the Bayesian Information Criterion (BIC)" << endl;
      else if( bic_criterion == 2 )
         cout << "Choosing the number of clusters automatically by maximising the marginal probability" << endl;
      if( nn_constraint || singletons_require_best_friend )
         cout << "Nearest neighbour constrained search, one subject of a cluster must be merging with a nearest neighbour subject" << endl;
   }
   initialise_glm_mvn_clustering();
}

GLM_MVN_Clustering::GLM_MVN_Clustering( gsl_matrix* X1, gsl_matrix* Y1 )
      : GLM_MVN( X1, Y1 )
{
   initialise_glm_mvn_clustering();
}

GLM_MVN_Clustering::GLM_MVN_Clustering( gsl_matrix* X1, gsl_matrix* Y1, gsl_matrix* D1 )
      : GLM_MVN( X1, Y1, D1 )
{
   initialise_glm_mvn_clustering();
}

GLM_MVN_Clustering::~GLM_MVN_Clustering()
{
   Cluster_GLM_MVN::kill_static_variables();
   zap_array( YTYs, p_y * num_subjects, yty_cols );
   zap_array( Y_totals, num_subjects, p_y );
   zap_array( YTDs, p_y * num_subjects, ytd_cols );
   zap_array( DTDs, num_design_cols * num_subjects, yty_cols  );
   zap_array( NOBs, num_subjects, dim_num_obsns );
   zap_triangular_array( closeness_matrix, num_subjects );
   zap_triangular_array( single_subject_closeness_matrix, num_subjects );
   zap_vector( single_subject_closest_subject );
   zap_triangular_array( subjects_first_merge, num_subjects );
   zap_array( merger_details, merger_details_rows, merger_details_cols );
   zap_array( best_merger_details, merger_details_rows, merger_details_cols );
   zap_array( input_merger_details, merger_details_rows_original - 1, 4 );
   if( dendrogram )
      delete [] dendrogram;
   if( best_dendrogram )
      delete [] best_dendrogram;
   if( inverse_dendrogram )
      delete [] inverse_dendrogram;
   if( dendrogram_scores )
      delete [] dendrogram_scores;
   if( num_obsns_working )
      gsl_matrix_int_free( num_obsns_working );
   if( num_obsns_working2 )
      gsl_matrix_int_free( num_obsns_working2 );
   if( yty_working )
      gsl_matrix_free( yty_working );
   if( ytd_working )
      gsl_matrix_free( ytd_working );
   if( dtd_working )
      gsl_matrix_free( dtd_working );
   zap_vector( subject_labels );
   zap_vector( ln_gamma_a_star_lookup );
   zap_vector( a_star_lookup );
   zap_vector( ln_gamma_a_star_lookup1 );
   zap_vector( a_star_lookup1 );
   zap_vector( a_star_vector );
   zap_vector( b_star_vector );
   zap_vector( a_star_vector1 );
   zap_vector( b_star_vector1 );
   zap_vector( error_prior_contribution_differences );
   zap_vector( error_prior_contribution_difference_ranks );
   zap_vector( zero_vote_prob );
   zap_array( log_vote_probs, num_experiments, 2 );
   zap_vector( log_prior_num_clusters );
   zap_vector( log_prior_cluster_size );
   zap_vector( cluster_probs );
   zap_array( membership_probability, num_subjects, membership_probability_dim );
   zap_vector( map_memberships );
   zap_array( membership_contributions, num_subjects, num_subjects + 1 );
   zap_vector( max_log_probs );
   zap_vector( probsums );
   zap_array( association_matrix, num_subjects, num_subjects );
   zap_vector( single_subject_closeness_contributions );
   zap_vector( single_subject_hldvs );
   zap_array( m_star_exp, num_experiments, num_design_cols );
   zap_vector( current_clustering );
   zap_vector( optimal_clustering );
   zap( proposed_subject_list );
   if( subject_cluster_types != best_clustering && subject_cluster_types != nn_equivalence_relation_partition )
      zap_vector( subject_cluster_types );
   zap_vector( nn_equivalence_relation_partition );
   zap_vector( best_clustering );
   zap_vector( subject_ever_reallocated );
   int i;
   if( single_subject_cluster_ptrs )
   {
      for( i = 0; i < num_subjects; i++ )
         zap( single_subject_cluster_ptrs[ i ] );
      delete single_subject_cluster_ptrs;
   }
   if( !preserve_tree )
      empty_cluster_map();
   else
   {
      list<Cluster_GLM_MVN*> root_clusters = Cluster_GLM_MVN::get_root_clusters();
      for( list<Cluster_GLM_MVN*>::iterator iter = root_clusters.begin(); iter != root_clusters.end(); ++iter )
         (*iter)->delete_down_to_subject_clusters();
      for( deque< Cluster_GLM_MVN* >::iterator d_iter = single_subject_clusters.begin(); d_iter != single_subject_clusters.end(); ++d_iter )
         zap( *d_iter );
   }
   for( i = 0; i < number_of_vs; i++ )
   {
      set_v_index( i );
      for( mx_numtoptr::iterator iter = vstar_map->begin(); iter != vstar_map->end(); ++iter )
         if( iter->second )
            gsl_matrix_free( iter->second );
      zap( vstar_map );
      zap( half_log_det_vstars );
   }
   if( vstar_maps_store )
   {
      for( i = 0; i < number_of_vs; i++ )
	 zap( vstar_maps_store[ i ] );
      delete [] vstar_maps_store;
      vstar_maps_store = 0;
      vstar_map_store = 0;
   }
   delete [] vstar_maps;
   if( half_log_det_vstar_maps_store )
   {
      for( i = 0; i < number_of_vs; i++ )
	 zap( half_log_det_vstar_maps_store[ i ] );
      delete [] half_log_det_vstar_maps_store;
      half_log_det_vstar_maps_store = 0;
      half_log_det_vstars_store = 0;
   }
   delete [] half_log_det_vstar_maps;
   if( vstar_working )
      gsl_matrix_free( vstar_working );
   V_star = 0;
}

void GLM_MVN_Clustering::initialise_glm_mvn_clustering()
{
   int i, j;
   Cluster_GLM_MVN::set_Rptr( this );
   kill_the_parent = 1;
   executing_move_subjects = 0;
   model_weight = 1;
   number_misclassified = 0;
   number_classified = 0;
   most_mergeable_cluster =most_mergeable_clusters_closest = NULL;
   most_mergeable_cluster_size = most_mergeable_clusters_closest_size = 0;
   utility_cluster_pointer = utility_cluster_pointer2 = NULL;
   utility_contribution = 0;
   current_ytd_vstar_dty_sum = 0;
   proposed_ytd_vstar_dty_sum = 0;
   closeness_contributions_store = 0;
   baseline_configuration_log_likelihood = 0;
   number_of_cluster_types = 0;
   mcmc_sampling = false;
   move_single_subjects_in_mcmc = 1;
   if( preserve_tree )
      gibbs_two_mean_separation = 0;
   cascade_from_cluster_in_model = 0;
   splitting_to_optimal = false;
   recalculate_whilst_splitting_to_optimal = false;
   membership_probability = 0;
   membership_probability_dim = 0;
   map_memberships = 0;
   membership_contributions = 0;
   membership_contribution_dim = num_subjects;
   max_log_probs = 0;
   probsums = 0;
   number_not_in_map_membership = 0;
   automatically_calculate_residuals = false;
   find_parameter_values = false;
   effective_num_exps = num_experiments;
   if( correlate_experiments || correlate_columns )
      effective_num_exps = dim_V / num_design_cols;
   dim_num_obsns = effective_num_exps;
   create_posterior_parameter_matrices();
   num_obsns_working = gsl_matrix_int_calloc( 1, dim_num_obsns  );
   if( !heteroskedastic )
      num_obsns_working2 = gsl_matrix_int_calloc( 1, dim_num_obsns );
   create_working_sufficient_statistic_matrices();
   max_log_likelihood = -DBL_MAX;
   max_BIC = -DBL_MAX;
   current_vstar_index = -INT_MAX;
   current_hldv_index = -INT_MAX;
   if( non_conjugate_model && !heteroskedastic )
      heteroskedastic = 1;
   if( p_y > 1 )
      heteroskedastic = 1;
   if( !heteroskedastic && !average_complete_single_link )
      storing_cluster_closenesses = 0;//no point retaining, as change after each merge/split
   if( heteroskedastic != 1 || !treat_experiments_as_different_dimensions )
      experiment_vote = num_experiments;
   if( heteroskedastic == 1 )
   {
      if( treat_experiments_as_different_dimensions )
      {
         a_star_vector = new double[ num_experiments ];
         b_star_vector = new double[ num_experiments ];
         if( experiment_vote < num_experiments )
         {
            a_star_vector1 = new double[ num_experiments ];
            b_star_vector1 = new double[ num_experiments ];
            error_prior_contribution_differences = new double[ num_experiments ];
            error_prior_contribution_difference_ranks = new int[ num_experiments ];
	    create_array( log_vote_probs, num_experiments, 2 );
            zero_vote_prob = new bool[ num_experiments ];
	    for( i = 0; i < num_experiments; i++ )
            {
	       log_vote_probs[ i ][ 0 ] = log_vote_probs[ i ][ 1 ] = -LOG_TWO;
               zero_vote_prob[ i ] = false;
            }
         }
         if( experiment_vote == 0 )//use this setting if choosing number of votes dynamically
            experiment_vote = num_experiments;
      }
   }
   if( euclidean_or_correlation_clustering == 2 )
      euclidean_not_correlation = false;
   if( !inputs_repeated_every )
      storing_non_conjugate_precision_matrices = 0;
   keep_vstars = 0;
   bool all_or_none_missing = !diagonal_vstar;
   currently_diagonal_vstar = diagonal_vstar;
   if( gram_schmidt )
      keep_vstars = 0;
   else
      if( inputs_repeated_every && !non_conjugate_model )
      {
         if( !missing_values && !random_effect_variances )//&& !random_effects_model )
            keep_vstars = 1;
         else
            keep_vstars = 3;//2;
      }
   if( check_at_each_max_map_allocation_sweeps > 0 && !max_map_allocation_sweeps )
      max_map_allocation_sweeps = check_at_each_max_map_allocation_sweeps;
   else if( check_allocations_at_each_merger && !check_at_each_max_map_allocation_sweeps )
      check_at_each_max_map_allocation_sweeps = max_map_allocation_sweeps;
   if( !strlen( Cluster_Output_Filename ) )
   {
      char* new_file = Cluster_Output_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_clusters_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Means_Filename ) )
   {
      char* new_file = Cluster_Means_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_means_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Cov_Filename ) )
   {
      char* new_file = Cluster_Cov_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_covs_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Variance_Filename ) )
   {
      char* new_file = Cluster_Variance_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_vars_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Sizes_Filename ) )
   {
      char* new_file = Cluster_Sizes_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_sizes_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Subjects_Filename ) )
   {
      char* new_file = Cluster_Subjects_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_subjects_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Labels_Filename ) && strlen( Subject_Labels_Filename ) )
   {
      char* new_file = Cluster_Labels_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_labels_";
      insert_in_string_before_dot( new_file, &insert );
   }
       
   if( !strlen( Dendrogram_Output_Filename ) )
   {
      char* new_file = Dendrogram_Output_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_dendro_output_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Dendrogram_Scores_Filename ) )
   {
      char* new_file = Dendrogram_Scores_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_dendrogram_scores_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Merger_Details_Filename ) )
   {
      char* new_file = Merger_Details_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_mergerdetails_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Bare_Merger_Details_Filename ) )
   {
      char* new_file = Bare_Merger_Details_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_baremergerdetails_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Partition_Output_Filename ) )
   {
      char* new_file = Partition_Output_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_partition_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( All_Partitions_Output_Filename ) )
   {
      char* new_file = All_Partitions_Output_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_all_partitions_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Residuals_Filename ) )
   {
      char* new_file = Residuals_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_residuals_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Missing_Values_Filename ) && missing_values )
   {
      char* new_file = Cluster_Missing_Values_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_missing_values_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Missing_Value_Predictions_Filename ) && missing_values )
   {
      char* new_file = Missing_Value_Predictions_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_missing_value_predictions_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( !strlen( Cluster_Error_Covariances_Filename ) )
   {
      char* new_file = Cluster_Error_Covariances_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_error_covariances_";
      insert_in_string_before_dot( new_file, &insert );
   }
   if( max_map_allocation_sweeps > 0 && !strlen( Subject_Misallocation_History_Filename ) )
   {
      char* new_file = Subject_Misallocation_History_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_misallocation_history_";
      insert_in_string_before_dot( new_file, &insert );
      remove( Subject_Misallocation_History_Filename );
   }
   if( error_prior_contribution_differences && !strlen( Votes_Filename ) )
   {
      char* new_file = Votes_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_votes_";
      insert_in_string_before_dot( new_file, &insert );
      remove( Votes_Filename );
   }
   if( (nn_constraint || singletons_require_best_friend) && !strlen( Single_Subject_Nearest_Neighbour_Filename ) )
   {
      char* new_file = Single_Subject_Nearest_Neighbour_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_subject_nearest_neighbours_";
      insert_in_string_before_dot( new_file, &insert );
      remove( Single_Subject_Nearest_Neighbour_Filename );
   }
   if( nn_constraint && !strlen( NN_equivalence_relation_partition_Filename ) )
   {
      char* new_file = NN_equivalence_relation_partition_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_nn_equivalence_relation_partition_";
      insert_in_string_before_dot( new_file, &insert );
      remove( NN_equivalence_relation_partition_Filename );
   }
   if( !strlen( Cluster_Nearest_Neighbour_Filename ) )
   {
      char* new_file = Cluster_Nearest_Neighbour_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_nearest_neighbours_";
      insert_in_string_before_dot( new_file, &insert );
      remove( Cluster_Nearest_Neighbour_Filename );
   }
   if( !strlen( Cluster_Closeness_Filename ) )
   {
      char* new_file = Cluster_Closeness_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_cluster_closeness_";
      insert_in_string_before_dot( new_file, &insert );
      remove( Cluster_Closeness_Filename );
   }
   if( !strlen( Subjects_First_Merge_Filename ) && store_when_subjects_first_merge )
   {
      char* new_file = Subjects_First_Merge_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_subjects_first_merge_";
      insert_in_string_before_dot( new_file, &insert );
      remove( Subjects_First_Merge_Filename );
   }
   if( timing_agglomerative_clustering )
   {
      if( !strlen( Agglomerative_Timing_Filename ) )
      {
         char* new_file = Agglomerative_Timing_Filename;
         strcpy( new_file, TargetFilename );
         string insert = "_agglomerative_timing_";
         insert_in_string_before_dot( new_file, &insert );
         remove( Agglomerative_Timing_Filename );
      }
      TimingStream.open( Agglomerative_Timing_Filename, ios::out );
   }
   
   if( log_vote_probs && strlen( Vote_Probabilities_Filename ) )
   {
      scan_array_data( Vote_Probabilities_Filename, log_vote_probs, num_experiments, 1 );// note we are pretending the mx only has one column for reading in.
      for( i = 0; i < num_experiments; i++ )
      {
	 double vote_prob_i = log_vote_probs[ i ][ 0 ];
	 log_vote_probs[ i ][ 0 ] = log_vote_probs[ i ][ 1 ] = -DBL_MAX;
	 if( vote_prob_i > 0 )
	   log_vote_probs[ i ][ 0 ] = log( vote_prob_i );
         else
            zero_vote_prob[ i ] = true;
	 if( vote_prob_i < 1 )
	   log_vote_probs[ i ][ 1 ] = log( 1 - vote_prob_i );
      }
   }

   
   if( strlen( Association_Matrix_Filename ) )
   {
      association_matrix = new double*[ num_subjects ];
      for( i = 0; i < num_subjects; i++ )
      {
         association_matrix[ i ] = new double[ num_subjects ];
         for( j = 0; j < num_subjects; j++ )
            if( i != j )
               association_matrix[ i ][ j ] = 0;
            else
               association_matrix[ i ][ j ] = 1;
      }
   }
   if( strlen( Membership_Probability_Filename ) || max_map_allocation_sweeps > 0 )
       membership_probabilities_required = true;
   else
       variable_dimension_allocation_sweeps = false;
   if( membership_probabilities_required && !strlen( Misallocated_Subject_Filename ) )
   {
      char* new_file = Misallocated_Subject_Filename;
      strcpy( new_file, TargetFilename );
      string insert = "_subjects_misallocated_";
      insert_in_string_before_dot( new_file, &insert );
      remove( Misallocated_Subject_Filename );
   }
   if( variable_dimension_allocation_sweeps )// && max_map_allocation_sweeps > 0 )
   {
      single_subject_closeness_contributions = new double[ num_subjects ];
      if( !heteroskedastic )
         single_subject_hldvs = new double[ num_subjects ];
   }
   if( max_map_allocation_sweeps == 0 )
      check_allocations_at_each_merger = false;
//   if( !one_reallocation_per_sweep )
//      reallocate_worst_each_sweep = 0;
//   else
//      merge_after_each_sweep = false;
   originally_check_allocations_at_each_merger = check_allocations_at_each_merger;
   if( check_allocations_at_each_merger )
      retain_singleton_clusters = true;
   if( max_map_allocation_sweeps > 0 )
      subject_ever_reallocated = new bool[ num_subjects ];;
   if( try_best_singletons > num_subjects || try_best_singletons < 0 )
      try_best_singletons = num_subjects;
   originally_heller_algorithm = heller_algorithm;
   if( heller_algorithm )
      heller_d = log_heller_dirichlet_alpha = log( heller_dirichlet_alpha );
   m_star_exp = 0;
   int *input_partition = 0, *partition_smallest_subjects = 0;
   map< int, Cluster_GLM_MVN* > input_partition_map;
   if( strlen( Partition_Input_Filename ) )
   {
      int number_of_sets = -INT_MAX;
      gsl_matrix_int* partition_mx = scan_integer_data( Partition_Input_Filename );
      int partition_size = partition_mx->size1;
      input_partition = new int[ partition_size ];
      for( i = 0; i < partition_size; i++ )
      {
         int set_number = gsl_matrix_int_get( partition_mx, i, 0 );
         if( set_number > number_of_sets )
            number_of_sets = set_number;
      }
      partition_smallest_subjects = new int[ number_of_sets + 1 ];
      for( i = partition_size - 1; i >= 0; i-- )
         partition_smallest_subjects[ gsl_matrix_int_get( partition_mx, i, 0 ) ] = i;
      for( i = 0; i < partition_size; i++ )
         input_partition[ i ] = partition_smallest_subjects[ gsl_matrix_int_get( partition_mx, i, 0 ) ];
      gsl_matrix_int_free( partition_mx );
      delete [] partition_smallest_subjects;

   }
   else if( num_subjects > 100000 )
      storing_cluster_closenesses = 0;
   storing_cluster_closenesses_store = storing_cluster_closenesses;
   if( storing_cluster_closenesses )
   {
      create_closeness_matrix();
      if( store_when_subjects_first_merge )
      {
//       create_triangular_array( subjects_first_merge, num_subjects );
         subjects_first_merge = new int*[num_subjects];
         subjects_first_merge[0] = 0;
         for( i = 1; i < num_subjects; i++ )
            subjects_first_merge[i] = new int[i];
      }
   }
   if( storing_cluster_closenesses == false )
      reduce_closeness_matrix = false;
   reduce_closeness_matrix_store = reduce_closeness_matrix;
   if( check_allocations_at_each_merger )
      reduce_closeness_matrix = false;

   number_unmergeable += (num_data_blocks - regression_num_data_blocks) / num_data_block_sizes;

   num_mergeable_subjects = regression_num_subjects; // every subject_grouping observations assumed from the same subject and so forced to be clustered together.
   bool* index_mergeable = get_mergeable_indices();

   if( inputs_repeated_every )
      gsl_matrix_scale( D_sq, (double)( inputs_repeated_every * ( correlate_experiments && !data_block_sizes ? num_experiments : 1 ) )/(double)( regression_n ) );

   if( weight_experiments )
      weight_the_experiments();

   if( !missing_values || delete_missing )
   {
      weight_by_missing_values = false;
      no_optimal_clusters_totally_missing_experiments = false;
   }

   if( ( num_experiments == 1 && !treat_experiments_as_different_dimensions ) || !inputs_repeated_every || !weight_by_missing_values )
      subject_experiment_weights = false;

   if( !heteroskedastic )
      exclude_singleton_clusters = uniform_background;// = false;
   if( uniform_background )
   {
      singleton_clusters_uniformly_distributed = true;
      if( print_to_screen )
         cout << "Singleton clusters assumed to be from a background Uniform distribution" << endl;
      log_nonbackground_penalty = log( 1 - background_prob ) - log( background_prob );
      background_correction = -log_nonbackground_penalty + ave_data_block_size * (p_y * LOG_SQRT_PI - log_y_range_product );
      if( heteroskedastic )
         background_correction -= lambda_prior_normalising_constant;
      background_random_effect_correction = 0;
   }

   vstar_maps = new mx_numtoptr*[ number_of_vs ];
   for( i = 0; i < number_of_vs; i++ )
      vstar_maps[ i ] = new mx_numtoptr;
   vstar_map = vstar_maps[ 0 ];
   vstar_maps_store = 0;
   vstar_map_store = 0;
   half_log_det_vstar_maps = new inttodbl*[ number_of_vs ];
   for( i = 0; i < number_of_vs; i++ )
      half_log_det_vstar_maps[ i ] = new inttodbl;
   half_log_det_vstars = half_log_det_vstar_maps[ 0 ];
   half_log_det_vstar_maps_store = 0;
   half_log_det_vstars_store = 0;
   // create the V* matrices for each n, and their determinants and the log(Gamma(a_+n/2)) values.
   int dim_a_star = 1;
   if( heteroskedastic )
      dim_a_star += n;//num_data_blocks;
   else if( exclude_singleton_clusters )
      dim_a_star += num_subjects;
   a_star_lookup = new double[ dim_a_star ];
   ln_gamma_a_star_lookup = new double[ dim_a_star ];
   a_star_lookup[ 0 ] = ln_gamma_a_star_lookup[ 0 ] = 0;
   if( a_star_vector1 )
   {
      a_star_lookup1 = new double[ dim_a_star ];
      ln_gamma_a_star_lookup1 = new double[ dim_a_star ];
      a_star_lookup1[ 0 ] = ln_gamma_a_star_lookup1[ 0 ] = 0;
   }
   log_prior_num_clusters = new double[ num_data_blocks + 1 ];
   log_prior_cluster_size = new double[ num_data_blocks + 1 ];
   log_gamma_dirichlet_parameter = log_dirichlet_parameter = 0;
   double log_dp_normalizing_const = 0;
   if( dirichlet_parameter > 0 )
   {
      log_dirichlet_parameter = log( dirichlet_parameter );
      log_gamma_dirichlet_parameter = gsl_sf_lngamma( dirichlet_parameter );
      log_dp_normalizing_const = log_gamma_dirichlet_parameter - gsl_sf_lngamma( regression_num_subjects + dirichlet_parameter );
   }
   bool mdprior_on_sizes_minus_one = false;
   double log_num_subjects = log( (double)regression_num_subjects );
   double log_fact_i = 0, log_gamma_i = 0, log_gamma_q = 0;
   if( p_y > 1 )
      log_gamma_q = .25 * p_y * ( p_y - 1 ) * LOG_PI;

   for( i = 1; i <= num_data_blocks; i++ )
   {
//       if( keep_vstars )
//       {
// 	 int d = !correlate_experiments ? i : i * num_experiments;
//          matrix *temp_mx = new matrix( *get_vstar( d ) );
//          (*vstar_map)[ d ] = temp_mx;
//          double hlvs = get_half_log_det_vstar( d );
//          (*half_log_det_vstars)[ d ] = hlvs;
//       }
      if( dirichlet_parameter > 0 )
      {
          log_gamma_i = log_fact_i;
          if( i > 1 )
             log_fact_i += log( (double)i );
         if( dirichlet_process )
         {
            log_prior_num_clusters[ i ] = i * log_dirichlet_parameter + log_dp_normalizing_const;
            log_prior_cluster_size[ i ] = log_gamma_i;
         }
         else
         {
            if( !mdprior_on_sizes_minus_one )
            {
               log_prior_num_clusters[ i ] = gsl_sf_lngamma( i * dirichlet_parameter ) - i * log_gamma_dirichlet_parameter - gsl_sf_lngamma( i * dirichlet_parameter + regression_num_subjects ) - log_num_subjects + log_fact_i;
               log_prior_cluster_size[ i ] = gsl_sf_lngamma( dirichlet_parameter + i );
            }
            else
            {
               log_prior_num_clusters[ i ] = gsl_sf_lngamma( i * dirichlet_parameter ) - i * log_gamma_dirichlet_parameter - gsl_sf_lngamma( i * dirichlet_parameter + regression_num_subjects - i ) - log_num_subjects + log_fact_i;
               log_prior_cluster_size[ i ] = gsl_sf_lngamma( dirichlet_parameter + i - 1 );
            }
         }
      }
      else
         log_prior_num_clusters[ i ] = log_prior_cluster_size[ i ] = 0;
      if( heteroskedastic == 1 )
         log_prior_num_clusters[ i ] += i * lambda_prior_normalising_constant * num_experiments;
      else if( heteroskedastic == 2 )
         log_prior_num_clusters[ i ] += i * lambda_prior_normalising_constant;
      else if( !heteroskedastic )
         log_prior_num_clusters[ i ] += lambda_prior_normalising_constant;
   }
   if( !heteroskedastic && exclude_singleton_clusters )
      log_prior_num_clusters[ num_subjects ] -= lambda_prior_normalising_constant;
   singleton_merge_prior_change = log_prior_cluster_size[ 2 ] - 2 * log_prior_cluster_size[ 1 ];

   if( non_conjugate_model )
   {
      gsl_matrix *temp_dvdt = 0;
      if( !V_ )
      {
         V_ = gsl_matrix_alloc( dim_V, dim_V );
         my_invert( V_inv, V_ );
      }
      if( inputs_repeated_every && ( !C1 || inputs_repeated_every == (int)C1->size1 ) )
      {
         gsl_matrix* D_single = gsl_matrix_alloc( inputs_repeated_every, num_design_cols );
         for( i = 0; i < inputs_repeated_every; i++ )
            for( j = 0; j < num_design_cols; j++ )
               gsl_matrix_set( D_single, i, j, gsl_matrix_get( !C1D ? D : C1D, i, j ) );
         if( correlate_experiments )
            matrix_block( D_single, num_experiments );
         gsl_matrix_multiply( temp_dvdt, D_single, V_, D_single, true );
         gsl_matrix_free( D_single );
      }
      (*vstar_map)[ 0 ] = temp_dvdt;
   }

   if( non_conjugate_model && number_of_vs == 1 )
      ml_const -= 0.5 * p_y * ( V_inv ? my_lndet( V_inv ) : -dim_V * log( v_multiplier ) );//subtract this bit off again

   double dummy_closeness = -DBL_MAX;
   NOBs = new int*[ num_subjects ];
   for( i = 0; i < num_subjects; i++ )
   {
      NOBs[ i ] = new int[ dim_num_obsns  + 1 ];
      for( j = 0; j < dim_num_obsns ; j++ )
         NOBs[ i ][ j ] = 0;
   }
   int py_num_subjects = p_y * num_subjects;
   if( yty_cols )
      create_zeroed_array( YTYs, py_num_subjects, yty_cols );
   if( ytd_cols )
      create_zeroed_array( YTDs, py_num_subjects, ytd_cols );
   if( !inputs_repeated_every )
   {
      int nd_num_subjects = num_design_cols * num_subjects;
      create_zeroed_array( DTDs, nd_num_subjects, dtd_cols );
   }
   if( non_conjugate_model )
      create_zeroed_array( YTDVDTYs, py_num_subjects, py_num_subjects * num_experiments );
   if( random_effects_model )
      create_zeroed_array( Y_totals, num_subjects, p_y );

   ifstream LabelFileStream( Subject_Labels_Filename, ios::in );//Only needed if we have labels
   if( !LabelFileStream )
      cluster_by_labels = 0;
   char st[20000];//Only needed if we have labels
   num_obsns_total= 0;
   int ii, i0;
   int total_num_missing = 0, total_num_missing_ii = 0, number_missing = 0;
   int* num_missing = 0;
   if( weight_by_missing_values )
      create_zeroed_array( num_missing, dim_num_obsns );
   double wt_ii_sq = 1;
   for( ii = 0; ii < num_subjects; ii++ )
   {
      int py_ii = p_y * ii;
      int start = get_subject_index( ii );
      int end = get_subject_index( ii + 1 );
      num_obsns_total += end - start;
      int row_counter = start * data_block_sizes_sum / num_data_block_sizes;
      if( num_missing )
      {
         total_num_missing_ii = 0;
         for( int exp_num = 0; exp_num < num_experiments; exp_num++ )
         {
            number_missing = subject_exp_num_missing_values[ ii ][ exp_num ];
            if( all_or_none_missing && number_missing < data_block_size )
               number_missing = 0;
            num_missing[ exp_num ] = number_missing;
            total_num_missing_ii += number_missing;
         }
// 	 int row_counter2 = row_counter;
//          for( int i0 = start; i0 < end; i0++ )
//          {
//             int exp_num = get_experiment_number( i0 );
//             number_missing = 0;
//             for( i = row_counter2; i < row_counter2 + data_block_size; i++ )
//                for( j = 0; j < p_y; j++ )
//                   if( missing_values[ i ][ j ] )
// 		     number_missing++;
// 	    row_counter2 += data_block_size;
// 	    if( all_or_none_missing && number_missing < data_block_size )
// 	       number_missing = 0;
//             num_missing[ exp_num ] = number_missing;
//             total_num_missing_ii += number_missing;
//          }
         if( !subject_experiment_weights )
            wt_ii_sq = (double)( data_block_sizes_sum - total_num_missing_ii ) / data_block_sizes_sum;
	 total_num_missing += total_num_missing_ii;
      }
      for( i0 = start; i0 < end; i0++ )
      {
         int exp_num = get_experiment_number( i0 );
	 //	 if( !gsl_matrix_int_get( num_obsns_working, 0, 1 ) ){ cout << "********" << cl->get_smallest_subject_allocated() << " " << cl2 <<  endl;
	 //	   print_gsl_matrix( dtd_working );cout << "****#****" << endl;}

         NOBs[ ii ][ exp_num ] += data_block_size;
         if( num_missing )
	 {
	    number_missing = num_missing[ exp_num ];
            NOBs[ ii ][ exp_num ] -= number_missing;
	    if( subject_experiment_weights )
	       wt_ii_sq = (double)( data_block_size - number_missing ) / data_block_size;
	 }

         if( YTYs )
         for( int j1 = 0; j1 < p_y; j1++ )
            for( int j2 = 0; j2 < p_y; j2++ )
            {
               for( i = row_counter; i < row_counter + data_block_size; i++ )
                  YTYs[ j1 + py_ii ][ j2 + p_y * exp_num ] += gsl_matrix_get( !C1Y ? Y : C1Y, i, j1 ) * gsl_matrix_get( !C1Y ? Y : C1Y, i, j2 ) * wt_ii_sq;
               if( non_conjugate_model && inputs_repeated_every )
                  for( int iii = 0; iii < num_subjects; iii++ )
                     for( i = row_counter; i < row_counter + data_block_size; i++ )
                        for( int i_ = i0 * data_block_size; i_ < (i0+1) * data_block_size; i_++ )
                           YTDVDTYs[ j1 + py_ii ][ j2 + p_y *iii + py_num_subjects * exp_num ] += gsl_matrix_get( !C1Y ? Y : C1Y, i, j1 ) * gsl_matrix_get( (*vstar_map)[ 0 ], i - row_counter, i_ - row_counter ) * gsl_matrix_get( !C1Y ? Y : C1Y, i_, j2 ) * wt_ii_sq;
            }
         if( treat_experiments_as_different_dimensions )
            exp_num = 0;
         if( YTDs )
         for( int design_col = 0; design_col < num_design_cols; design_col++ )
            for( i = row_counter; i < row_counter + data_block_size; i++ )
            {
               for( j = 0; j < p_y; j++ )
                  YTDs[ j + py_ii ][ exp_num * num_design_cols + design_col ] += gsl_matrix_get( !C1Y ? Y : C1Y, i, j ) * gsl_matrix_get( !C1D ? D : C1D, i, design_col ) * wt_ii_sq;
               if( !inputs_repeated_every )
                  for( j = 0; j < num_design_cols; j++ )
                     DTDs[ ii * num_design_cols + j ][ exp_num * num_design_cols + design_col ] += gsl_matrix_get( !C1D ? D : C1D, i, j ) * gsl_matrix_get( !C1D ? D : C1D, i, design_col ) * wt_ii_sq;
            }
         if( random_effects_model )
            for( i = row_counter; i < row_counter + data_block_size; i++ )
               for( j = 0; j < p_y; j++ )
                  Y_totals[ ii ][ j ] += gsl_matrix_get( !C1Y ? Y : C1Y, i, j );
         row_counter += data_block_size;
      }

      if( LabelFileStream && !LabelFileStream.eof() )
      {
         LabelFileStream.getline(st,20000);
         string temp_label( st );
         if( temp_label.size() )
         {
            str_to_int::iterator labels_iter =labels.find( temp_label );
            if( labels_iter == labels.end() )
               labels[ temp_label ] = end - start;
            else
               labels_iter->second += end - start;
         }
      }
   }
   if( num_missing )
   {
      delete [] num_missing;
      if( print_to_screen )
	 cout << "Weighting subject observations in consideration of " << total_num_missing << " missing observations." << endl;
   }
   
   double ytysum = 0;
   if(yty_cols)
   for( i = 0; i < num_subjects; i++ )
      for( j = 0; j < yty_cols; j++ )
         ytysum += YTYs[ i ][ j ];
   proposed_yty_total = yty_total = b_ + 0.5 * ytysum;

 //   if( non_conjugate_model )
   {
      log_likelihood_constant = - ( regression_n - total_num_missing ) * p_y * LOG_SQRT_PI;
      if( normalise_targets )
         log_likelihood_constant -= ( regression_n - total_num_missing ) * p_y * log_ave_y_scale;
      if( standardize_experiments )
         log_likelihood_constant -= ( regression_n - total_num_missing ) * p_y * log_ave_experiments_sds;
   }

   if( !heteroskedastic )
   {
      a_star = a_star_lookup[ 0 ] = a_ + 0.5 * regression_n * p_y;
      ln_gamma_a_star_lookup[ 0 ] = gsl_sf_lngamma( a_star_lookup[ 0 ] );
      if( exclude_singleton_clusters )
      {
         for( i = 0; i <= num_subjects; i++ )
         {
            a_star_lookup[ i ] = a_ + 0.5 * i * data_block_sizes_sum * p_y;
            ln_gamma_a_star_lookup[ i ] = gsl_sf_lngamma( a_star_lookup[ i ] );
         }
      }
   }
   else
      for( i = 0; i <= n; i++ )
      {
         if( p_y == 1 )
            a_star_lookup[ i ] = a_ + 0.5 * i;//( i * ave_data_block_size );
         else
            a_star_lookup[ i ] = 0.5 * ( a_ + p_y - 1 + i );// * ave_data_block_size );
         ln_gamma_a_star_lookup[ i ] = gsl_sf_lngamma( a_star_lookup[ i ] ) + log_gamma_q;
         for( j = 1; j < p_y; j++ )
            ln_gamma_a_star_lookup[ i ] += gsl_sf_lngamma( a_star_lookup[ i ] - .5 * j );
         if( a_star_lookup1 )
         {
            if( p_y == 1 )
               a_star_lookup1[ i ] = a_1 + 0.5 * i;//( i * ave_data_block_size );
            else
               a_star_lookup1[ i ] = 0.5 * ( a_1 + p_y - 1 + i );// * ave_data_block_size );
            ln_gamma_a_star_lookup1[ i ] = gsl_sf_lngamma( a_star_lookup1[ i ] ) + log_gamma_q;
            for( j = 1; j < p_y; j++ )
               ln_gamma_a_star_lookup1[ i ] += gsl_sf_lngamma( a_star_lookup1[ i ] - .5 * j );
         }
      }


   if( LabelFileStream )
      subject_labels = new string[ num_subjects ];
   LabelFileStream.clear();
   LabelFileStream.seekg( 0 );
   bool temp_mergeable = true;
   if( retain_singleton_clusters )
      single_subject_cluster_ptrs = new Cluster_GLM_MVN*[ num_subjects ];
   for( ii = 0; ii < num_subjects; ii++ )
   {
      if( index_mergeable )
         temp_mergeable = index_mergeable[ ii ];
      Cluster_GLM_MVN* new_cluster;
      if( !LabelFileStream || LabelFileStream.eof() )
         new_cluster = make_cluster_containing_subject( ii, temp_mergeable );
      else
      {
         LabelFileStream.getline(st,20000);
         string temp_label( st );
	 subject_labels[ ii ] = temp_label;
//         if( (!subject_labels || cluster_by_labels) && temp_label.size() )
         if( cluster_by_labels && temp_label.size() )
            new_cluster = make_cluster_containing_subject( ii, temp_mergeable, &temp_label );
         else
            new_cluster = make_cluster_containing_subject( ii, temp_mergeable );
      }
      if( retain_singleton_clusters )
	 single_subject_cluster_ptrs[ ii ] = make_cluster_containing_subject( ii, true );
      if( ( preserve_tree && temp_mergeable ) || strlen( Single_Subject_Contributions_Filename ) )
         single_subject_clusters.push_back( new_cluster );
      if( !temp_mergeable )
      {
         unmergeable_cluster_deque.push_back( new_cluster );
         for( str_to_int::iterator iter0=labels.begin(); iter0 != labels.end(); ++iter0 )
         {
            pair< Cluster_GLM_MVN*, string > clstr_pair( new_cluster, (iter0->first) );
            cluster_and_label_probability[ clstr_pair ] = 0;
         }
      }
      if( single_subject_closeness_contributions )
      {
         single_subject_closeness_contributions[ ii ] = calculate_closeness_contribution( new_cluster );
         new_cluster->set_closeness_contribution( single_subject_closeness_contributions[ ii ] );
         if( !heteroskedastic )
            single_subject_hldvs[ ii ] = current_hlvs + ml_const;
      }
      if( !input_partition )// start each subject in its own cluster.
         cluster_map.insert( cluster_ptrtodbl::value_type( new_cluster, dummy_closeness ) );//dummy values for 'best closeness' for now, will enter them when all clusters have been created.
      else
      {
         if( ii == input_partition[ ii ] )
         {
            cluster_map.insert( cluster_ptrtodbl::value_type( new_cluster, dummy_closeness ) );
            input_partition_map[ ii ] = new_cluster;
         }
         else
         {
            Cluster_GLM_MVN* cl = input_partition_map[ input_partition[ ii ] ];
            if( !preserve_tree )
               cl->merge_cluster( new_cluster, false );
            else
            {
               cluster_map.erase( cl );
               cl = cl->merge_cluster( new_cluster, false );
               input_partition_map[ input_partition[ ii ] ] = cl;
               cluster_map.insert( cluster_ptrtodbl::value_type( cl, dummy_closeness ) );
            }
         }
      }
   }

   zap_vector( index_mergeable );
   if( input_partition )
   {
      delete [] input_partition;
      if( preserve_tree )
      {
         calculate_single_subject_cluster_closeness_contributions();
         for( map< int, Cluster_GLM_MVN* >::iterator iter = input_partition_map.begin(); iter != input_partition_map.end(); ++iter )
         {
            Cluster_GLM_MVN* cl = iter->second;
            rebuild_agglomerative_tree_from_cluster( cl, true );
         }
      }
      if( merge_through_input_partition )
      {
         give_clusters_different_types();
         restart_subjects_in_own_clusters();
      }
   }

   mean_cluster_and_label_probability = cluster_and_label_probability;

   int surrogate_num_distinct = number_distinct;
   if( cluster_by_labels )
      surrogate_num_distinct += labels.size();
   if( !surrogate_num_distinct )
      surrogate_num_distinct = 1;
   minimum_num_clusters += number_unmergeable;
   if( minimum_num_clusters - number_unmergeable < surrogate_num_distinct )
      minimum_num_clusters = number_unmergeable + surrogate_num_distinct;

   merger_details_rows_original = merger_details_rows = num_subjects - minimum_num_clusters + 1;
   merger_details_cols = md_write_smallest_subjects? 5 : 7;
   create_zeroed_array( merger_details, merger_details_rows, merger_details_cols );
   best_merger_details = 0;
   input_merger_details = 0;
   if( strlen( Input_Merger_Details_Filename ) )
   {
      ifstream InputMergerDetailsStream( Input_Merger_Details_Filename, ios::in );
      scan_array_data( InputMergerDetailsStream, input_merger_details, merger_details_rows_original - 1, 4 );
   }

   dendrogram = 0;
   best_dendrogram = 0;
   inverse_dendrogram = 0;
   dendrogram_scores = 0;
   
   if( strlen(Residuals_Filename) && missing_values )
      calculate_error_covariances = true;

   if( calculate_error_covariances )
      calculate_global_error_covariances();

   int num_labels = labels.size();
   if( num_labels != num_subjects && num_labels < 50 )
      for( str_to_int::iterator iter0 = labels.begin(); iter0 != labels.end(); ++iter0 )
         cout << (iter0->first) << ",  " << (iter0->second) << " observations" << endl;

   if( print_to_screen )
   {
      cout << num_subjects << " subjects to cluster";
      if( num_experiments > 1 )
         cout << ", across " << num_experiments << " experiments";
      cout << "." << endl;
   }

   number_of_models_evaluated -= (int)cluster_map.size() - 1;//as each cluster will be counted as one model when this partition is evaluated.

   //Note: Still need to calculate closeness of each cluster to the others before doing clustering.
}

void GLM_MVN_Clustering::create_closeness_matrix( double** copy_source )
{
   closeness_matrix = new double* [ num_subjects ];
   closeness_matrix[ 0 ] = 0;
   for( int i = 1; i < num_subjects; i++ )
   {
      closeness_matrix[ i ] = new double[ i ];
      for( int j = 0; j < i; j++ )
          closeness_matrix[ i ][ j ] = copy_source ? copy_source[ i ][ j ] : -DBL_MAX;
   }
}

void GLM_MVN_Clustering::create_working_sufficient_statistic_matrices()
{
//   yty_cols = p_y * num_experiments;
   if( yty_cols )
      yty_working = gsl_matrix_alloc( p_y, yty_cols );
   if( yty_cols )
      ytd_working = gsl_matrix_alloc( p_y, ytd_cols );
   dtd_cols = ytd_cols;
   if( !inputs_repeated_every & dtd_cols )
      dtd_working = gsl_matrix_alloc( num_design_cols, dtd_cols );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::make_cluster_containing_subject( int subject_num, bool temp_mergeable, string* temp_label )
{
   bool temp_distinct = 0;
   if( subject_num < number_distinct )
      temp_distinct = 1;

   list<int> temp_list;
   temp_list.push_back( subject_num );
   int i, j;
   for( j = 0; j < dim_num_obsns; j++ )
      gsl_matrix_int_set( num_obsns_working, 0, j, NOBs[ subject_num ][ j ] );
   for( i = 0; i < p_y; i++ )
   {
      if(yty_cols)
      for( j = 0; j < yty_cols; j++ )
         gsl_matrix_set( yty_working, i, j, YTYs[ i + p_y * subject_num ][ j ] );
      if(ytd_cols)
      for( j = 0; j < ytd_cols; j++ )
         gsl_matrix_set( ytd_working, i, j, YTDs[ i + p_y * subject_num ][ j ] );//(gets row subject_num if p_y = 1)
   }
   if( !inputs_repeated_every )
      for( i = 0; i < num_design_cols; i++ )
         for( j = 0; j < dtd_cols ; j++ )
            gsl_matrix_set( dtd_working, i, j, DTDs[ subject_num * num_design_cols + i ][ j ] );

   Cluster_GLM_MVN* new_cluster;
   if( !temp_label )
      new_cluster = new Cluster_GLM_MVN( num_obsns_working, yty_working, ytd_working, dtd_working, temp_distinct, temp_mergeable, temp_list, 0 );
   else
      new_cluster = new Cluster_GLM_MVN( num_obsns_working, yty_working, ytd_working, dtd_working, temp_distinct, temp_mergeable, temp_list, 0, *temp_label );
   if( !temp_mergeable )
      new_cluster->set_closeness_contribution( calculate_closeness_contribution( new_cluster ) );
   return new_cluster;
}


bool* GLM_MVN_Clustering::get_mergeable_indices()
{
   if( !number_unmergeable )
      return NULL;
   bool* index_mergeable = new bool[ num_subjects ];
   int i;
   for( i = 0; i < num_subjects; i++ )
      index_mergeable[ i ] = 0;
   if( !randomised_unmergeable )
      for( i = 0; i < num_subjects - number_unmergeable; i++ )
         index_mergeable[ i ] = 1;
   else
   {
      int* indices_mergeable = new int[ num_subjects - number_unmergeable ];
      int* indices = new int[ num_subjects ];
      for( i = 0; i < num_subjects; i++ )
         indices[ i ] = i;
      gsl_ran_choose( rn, indices_mergeable, num_subjects - number_unmergeable, indices, num_subjects, sizeof( int ) );
      for( i = 0; i < num_subjects - number_unmergeable; i++ )
         index_mergeable[ indices_mergeable[ i ] ] = 1;
      delete [] indices;
      delete [] indices_mergeable;
   }
   return index_mergeable;
}

void GLM_MVN_Clustering::restart_subjects_in_own_clusters()
{
   if( preserve_tree )
   {
      cluster_map.clear();
      list<Cluster_GLM_MVN*> root_clusters = Cluster_GLM_MVN::get_root_clusters();
      for( list<Cluster_GLM_MVN*>::iterator iter = root_clusters.begin(); iter != root_clusters.end(); ++iter )
         (*iter)->delete_down_to_subject_clusters();
      for( deque< Cluster_GLM_MVN* >::iterator d_iter = single_subject_clusters.begin(); d_iter != single_subject_clusters.end(); ++d_iter )
	 cluster_map.insert( cluster_ptrtodbl::value_type( *d_iter, -DBL_MAX ) );
   }
   else
   {
      get_subject_cluster_types();
      empty_cluster_map();
      ifstream LabelFileStream( Subject_Labels_Filename, ios::in );//Only needed if we have labels
      char st[20000];//Only needed if we have labels
      bool* index_mergeable = get_mergeable_indices();
      bool temp_mergeable = true;
      if( heller_algorithm )
	 heller_d = log_heller_dirichlet_alpha;
      for( int ii = 0; ii < num_subjects; ii++ )
      {
	 if( index_mergeable )
	    temp_mergeable = index_mergeable[ ii ];
	 Cluster_GLM_MVN* new_cluster;
	 if( !cluster_by_labels || !LabelFileStream || LabelFileStream.eof() )
	    new_cluster = make_cluster_containing_subject( ii, temp_mergeable );
	 else
	 {
	    LabelFileStream.getline(st,20000);
	    string temp_label( st );
	    if( temp_label.size() )
	       new_cluster = make_cluster_containing_subject( ii, temp_mergeable, &temp_label );
	    else
	       new_cluster = make_cluster_containing_subject( ii, temp_mergeable );
	 }
         if( subject_cluster_types )
	 {
            new_cluster->set_type( subject_cluster_types[ ii ] );
	    if( single_subject_cluster_ptrs )
	       single_subject_cluster_ptrs[ ii ]->set_type( subject_cluster_types[ ii ] );
	 }
	 if( !temp_mergeable )
	 {
	    unmergeable_cluster_deque.push_back( new_cluster );
	    for( str_to_int::iterator iter0=labels.begin(); iter0 != labels.end(); ++iter0 )
	    {
	       pair< Cluster_GLM_MVN*, string > clstr_pair( new_cluster, (iter0->first) );
	       cluster_and_label_probability[ clstr_pair ] = 0;
	    }
	 }
         if( single_subject_closeness_contributions )
            new_cluster->set_closeness_contribution( single_subject_closeness_contributions[ ii ] );
	 cluster_map.insert( cluster_ptrtodbl::value_type( new_cluster, -DBL_MAX ) );//dummy values for 'best closeness' for now, will enter them when all clusters have been created.
      }
      zap_vector( index_mergeable );
   }
   initialise_mergeable_cluster_deque();
   if( reduce_closeness_matrix )
      create_closeness_matrix( single_subject_closeness_matrix );
   else if( closeness_matrix )
      for( int i = 1; i < num_subjects; i++ )
         for( int j = 0; j < i; j++ )
            closeness_matrix[ i ][ j ] = single_subject_closeness_matrix ? single_subject_closeness_matrix[i][j] : -DBL_MAX;
   calculate_inter_cluster_closeness();
   calculate_log_likelihood();
   log_likelihood = proposed_log_likelihood;
   if( check_allocations_at_each_merger )
   {
      if( map_memberships )
	 for( int i = 0; i < num_subjects; i++ )
	    map_memberships[ i ] = -2;
      ////      zap_array( membership_contributions, num_subjects, num_subjects + 1 );
   }
}

void GLM_MVN_Clustering::initialise_mergeable_cluster_deque( map< Cluster_GLM_MVN*, double >& map_of_clusters )
{
   /*
     while( mergeable_cluster_deque.begin() != mergeable_cluster_deque.end() )
     mergeable_cluster_deque.pop_back();
     while( unmergeable_cluster_deque.begin() != unmergeable_cluster_deque.end() )
     unmergeable_cluster_deque.pop_back();
   */
   mergeable_cluster_deque.clear();
   cluster_ptrtodbl::iterator iter;
   for( iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
   {
      Cluster_GLM_MVN* cl = iter->first;
      if( cl->get_mergeable() || ( preserve_tree && finished_mcmc_sampling ) )
      {
         if( cl->get_distinct() )
            mergeable_cluster_deque.push_back( cl );
         else
            mergeable_cluster_deque.push_front( cl );
      }
   }
}

void GLM_MVN_Clustering::initialise_mergeable_cluster_deque()
{
   initialise_mergeable_cluster_deque( cluster_map );
}

void GLM_MVN_Clustering::remove_from_all_clusters_deque( Cluster_GLM_MVN* cl )
{
   int num_in_tree = all_clusters_in_tree.size();
   deque< Cluster_GLM_MVN* >::iterator iter;
   int counter = 0;
   bool found_cluster = false;
   while( counter < num_in_tree && !found_cluster )
   {
      iter = all_clusters_in_tree.begin();
      Cluster_GLM_MVN* cl2 = *iter;
      all_clusters_in_tree.pop_front();
      if( cl2 == cl )
         found_cluster = true;
      else
         all_clusters_in_tree.push_back( cl2 );
      counter++;
   }
}

int GLM_MVN_Clustering::get_number_mergeable_in_cluster_map()
{
   int counter = 0;
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( iter->first->get_mergeable() )
         counter++;
   return counter;
}

double GLM_MVN_Clustering::calculate_log_likelihood()
{
   return calculate_log_likelihood( cluster_map );
}

double GLM_MVN_Clustering::calculate_log_likelihood( map< Cluster_GLM_MVN*, double >& map_of_clusters )
{
   double contribution, contribution_sum = 0;
   proposed_number_of_clusters = proposed_number_of_singleton_clusters = 0;
   proposed_log_likelihood = log_likelihood_constant;
   bool singleton_cluster = false;
   if( random_effects_model )
      proposed_log_likelihood -= .5 * sum_log_random_effect_variances;
   proposed_yty_total = b_;

   proposed_BIC = 0;
   for( cluster_ptrtodbl::iterator iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
      if( (iter->first)->get_mergeable() )
      {//need a separate loop here in case !heteroskedastic, meaning we need to know current_ytd_vstar_dty_sum before we can evaluate inter cl8uster closenesses in next loop.
         proposed_number_of_clusters++;
         singleton_cluster = (iter->first)->is_singleton_cluster();
	 if( singleton_cluster )
	    proposed_number_of_singleton_clusters++;
         if( !treat_experiments_separately )
            proposed_BIC -= 0.5 * num_design_cols * log( (double)( regression_n * p_y ) );
         else
            proposed_BIC -= 0.5 * num_design_cols * (iter->first)->get_num_experiments_represented() * log( (double)( regression_n * p_y ) );
         contribution = (iter->first)->get_closeness_contribution();
//         contribution = calculate_closeness_contribution(iter->first);
         contribution_sum += contribution;
         if( !heteroskedastic && !(exclude_singleton_clusters && singleton_cluster) )
         {
            double hldvs = half_log_det_vstar( (iter->first)->get_num_obsns() );//still call this even if !inputs_repeated_every, to get the right number of ml_const's added on.
            if( !inputs_repeated_every )
               hldvs += get_half_lndet_invvinvplusdtd( iter->first );
            proposed_log_likelihood += hldvs;
	    if( exclude_singleton_clusters )
               proposed_yty_total += (iter->first)->get_yty_sum();
         }
         proposed_log_likelihood += log_prior_cluster_size[ (iter->first)->get_num_subjects_allocated() ];
	 if( !heteroskedastic && exclude_singleton_clusters && singleton_cluster && random_effect_variances )
	 {
	    background_random_effect_correction = (random_effect_variances? .5 * random_effect_log_variances[ (iter->first)->get_first_subject_allocated() ] : 0);
	    proposed_log_likelihood += background_random_effect_correction;
	 }
      }
   if( heteroskedastic )
      proposed_log_likelihood += contribution_sum;
   else
   {
      proposed_ytd_vstar_dty_sum = contribution_sum;
      if( !exclude_singleton_clusters )
         proposed_log_likelihood += ln_gamma_a_star_lookup[ 0 ] - a_star_lookup[ 0 ] * log( yty_total - proposed_ytd_vstar_dty_sum );
      else
      {
         proposed_log_likelihood += background_correction * proposed_number_of_singleton_clusters;
         if( !proposed_number_of_singleton_clusters )
            proposed_log_likelihood += ln_gamma_a_star_lookup[ num_subjects - proposed_number_of_singleton_clusters ] - a_star_lookup[ num_subjects - proposed_number_of_singleton_clusters ] * log( proposed_yty_total - proposed_ytd_vstar_dty_sum );
      }
   }
   proposed_log_likelihood += log_prior_num_clusters[ proposed_number_of_clusters ];
   if( !mixture_of_vs && variable_v )
      proposed_log_likelihood += get_log_prior_v_multiplier();
   proposed_BIC += proposed_log_likelihood;
   return proposed_log_likelihood;
}

void GLM_MVN_Clustering::print_cluster_sizes()
{
   print_cluster_sizes( cluster_map );
}

void GLM_MVN_Clustering::print_cluster_sizes( map< Cluster_GLM_MVN*, double >& map_of_clusters )
{
   for( cluster_ptrtodbl::iterator iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
      if( (iter->first)->get_mergeable() )
         cout << iter->first->size() << " ";
   cout << endl;
}

void GLM_MVN_Clustering::calculate_inter_cluster_closeness()
{
//   if( !euclidean_or_correlation_clustering )
   {
     calculate_closeness_contributions();
     calculate_log_likelihood();
   }
   log_likelihood = proposed_log_likelihood;
   BIC = proposed_BIC;
   number_of_clusters = proposed_number_of_clusters;
   number_of_singleton_clusters = proposed_number_of_singleton_clusters;
   current_ytd_vstar_dty_sum = proposed_ytd_vstar_dty_sum;
   if( exclude_singleton_clusters )
      yty_total = proposed_yty_total;
   if( number_of_clusters <= max_analytic_num_clusters && number_of_clusters > 1 && !strlen( Partition_Input_Filename ) )
      sum_cluster_configuration_probabilities();
   calculate_inter_cluster_closeness( cluster_map );
   bool check_for_triangle_inequality = false;
   if( check_for_triangle_inequality )
       for( cluster_ptrtodbl::iterator iter_i = cluster_map.begin(); iter_i != cluster_map.end(); ++iter_i )
           for( cluster_ptrtodbl::iterator iter_j = cluster_map.begin(); iter_j != cluster_map.end(); ++iter_j )
               if( iter_j->first != iter_i->first )
                   check_triangle_inequality( iter_i->first, iter_j->first );
   if( (int)cluster_map.size() == num_subjects && !single_subject_closeness_matrix && closeness_matrix )
   {
      if( !number_of_cluster_types )//don't preserve if clusters have temporary types.
         copy_triangular_array( single_subject_closeness_matrix, closeness_matrix, num_subjects );
      if( ( nn_constraint || singletons_require_best_friend || strlen( Single_Subject_Nearest_Neighbour_Filename ) || strlen( NN_equivalence_relation_partition_Filename ) )&& !single_subject_closest_subject )
      {
         single_subject_closest_subject = new int[ num_subjects ];
         int i,j;
         double change_in_prior = log_prior_num_clusters[ num_subjects - 1 ] - log_prior_num_clusters[ num_subjects ];
         for( cluster_ptrtodbl::iterator iter_i = cluster_map.begin(); iter_i != cluster_map.end(); ++iter_i )
         {
             i = iter_i->first->get_first_subject_allocated();
             Cluster_GLM_MVN* cl_i_nearest = iter_i->first->get_closest_cluster();
             if( non_negative_nearest_neighbours && iter_i->first->get_cluster_closeness( cl_i_nearest ) + change_in_prior < 0 )
             {
                cl_i_nearest = NULL;
                iter_i->first->set_closest_cluster( NULL );
                iter_i->second = -DBL_MAX;
             }
             j = cl_i_nearest ? cl_i_nearest->get_first_subject_allocated(): -1;
             single_subject_closest_subject[ i ] = j;
             if( nn_constraint || singletons_require_best_friend )
             {
                 for( cluster_ptrtodbl::iterator iter_j = cluster_map.begin(); iter_j != cluster_map.end(); ++iter_j )
                     if( iter_j->first != iter_i->first )
                     {
                         if( iter_j->first != cl_i_nearest && singletons_require_best_friend == 2 )
                             iter_i->first->set_cluster_closeness( iter_j->first, -DBL_MAX );
                         else if( iter_j->first != cl_i_nearest || singletons_require_best_friend == 2 )
                         {
                             Cluster_GLM_MVN* cl_j_nearest = iter_j->first->get_closest_cluster();
                             if( iter_i->first != cl_j_nearest )
                             {
                                 iter_i->first->set_cluster_closeness( iter_j->first, -DBL_MAX );
                                 if( iter_j->first == cl_i_nearest )
                                 {
                                     iter_i->first->set_closest_cluster( NULL );
                                     iter_i->second = -DBL_MAX;
                                 }
                             }
                         }
                     }
             }
         }
         /*        for( i = 0; i < num_subjects; i++ )
         {
            max_closeness = -DBL_MAX;
            int max_index = -1;
            for( j = 0; j < num_subjects; j++ )
            {
               if( i > j && max_closeness < single_subject_closeness_matrix[ i ][ j ] )
               {
                  max_index = j;
                  max_closeness = single_subject_closeness_matrix[ i ][ j ];
               }
               else if( i < j && max_closeness < single_subject_closeness_matrix[ j ][ i ] )
               {
                  max_index = j;
                  max_closeness = single_subject_closeness_matrix[ j ][ i ];
               }
            }
            single_subject_closest_subject[ i ] = max_index;
            }*/

/*         for( i = 0; i < num_subjects; i++ )
            for( j = 0; j < i; j++ )
                if( single_subject_closest_subject[ i ] != j && single_subject_closest_subject[ j ] != i )
                closeness_matrix[ i ][ j ] = -DBL_MAX;*/
	 if( strlen( NN_equivalence_relation_partition_Filename ) || nn_constraint )
	 {
	    ofstream NNPartitionStream( NN_equivalence_relation_partition_Filename, ios::out );
	    if( NNPartitionStream )
	    {
	       list<int> sub_list;
//               list<list<int>> partition_list;
               zap_vector( nn_equivalence_relation_partition );
	       nn_equivalence_relation_partition = new int[ num_subjects ];
	       for( i = 0; i < num_subjects; i++ )
		  sub_list.push_back( i );
	       nn_equivalence_relation_partition_size = 0;
	       while( !sub_list.empty() )
	       {
		  list<int>::iterator iter = sub_list.begin();
		  nn_equivalence_relation_partition[ *iter ] = nn_equivalence_relation_partition_size;
		  int sub = single_subject_closest_subject[ *iter ];
		  list<int> cluster_sub_list;
		  cluster_sub_list.push_back( *iter );
		  sub_list.pop_front();
		  iter = find( sub_list.begin(), sub_list.end(), sub );
		  while( iter != sub_list.end() )
		  {
		     cluster_sub_list.push_back( *iter );
		     sub_list.erase( iter );
		     nn_equivalence_relation_partition[ sub ] = nn_equivalence_relation_partition_size;
		     sub = single_subject_closest_subject[ sub ];
		     iter = find( sub_list.begin(), sub_list.end(), sub );
		  }
		  if( sub < 0 || find( cluster_sub_list.begin(), cluster_sub_list.end(), sub ) != cluster_sub_list.end() )
		     nn_equivalence_relation_partition_size++;
                  else
                  {
                     int sub_cl_num = nn_equivalence_relation_partition[ sub ];
                     for( iter = cluster_sub_list.begin(); iter != cluster_sub_list.end(); ++iter )
                        nn_equivalence_relation_partition[ *iter ] = sub_cl_num;
                  }
	       }
	       for( i = 0; i < num_subjects; i++ )
		  NNPartitionStream << nn_equivalence_relation_partition[ i ] + 1 << endl;
	    }
	    NNPartitionStream.close();
	 }
         if( nn_equivalence_relation_partition_size == num_subjects )
             nn_constraint = false;
         else if( nn_constraint )
         {
            for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
               map_iter->first->set_type( nn_equivalence_relation_partition[ map_iter->first->get_first_subject_allocated() ] );
            Cluster_GLM_MVN::set_using_types( true );
            subject_cluster_types = nn_equivalence_relation_partition;
            if( print_to_screen )
               cout << "Nearest neighbour constraint gives a partition with " << nn_equivalence_relation_partition_size << " clusters that must be passed through in agglomerative clustering" << endl;
         }
      }
   }
}

void GLM_MVN_Clustering::calculate_inter_cluster_closeness( map< Cluster_GLM_MVN*, double >& map_of_clusters )
{
   cluster_ptrtodbl::iterator iter, iter2;
   Cluster_GLM_MVN *cl, *cl_max, *cl_second_max;
   bool check_second_closest = require_outstanding_merge;
   for( iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
      iter->second = -DBL_MAX;
   for( iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
   {
      cl = iter->first;
      if( cl->get_mergeable() )
      {
         iter2 = iter;
         ++iter2;
         double d, d_max = iter->second, d_second_max = -DBL_MAX;
         if( check_second_closest )
         {
            iter2 = map_of_clusters.begin();
            d_max =-DBL_MAX;
         }
         cl_max = cl_second_max = NULL;
         bool look_up_closeness = check_second_closest;//false;//true;
         while( iter2 != map_of_clusters.end() )
         {
            if( iter2 == iter )
               look_up_closeness = false;
            else if( iter2->first->get_mergeable() )
            {
               d = cl->get_cluster_closeness( iter2->first, look_up_closeness );
               if( !Cluster_GLM_MVN::using_types || cl->get_type() == iter2->first->get_type() )
               {
                  if( d > d_max )
                  {
                     if( check_second_closest )
                     {
                        d_second_max = d_max;
                        cl_second_max = cl_max;
                     }
                     d_max = d;
                     cl_max = iter2->first;
                  }
                  else if( check_second_closest && d > d_second_max )
                  {
                     d_second_max = d;
                     cl_second_max = iter2->first;
                  }                      
                  if( !check_second_closest && (nn_constraint || singletons_require_best_friend) && d > iter2->second )
                  {
                     iter2->second = d;
                     iter2->first->set_closest_cluster( cl );
                  }
               }
            }
            ++iter2;
         }
         iter->second = d_max;
         if( cl_max )
            cl->set_closest_cluster( cl_max );
         if( cl_second_max )
            cl->set_second_closest_cluster( cl_second_max );
     }
   }
}

double GLM_MVN_Clustering::calculate_closest_cluster( Cluster_GLM_MVN* cl )
{
   return calculate_closest_cluster( cl, cluster_map );
}

double GLM_MVN_Clustering::calculate_closest_cluster( Cluster_GLM_MVN* cl, map< Cluster_GLM_MVN*, double >& map_of_clusters )
{
   double d, d_max = -DBL_MAX;
   Cluster_GLM_MVN* cl_max = 0;
   int cl_s = cl->get_num_subjects_allocated();
   for( cluster_ptrtodbl::iterator iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
      if( (iter->first)->get_mergeable() && iter->first != cl )
      {
         d = calculate_closeness( cl, iter->first );
         if( storing_cluster_closenesses )
         {
             (iter->first)->set_cluster_closeness( cl, d );
             if( !closeness_matrix )
                cl->set_cluster_closeness( iter->first, d );//by symmetry.
         }
         if( !euclidean_or_correlation_clustering && !average_complete_single_link )
            d += get_change_log_prior_cluster_size( iter->first->get_num_subjects_allocated(), cl_s, false );
	 if( d > d_max && (!Cluster_GLM_MVN::using_types || cl->get_type() == iter->first->get_type()) )
         {
            d_max = d;
            cl_max = iter->first;
         }
      }
   cl->set_closest_cluster( cl_max );
   return d_max;
}

double GLM_MVN_Clustering::calculate_closeness_contribution( gsl_matrix_int* nn, gsl_matrix* yy, gsl_matrix* yd, gsl_matrix* dd )
{
   if( ( num_experiments == 1 || treat_experiments_as_different_dimensions ) && heteroskedastic )
   {
      int n00 = gsl_matrix_int_get( nn, 0, 0 );
      if( dim_num_obsns > 1 )
      {
         for( unsigned int j = 1; j < nn->size2; j++ )
            n00 += gsl_matrix_int_get( nn, 0, j );
         if( !dd )
         {
            get_vstar( nn );
            return calculate_closeness_contribution( n00, yy, yd, get_half_log_det_vstar( current_vstar_index ), nn );
         }
      }
      if( !dd )
      {
         get_vstar( n00 );
         get_half_log_det_vstar( n00 );
         return calculate_closeness_contribution( n00, yy, yd, hldv );
      }
      return calculate_closeness_contribution( n00, yy, yd, dd, nn );
   }
   double yd_vstar_dy_sum = 0;
   gsl_matrix* yysum = gsl_matrix_calloc( p_y, p_y );
   gsl_matrix* yy_i = gsl_matrix_calloc( p_y, p_y );
   gsl_matrix* ydsum = gsl_matrix_calloc( p_y, yd->size2 );
   gsl_matrix* ddsum = gsl_matrix_calloc( correlate_experiments ? dim_V : num_design_cols, dim_V );
   int i, j, nn_i = 0, nnsum = 0;
   //   int shift = 1;
   double d = 0;
   for( i = 0; i < num_experiments; i++ )
   {
     if( i > 0 )
      {
         gsl_matrix_set_zero( yy_i );
         nn_i = 0;
         if( treat_experiments_separately )
         {
            gsl_matrix_set_zero( ydsum );
            if( dd )
               gsl_matrix_set_zero( ddsum );
         }
      }

      if( !equivalent_experiments )
      {
         for( int j1 = 0; j1 < p_y; j1++ )
            for( int j2 = 0; j2 < p_y; j2++ )
               *gsl_matrix_ptr(yy_i, j1, j2 ) += gsl_matrix_get( yy, j1, j2 + p_y * i );
         nn_i = gsl_matrix_int_get( nn, 0, i );
	 if( !(dd || treat_experiments_as_different_dimensions) || i == 0 )
	   for( j = 0; j < num_design_cols; j++ )
         {
            for( int i1 = 0; i1 < p_y; i1++ )
               if( !correlate_experiments )
                  *gsl_matrix_ptr( ydsum, i1, j ) += gsl_matrix_get( yd, i1, i * num_design_cols + j );
               else
                  *gsl_matrix_ptr( ydsum, i1, i * num_design_cols + j ) += gsl_matrix_get( yd, i1, i * num_design_cols + j );
            if( dd )
               for( int row = 0; row < num_design_cols; row++ )
                  if( !weight_experiments )
                  {
                     if( !correlate_experiments )
                        *gsl_matrix_ptr( ddsum, row, j ) += gsl_matrix_get( dd, row, i * num_design_cols + j );
                     else
                        *gsl_matrix_ptr( ddsum, i * num_design_cols + row, i * num_design_cols + j ) += gsl_matrix_get( dd, row, i * num_design_cols + j );
                  }
                  else
                  {
                     if( !correlate_experiments )
                        *gsl_matrix_ptr( ddsum, row, j ) += gsl_matrix_get( dd, row, i * num_design_cols + j ) * experiment_weights[ i ] * experiment_weights[ i ];
                     else
                        *gsl_matrix_ptr( ddsum, i * num_design_cols + row, i * num_design_cols + j ) += gsl_matrix_get( dd, row, i * num_design_cols + j ) * experiment_weights[ i ] * experiment_weights[ i ];
                  }
         }
      }
      else
         for( int ii = 0; ii < num_experiments; ii++ )
            if( equivalent_experiments[ ii ] == i )
            {
               for( int j1 = 0; j1 < p_y; j1++ )
                  for( int j2 = 0; j2 < p_y; j2++ )
                     *gsl_matrix_ptr( yy_i, j1, j2 ) += gsl_matrix_get( yy, j1, j2 + p_y * ii );
               nn_i += gsl_matrix_int_get( nn, 0, ii );
               for( j = 0; j < num_design_cols; j++ )
               {
                  for( int i1 = 0; i1 < p_y; i1++ )
                     if( !correlate_experiments )
                        *gsl_matrix_ptr( ydsum,  i1, j ) += gsl_matrix_get( yd, i1, ii * num_design_cols + j );
                     else
                        *gsl_matrix_ptr( ydsum, i1, i * num_design_cols + j ) += gsl_matrix_get( yd, i1, ii * num_design_cols + j );
                  if( dd )
                     for( int row = 0; row < num_design_cols; row++ )
                        if( !weight_experiments )
                        {
                           if( !correlate_experiments )
                              *gsl_matrix_ptr( ddsum, row, j ) += gsl_matrix_get( dd, row, i * num_design_cols + j );
                           else
                              *gsl_matrix_ptr( ddsum, i * num_design_cols + row, i * num_design_cols + j ) += gsl_matrix_get( dd, row, i * num_design_cols + j );
                        }
                        else
                        {
                           if( !correlate_experiments )
                              *gsl_matrix_ptr( ddsum, row, j ) += gsl_matrix_get( dd, row, i * num_design_cols + j ) * experiment_weights[ i ] * experiment_weights[ i ];
                           else
                              *gsl_matrix_ptr( ddsum, i * num_design_cols + row, i * num_design_cols + j ) += gsl_matrix_get( dd, row, i * num_design_cols + j ) * experiment_weights[ i ] * experiment_weights[ i ];
                        }
               }
            }

      gsl_matrix_add( yysum, yy_i );
      //      if( !subject_experiment_weights || treat_experiments_separately )
      nnsum += nn_i;
	 //      else
	 //      {
	 //         nnsum += shift * nn_i ;
	 //	 shift *= ( num_subjects + 1 ) * data_block_size;
	 //      }
      if( nn_i && ( treat_experiments_separately || weight_experiments ) )
      {
         if( treat_experiments_separately && heteroskedastic < 2 )
            d += calculate_closeness_contribution( nn_i, yy_i, ydsum, ddsum );
         else
         {
            if( treat_experiments_separately )
            {
               yd_vstar_dy_sum += calculate_closeness_contribution( nn_i, yy_i, ydsum, ddsum );
               if( !dd )
                  d += get_half_log_det_vstar( nn_i ) + ml_const;
               else
               {
                  gsl_matrix* mx = gsl_matrix_alloc( dim_V, dim_V );
                  for( int mxi = 0; mxi < dim_V; mxi++ )
                     for( int mxj = 0; mxj < dim_V; mxj++ )
                        gsl_matrix_set( mx, mxi, mxj, gsl_matrix_get( V_inv, mxi, mxj ) + gsl_matrix_get( ddsum, mxi, mxj ) );
                  d += -0.5 * my_lndet( mx ) + ml_const;
                  gsl_matrix_free( mx );
               }
               if( number_of_vs > 1 )
                  d += half_logdet_v_inv[ current_v_index ];
            }
            else if( weight_experiments )
	    {
               if( !correlate_experiments || !data_block_sizes )
                  d += nn_i * experiment_weights[ i ] * experiment_weights[ i ];
               else
                  d += nn_i;
	    }
         }
      }
      if( m_star_exp )
         for( j = 0; j < num_design_cols; j++ )
            m_star_exp[ i ][ j ] = gsl_matrix_get( m_star, j, 0 );
   }
   if( !heteroskedastic )
      current_hlvs = d;

   if( random_effects_model )
   {
      for( i = 0; i < p_y; i++ )
         for( j = ytd_cols; j < (int)yd->size2; j++ )
            *gsl_matrix_ptr( ydsum, i, j ) = gsl_matrix_get( yd, i, j );
   }

   if( !treat_experiments_separately && !weight_experiments )
   {
      if( !subject_experiment_weights || treat_experiments_separately || !inputs_repeated_every )
	 d = calculate_closeness_contribution( nnsum, yysum, ydsum, ddsum );
      else
      {
	 get_vstar( nn );
         current_hlvs = get_half_log_det_vstar( current_vstar_index );
	 d = calculate_closeness_contribution( nnsum, yysum, ydsum, current_hlvs );
      }
   }

   if( treat_experiments_separately && heteroskedastic == 2 && nnsum )
   {
      double dyysum = 0;
      for( i = 0; i < p_y; i++ )
         for( j = 0; j < p_y; j++ )
            dyysum += gsl_matrix_get( yysum, i, j );
      gsl_matrix_set( b_star, 0, 0, b_ + 0.5 * dyysum - yd_vstar_dy_sum );
      d += - a_star_lookup[ nnsum ] * log( gsl_matrix_get( b_star, 0, 0 ) ) + ln_gamma_a_star_lookup[ nnsum ];
   }
   else if( weight_experiments )
   {
      if( !dd )
      {
         get_vstar_dbl( d );
         current_hlvs = get_half_log_det_vstar_dbl( d );
//          if( keep_vstars )//then save to the map
//          {
//             (*vstar_map)[ d ] = new matrix( vv );
//             (*half_log_det_vstars)[ d ] = current_hlvs;
//          }
      }
      else
      {
         gsl_matrix* vinv_dd = gsl_matrix_alloc( dim_V, dim_V );
         for( i = 0; i < dim_V; i++ )
            for( j = 0; j < dim_V; j++ )
               gsl_matrix_set( vinv_dd, i, j, gsl_matrix_get( V_inv, i, j ) + gsl_matrix_get( ddsum, i, j ) );
         V_star = gsl_matrix_alloc( num_design_cols, num_design_cols );
         my_invert( vinv_dd, V_star );
         current_hlvs = 0.5 * my_lndet( V_star ) + ml_const;
         gsl_matrix_free( vinv_dd );
      }

      d = calculate_closeness_contribution( nnsum, yysum, ydsum, current_hlvs );
      if( dd )
      {
         gsl_matrix_free( V_star );
         V_star = 0;
      }
   }

   gsl_matrix_free( yysum );
   gsl_matrix_free( yy_i );
   gsl_matrix_free( ydsum );
   gsl_matrix_free( ddsum );
   return d;
}

double GLM_MVN_Clustering::calculate_closeness_contribution( const int nn, const gsl_matrix* yy, const gsl_matrix* yd, const double hlvs, const gsl_matrix_int* nn_obsns )
{
   if( !nn )
      return 0;
   double d = hlvs;

   int i, j, k;
   int dim_vstar = dim_V;
   if( random_effects_model )
      dim_vstar = V_star->size1;
   bool separate_calculations = treat_experiments_as_different_dimensions && heteroskedastic == 1 && nn_obsns;
   int expt_counter = -1, expt_limit = 0, previous_expt_limit = 0;
                                    
   if( heteroskedastic && !separate_calculations )
      a_star = a_star_lookup[ nn ];
    
   if( p_y == 1 )
   {
//   *m_star = (*V_star) * yd.transpose();
//   *yd_vstar_dy= yd * (*m_star);
      double yd_vstar_dy_sum = 0;
      double cum_yd_vstar_dy_sum = 0;
      double yy_00 = gsl_matrix_get( yy, 0, 0 );
      int nn_00 = nn;
      if( !separate_calculations && treat_experiments_as_different_dimensions )
         for( unsigned int jj = 1; jj < yy->size2; jj++ )
            yy_00 += gsl_matrix_get( yy, 0, jj );
      for( i = 0; i < dim_vstar; i++ )
      {
         if( separate_calculations && i == expt_limit )
         {
            expt_counter++;
	    previous_expt_limit = expt_limit;
            expt_limit += num_1way_basis_fns[ expt_counter ];//knot_point_grid ? (vstar_rows/num_experiments_original) : data_block_size;
            yd_vstar_dy_sum = 0;
            nn_00 = gsl_matrix_int_get( nn_obsns, 0, expt_counter );
         }
         if( nn_00 )
         {
         double yd_i = gsl_matrix_get( yd, 0, i );
         double mstar_i0 = gsl_matrix_get( V_star, i, i ) * yd_i;
         if( !find_parameter_values )
         {
            if( !( currently_diagonal_vstar && inputs_repeated_every ) )
            {
               double ydvi_sum = 0;
               for( k = previous_expt_limit; k < i; k++ )
                  ydvi_sum += gsl_matrix_get( yd, 0, k ) * gsl_matrix_get( V_star, i, k );
               yd_vstar_dy_sum += 2 * ydvi_sum * yd_i;
            }
         }
         else
         {
            if( !( currently_diagonal_vstar && inputs_repeated_every ) )
               for( k = previous_expt_limit; k < dim_vstar; k++ )
                  if( k != i )
                     mstar_i0 += gsl_matrix_get( V_star, i, k ) * gsl_matrix_get( yd, 0, k );
            gsl_matrix_set( m_star, i, 0, mstar_i0 );
         }
         yd_vstar_dy_sum += yd_i * mstar_i0;
         }
         else if( find_parameter_values )
            gsl_matrix_set( m_star, i, 0, 0 );

         if( separate_calculations && i == (expt_limit - 1) )
         {
            yy_00 = gsl_matrix_get( yy, 0, expt_counter );
            a_star_vector[ expt_counter ] = a_star_lookup[ nn_00 ];
            b_star_vector[ expt_counter ] = b_ + 0.5 * ( yy_00 - yd_vstar_dy_sum );
            double contrib = -a_star_vector[ expt_counter ] * log( b_star_vector[ expt_counter ] ) + ln_gamma_a_star_lookup[ nn_00 ];
	    if( log_vote_probs && !zero_vote_prob[ expt_counter ] )
	       contrib += log_vote_probs[ expt_counter ][ 0 ];
            d += contrib;
            if( error_prior_contribution_differences )
            { 
	       if( change_basis_variance_for_vote )
	       {
		  a_star_vector1[ expt_counter ] = 1.0 / (coeff_prior_precision1 + (double) nn_00 / num_1way_basis_fns[ expt_counter ]);
		  b_star_vector1[ expt_counter ] = a_star_vector1[ expt_counter ] / gsl_matrix_get( vstar_working, i, i );
	       }
	       else
	       {
		  a_star_vector1[ expt_counter ] = a_star_lookup1[ nn_00 ];
		  b_star_vector1[ expt_counter ] = b_1 + 0.5 * ( yy_00 - yd_vstar_dy_sum );
	       }
               double contrib_diff = 0;
               int rank = num_experiments;
               if( nn_00 )
               {
		  if( change_basis_variance_for_vote )//cut from here
		  {
		     int num_rows = num_1way_basis_fns[ expt_counter ];
		     double old_vstar = gsl_matrix_get( vstar_working, i, i );//assumes same v for whole expt
		     double new_vstar = 1.0 / (coeff_prior_precision1 + (double) nn_00 / num_rows);
		     double hldv_diff = num_rows*(log( old_vstar ) - log( new_vstar ));
		     double ydvstardysumdiff= (old_vstar - new_vstar)*(yd_vstar_dy_sum-cum_yd_vstar_dy_sum);
		     cum_yd_vstar_dy_sum = yd_vstar_dy_sum;
		     contrib_diff = 0.5 * ydvstardysumdiff + hldv_diff;
		  }//to here
		  else{
                  double contrib1 = -a_star_vector1[ expt_counter ] * log( b_star_vector1[ expt_counter ] ) + ln_gamma_a_star_lookup1[ nn_00 ];//change with a_1 later...
                  contrib_diff = contrib - contrib1 + lambda_prior_normalising_constant - lambda_prior_normalising_constant1;
		  }
		  if( log_vote_probs )
		     contrib_diff -= log_vote_probs[ expt_counter ][ 1 ];
                  error_prior_contribution_differences[ expt_counter ] = contrib_diff;
                  rank = 1;
               }
               else
                  error_prior_contribution_differences[ expt_counter ] = 0;
               for( int ii = 0; ii < expt_counter; ii++ )
                  if( zero_vote_prob[ expt_counter ] || ( rank <= error_prior_contribution_difference_ranks[ ii ] && contrib_diff < error_prior_contribution_differences[ ii ] ) )
                     rank++;
                  else if( error_prior_contribution_difference_ranks[ ii ] < num_experiments )
                     error_prior_contribution_difference_ranks[ ii ]++;
               error_prior_contribution_difference_ranks[ expt_counter ] = rank;
            }
         }
      }
//      for( int k = 0; k < dim_vstar; k++ )
//         yd_vstar_dy_sum += gsl_matrix_get( yd, 0, k ) * gsl_matrix_get( m_star, k, 0 );

      double bstar_00 = b_ + 0.5 * ( yy_00 - yd_vstar_dy_sum );
      //            cout << bstar_00 << " " << yy_00 << " " << yd_vstar_dy_sum << " " << endl;
      //      if( yy_00 < yd_vstar_dy_sum ) exit(1);

      if( !heteroskedastic || (heteroskedastic == 2 && treat_experiments_separately) )
      {
         if( !heteroskedastic && find_parameter_values )
            *gsl_matrix_ptr( b_star, 0, 0 ) += 0.5 * ( yy_00 - yd_vstar_dy_sum );
         return 0.5 * yd_vstar_dy_sum;
      }
      if( find_parameter_values )
         gsl_matrix_set( b_star, 0, 0, bstar_00 );
      if( separate_calculations && error_prior_contribution_differences )
      {
         for( i = 0; i < num_experiments; i++ )
            if( error_prior_contribution_difference_ranks[ i ] > experiment_vote || ( experiment_vote == num_experiments && error_prior_contribution_differences[ i ] <= 0 ) || zero_vote_prob[ i ] )
            {
               d -= error_prior_contribution_differences[ i ];
	       if( !change_basis_variance_for_vote )
	       {
		  a_star_vector[ i ] = a_star_vector1[ i ];
		  b_star_vector[ i ] = b_star_vector1[ i ];
	       }
	       else
	       {
                  *gsl_matrix_ptr( m_star, i, 0 ) *= b_star_vector1[ i ];
	       }
            }
      }
      if( !separate_calculations )
         d -= a_star * log( bstar_00 );
   }
   else
   {
      //   *m_star = (*V_star) * yd.transpose();
      for( j = 0; j < p_y; j++ )
         for( i = 0; i < dim_V; i++ )
         {
            double mstar_ij = 0;
            for( k = 0; k < dim_V; k++ )
               mstar_ij += gsl_matrix_get( V_star, i, k ) * gsl_matrix_get( yd, j, k );
            gsl_matrix_set( m_star, i, j, mstar_ij );
         }
//   *yd_vstar_dy= yd * (*m_star);
      for( i = 0; i < p_y; i++ )
         for( j = 0; j < p_y; j++ )
         {
            double yd_vstar_dy_ij = 0;
            for( k = 0; k < dim_V; k++ )
               yd_vstar_dy_ij += gsl_matrix_get( yd, i, k ) * gsl_matrix_get( m_star, k, j );
            gsl_matrix_set( yd_vstar_dy, i, j, yd_vstar_dy_ij );
         }
      if( !heteroskedastic || (heteroskedastic == 2 && treat_experiments_separately) )
      {
         double yd_vstar_dy_sum = 0;
         for( i = 0; i < p_y; i++ )
            for( j = 0; j < p_y; j++ )
            {
               yd_vstar_dy_sum += gsl_matrix_get( yd_vstar_dy, i, j );
               if( !heteroskedastic && find_parameter_values )
                   *gsl_matrix_ptr( b_star, i, j ) += gsl_matrix_get( yy, i, j ) - gsl_matrix_get( yd_vstar_dy, i, j );

            }
         return 0.5 * yd_vstar_dy_sum;
      }
      for( i = 0; i < p_y; i++ )
         for( j = 0; j < p_y; j++ )
            gsl_matrix_set( b_star, i, j, gsl_matrix_get( b_matrix, i, j ) + gsl_matrix_get( yy, i, j ) - gsl_matrix_get( yd_vstar_dy, i, j ) );
      d -= a_star * my_lndet( b_star );
   }
   if( !separate_calculations )
      d += ln_gamma_a_star_lookup[ nn ];
   d += ml_const;
   if( number_of_vs > 1 )
      d += half_logdet_v_inv[ current_v_index ];
   return d;
}

double GLM_MVN_Clustering::calculate_closeness_contribution( int nn, gsl_matrix* yy, gsl_matrix* yd )
{
   if( !nn )
      return 0;
   if( !subject_experiment_weights || treat_experiments_separately )
      get_vstar( nn );
   current_hlvs = get_half_log_det_vstar( nn );
   return calculate_closeness_contribution( nn, yy, yd, current_hlvs );
}

double GLM_MVN_Clustering::calculate_closeness_contribution( int nn, gsl_matrix* yy, gsl_matrix* yd, gsl_matrix* dd, gsl_matrix_int* nn_obsns )
{
   if( !nn )
      return 0;
   if( inputs_repeated_every )//then ignore dd
   {
      get_vstar( nn );
      current_hlvs = get_half_log_det_vstar( nn );
      return calculate_closeness_contribution( nn, yy, yd, current_hlvs );
   }
   gsl_matrix* vv_inv = gsl_matrix_alloc( dim_V, dim_V );
   for( int i = 0; i < dim_V; i++ )
      for( int j = 0; j < dim_V; j++ )
         gsl_matrix_set( vv_inv, i, j, gsl_matrix_get( V_inv, i, j ) + gsl_matrix_get( dd, i, j ) );
   if( !V_star )
      V_star = gsl_matrix_alloc( dim_V, dim_V );
   my_invert( vv_inv, V_star );
   gsl_matrix_free( vv_inv );
   current_hlvs = 0.5 * p_y * my_lndet( V_star );
   return calculate_closeness_contribution( nn, yy, yd, current_hlvs, nn_obsns );
}

double GLM_MVN_Clustering::calculate_closeness_contribution( Cluster_GLM_MVN* cl, bool v_optimise )
{
   return calculate_closeness_contribution( cl, NULL, false, v_optimise );
}

double GLM_MVN_Clustering::calculate_closeness_contribution( Cluster_GLM_MVN* cl, Cluster_GLM_MVN* cl2, bool subtract, bool v_optimise )
{
   if( !splitting_to_optimal )
      number_of_models_evaluated++;
   if( singleton_clusters_uniformly_distributed && cl->is_singleton_cluster() && !cl2 )
   {
      if( !heteroskedastic )
	 return 0;
      background_random_effect_correction = (random_effect_variances? .5 * random_effect_log_variances[ cl->get_first_subject_allocated() ] : 0);
      return background_correction + background_random_effect_correction;//+ ave_data_block_size * p_y *(normalise_targets ? log_ave_y_scale : 0 );
   }
   double temp_closeness, v_ave_closeness, v_max_closeness;
   int i, j;
   list<int> cl_subjects;
   gsl_matrix *ytd_working_store = 0, *m_star_store = 0;//needed for random effects model.
   if( number_of_vs > 1 && v_matrices_differ )
   {
      if( !cl2 && !v_optimise && !mixture_of_vs )
         set_v_index( cl->get_v_index() );
   }
   else
      v_optimise = false;
   if( !non_conjugate_model )
   {
      gsl_matrix_int* cl_num_obsns = cl->get_num_obsns();
      gsl_matrix* cl_yty = cl->get_yty();
      gsl_matrix* cl_ytd = cl->get_ytd();
      for( int j = 0; j < dim_num_obsns; j++ )
         gsl_matrix_int_set( num_obsns_working, 0, j, gsl_matrix_int_get( cl_num_obsns, 0, j ) );

      gsl_matrix_memcpy( yty_working, cl_yty );
      gsl_matrix_memcpy( ytd_working, cl_ytd );

      if( cl2 )
      {
         if( !subtract )
         {
            gsl_matrix_int_add( num_obsns_working, cl2->get_num_obsns() );
            gsl_matrix_add( yty_working, cl2->get_yty() );
            gsl_matrix_add( ytd_working, cl2->get_ytd() );
         }
         else
         {
            gsl_matrix_int_sub( num_obsns_working, cl2->get_num_obsns() );
            gsl_matrix_sub( yty_working, cl2->get_yty() );
            gsl_matrix_sub( ytd_working, cl2->get_ytd() );
         }
      }
      if( !inputs_repeated_every )
      {
         gsl_matrix* cl_dtd = cl->get_dtd();
         gsl_matrix_memcpy( dtd_working, cl_dtd );
         if( cl2 )
         {
            if( !subtract )
               gsl_matrix_add( dtd_working, cl2->get_dtd() );
            else
               gsl_matrix_sub( dtd_working, cl2->get_dtd() );
         }
      }
   }
   if( non_conjugate_model || random_effects_model )
   {
      cl_subjects = cl->get_subjects_allocated();
      if( cl2 )
      {
         list<int> cl2_subjects = cl2->get_subjects_allocated();
         if( !subtract )
            cl_subjects.splice( cl_subjects.end(), cl2_subjects );
         else
            for( list<int>::iterator iter = cl2_subjects.begin(); iter != cl2_subjects.end(); ++iter )
               cl_subjects.remove( *iter );
      }
   }
   if( random_effects_model )
   {
      int num_subjects_in_list = cl_subjects.size();
      ytd_working_store = ytd_working;
      random_effect_rows = num_subjects_in_list;
      list<int>::iterator cl_subjects_iter;
      gsl_matrix *effective_ys = NULL;
      if( random_effect_variances )
      {
	 cl_subjects_working.clear();//will be a list of effective subjects
	 random_effect_rows = 0;
	 for( cl_subjects_iter = cl_subjects.begin(); cl_subjects_iter != cl_subjects.end(); ++cl_subjects_iter )
             if( random_effect_variances[ *cl_subjects_iter ] > 0 )
             {
                random_effect_rows++;
                cl_subjects_working.push_back( *cl_subjects_iter );
             }
          random_effect_rows *= ave_data_block_size;
          effective_ys = get_targets( cl_subjects_working );
      }
      
      ytd_working = gsl_matrix_alloc( p_y, ytd_cols + random_effect_rows );
      m_star_store = m_star;
      m_star = gsl_matrix_alloc( dim_V + random_effect_rows, p_y );
      for( i = 0; i < p_y; i++ )
      {
         for( j = 0; j < ytd_cols; j++ )
            gsl_matrix_set( ytd_working, i, j, gsl_matrix_get( ytd_working_store, i, j ) );
         cl_subjects_iter = cl_subjects.begin();
         for( j = 0; j < random_effect_rows; j++ )
         {
             if( random_effect_variances )
                gsl_matrix_set( ytd_working, i, ytd_cols + j, gsl_matrix_get( effective_ys, j, i ) );
             else
             {
                gsl_matrix_set( ytd_working, i, ytd_cols + j, Y_totals[ *cl_subjects_iter ][ i ] );
                ++cl_subjects_iter;
             }
         }
      }
      if( effective_ys )
	 gsl_matrix_free( effective_ys );
   }
   if( !v_optimise )
      if( !non_conjugate_model )
         temp_closeness = calculate_closeness_contribution( num_obsns_working, yty_working, ytd_working, dtd_working );
      else
         temp_closeness = calculate_non_conjugate_closeness_contribution( cl_subjects );
   else
   {
      v_max_closeness = -DBL_MAX;
      v_ave_closeness = 0;
      for( int index = 0; index < number_of_vs; index++ )
      {
         set_v_index( index );
         if( !non_conjugate_model )
            temp_closeness = calculate_closeness_contribution( num_obsns_working, yty_working, ytd_working, dtd_working );
         else
            temp_closeness = calculate_non_conjugate_closeness_contribution( cl_subjects );
//         if( cl2 )

         if( temp_closeness > v_max_closeness )
         {
            v_ave_closeness *= exp( v_max_closeness - temp_closeness );
            v_max_closeness = temp_closeness;
            temp_closeness = 0;
            optimal_v_index = index;
         }
         else
            temp_closeness -= max_closeness;
         if( mixture_of_vs == 1 )
            temp_closeness += log_prior_v[ index ];
         if( gauss_laguerre_v )
            temp_closeness += log( gsl_matrix_get( w_gl, current_v_index % dim_gl, 0 ) );
         v_ave_closeness += exp( temp_closeness );
      }
      v_ave_closeness = v_max_closeness + log( v_ave_closeness );
      if( mixture_of_vs == 1 )
         temp_closeness = v_ave_closeness;
      else
         temp_closeness = v_max_closeness;
      set_v_index( optimal_v_index );
   }
   if( random_effects_model )
   {
      switch_values( ytd_working_store, ytd_working );
      gsl_matrix_free( ytd_working_store );
      switch_values( m_star_store, m_star );
      for( i = 0; i < dim_V; i++ )
         for( j = 0; j < p_y; j++ )
            gsl_matrix_set( m_star, i, j, gsl_matrix_get( m_star_store, i, j ) );
      gsl_matrix_free( m_star_store );
   }
   return temp_closeness;
}

double GLM_MVN_Clustering::calculate_non_conjugate_closeness_contribution( list<int> cl_subjects )
{
   if( !inputs_repeated_every )
   {
      if( (*vstar_map)[ 0 ] )
         gsl_matrix_free( (*vstar_map)[ 0 ] );
      gsl_matrix *ds_V_dstransp = 0, *ds = get_design_points( cl_subjects );
      gsl_matrix_multiply( ds_V_dstransp, ds, V_, ds, true );
      gsl_matrix_free( ds );
      (*vstar_map)[ 0 ] = ds_V_dstransp;
   }
   if( num_experiments == 1 || correlate_experiments )
      return calculate_gauss_laguerre_non_conjugate_ml( cl_subjects );
   double d = 0;
   for( int i = 0; i < num_experiments; i++ )
      d += calculate_gauss_laguerre_non_conjugate_ml( cl_subjects, &i );
   return d;
}

void GLM_MVN_Clustering::calculate_closeness_contributions()
{
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
   {
      if( (iter->first)->get_mergeable() )
      {
         if( single_subject_closeness_contributions && (iter->first)->get_num_subjects_allocated() == 1 )
         {
            int sub = (iter->first )->get_smallest_subject_allocated();
	    (iter->first)->set_closeness_contribution( single_subject_closeness_contributions[ sub ] );
         }
         else
	    (iter->first)->set_closeness_contribution( calculate_closeness_contribution( iter->first ) );
      }
   }
   if( strlen( Single_Subject_Contributions_Filename ) )
      write_single_subject_contributions_to_file();
}

void GLM_MVN_Clustering::calculate_single_subject_cluster_closeness_contributions()
{
   for( deque< Cluster_GLM_MVN* >::iterator iter = single_subject_clusters.begin(); iter != single_subject_clusters.end(); ++iter )
      (*iter)->set_closeness_contribution( calculate_closeness_contribution( *iter ) );
}

double GLM_MVN_Clustering::calculate_closeness_contribution_with_subject( Cluster_GLM_MVN* cl1, int subject_number )
{
   gsl_matrix_memcpy( yty_working, cl1->get_yty() );
   gsl_matrix_memcpy( ytd_working, cl1->get_ytd() );
   gsl_matrix_int* cl1_num_obsns = cl1->get_num_obsns();
   int i, j;
   for( j = 0; j < dim_num_obsns; j++ )
      gsl_matrix_int_set( num_obsns_working, 0, j, gsl_matrix_int_get( cl1_num_obsns, 0, j ) );
   if( !inputs_repeated_every )
      gsl_matrix_memcpy( dtd_working, cl1->get_dtd() );
   if( !cl1->cluster_contains_subject( subject_number ) )
   {
      for( i = 0; i < p_y; i++ )
      {
         if(yty_cols)
         for( j = 0; j < yty_cols; j++ )
            *gsl_matrix_ptr( yty_working, i, j ) += YTYs[ p_y * subject_number + i ][ j ];
         if(ytd_cols)
         for( j = 0; j < ytd_cols; j++ )
            *gsl_matrix_ptr( ytd_working, i, j ) += YTDs[ p_y * subject_number + i ][ j ];
      }
      if( !inputs_repeated_every )
         for( i = 0; i < num_design_cols; i++ )
            for( j = 0; j < dtd_cols; j++ )
               *gsl_matrix_ptr( dtd_working, i, j ) += DTDs[ num_design_cols * subject_number + i ][ j ];
      for( j = 0; j < dim_num_obsns; j++ )
         *gsl_matrix_int_ptr( num_obsns_working, 0, j ) += NOBs[ subject_number ][ j ];
   }
   if( !non_conjugate_model && !random_effects_model && number_of_vs == 1 )
      return calculate_closeness_contribution( num_obsns_working, yty_working, ytd_working, dtd_working );
   list<int> cl_subjects = cl1->get_subjects_allocated();
   cl_subjects.push_back( subject_number );
   Cluster_GLM_MVN* cl = new Cluster_GLM_MVN( num_obsns_working, yty_working, ytd_working, dtd_working, cl1->get_distinct(), 1, cl_subjects, 0 );
   double cl_closeness_contribution = calculate_closeness_contribution( cl );
   delete cl;
   return cl_closeness_contribution;
}


void GLM_MVN_Clustering::revert_closeness_contributions()
{
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( (iter->first)->get_mergeable() )
         ( iter->first )->revert_closeness_contribution();
}

double GLM_MVN_Clustering::calculate_closeness( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   if( cl1->get_distinct() && cl2->get_distinct() )//clusters cannot be merged
      return -DBL_MAX;
   if( Cluster_GLM_MVN::using_types && cl1->get_type() != cl2->get_type() && !strlen( Closeness_Matrix_Filename ) )
      return -DBL_MAX;
   if( (nn_constraint || singletons_require_best_friend) && single_subject_closest_subject )
      if( !clusters_nearest_neighbours( cl1, cl2 ) )
         return -DBL_MAX;
   if( maximum_cluster_size < num_subjects && cl1->get_num_subjects_allocated() + cl2->get_num_subjects_allocated() > maximum_cluster_size )
      return -DBL_MAX;

   if( single_subject_closeness_matrix && cl1->is_singleton_cluster() && cl2->is_singleton_cluster() && !heller_algorithm )
   {
      int cl1_smallest_subject = cl1->get_smallest_subject_allocated();
      int cl2_smallest_subject = cl2->get_smallest_subject_allocated();
      if( cl1_smallest_subject < cl2_smallest_subject )
         return single_subject_closeness_matrix[ cl2_smallest_subject ][ cl1_smallest_subject ] - singleton_merge_prior_change;
      else
         return single_subject_closeness_matrix[ cl1_smallest_subject ][ cl2_smallest_subject ] - singleton_merge_prior_change;
   }
   if( cluster_by_labels && cl1->get_mergeable() && cl2->get_mergeable() )//if one is not mergeable, it's cluster label is there for validation purposes, so we want the proper probability still.
   {
      string* s1 = cl1->get_label();
      if( s1 )
      {
         string str1 = *s1;
         string* s2 = cl2->get_label();
         if( s2 && str1 != *s2 )//clusters have different labels, cannot be merged
            return -DBL_MAX;
      }
   }
   
   if( euclidean_or_correlation_clustering )
      return -calculate_squared_euclidean_or_correlation_distance( cl1, cl2 );

   old_contributions = cl1->get_closeness_contribution() + cl2->get_closeness_contribution();

   if( heteroskedastic )
   {
      int number_of_models_evaluated_store = number_of_models_evaluated;
      new_contribution = calculate_closeness_contribution( cl1, cl2 );
      if( !heller_algorithm )
          return new_contribution - old_contributions;
//      heller_current_contribution = new_contribution;
      if( single_subject_closeness_matrix && cl1->is_singleton_cluster() && cl2->is_singleton_cluster() )
	 number_of_models_evaluated = number_of_models_evaluated_store;
      int cl1_numsubs = cl1->get_num_subjects_allocated();
      int cl2_numsubs = cl2->get_num_subjects_allocated();
      double log_alpha_gamma = log_heller_dirichlet_alpha + gsl_sf_lngamma(cl1_numsubs+cl2_numsubs);
      double old_d_sum = cl1->get_heller_prior_d() + cl2->get_heller_prior_d();
      heller_log_odds = log_alpha_gamma - old_d_sum;
      heller_reverse_odds = exp(-heller_log_odds );
      heller_odds = exp(heller_log_odds );
      if( heller_log_odds > 0 )
	 heller_pi = 1 / ( 1 + heller_reverse_odds );
      else
	 heller_pi = heller_odds / ( 1 + heller_odds );
      if( heller_pi > 0 )
	 heller_d = -log( heller_pi ) + log_alpha_gamma;
      else
	 heller_d = old_d_sum;
      //      cout << cl1_numsubs+cl2_numsubs << "  " << cl1_numsubs << "  " << cl2_numsubs << "  " << heller_log_odds  << "  " << heller_pi << endl;
      if( old_contributions < new_contribution )
      {
	 if( heller_pi > 0 )
	 {
	    heller_current_contribution = new_contribution + log( heller_pi+(1-heller_pi)*exp(old_contributions-new_contribution) );
	 }
	 else
	 {
	    heller_current_contribution = old_contributions;
	    //	    heller_log_r = -DBL_MAX;
	 }
	 if( heller_log_odds > 0 )
	    heller_log_r = -log( 1 + exp( old_contributions - new_contribution )*heller_reverse_odds );
	 else
	 {
	    if( heller_odds > 0 )
	       heller_log_r = -log( heller_odds + exp( old_contributions - new_contribution ) ) + heller_log_odds;
	    else
	       heller_log_r = new_contribution - old_contributions + heller_log_odds;
	    //	 if( heller_pi <= 0 )
	    //	   cout << exp(heller_log_r) << " " << heller_log_r << " " << heller_log_odds << " " << heller_odds << " " << new_contribution - old_contributions << endl;
	 }
      }
      else
      {
	 if( heller_pi < 1 )
	    heller_current_contribution = old_contributions + log( heller_pi*exp(new_contribution-old_contributions)+(1-heller_pi) );
	 else
	    heller_current_contribution = new_contribution;
	 if( heller_log_odds > 0 )
	    heller_log_r = ( new_contribution - old_contributions ) - log( exp( new_contribution - old_contributions ) + heller_reverse_odds );
	 else
	    heller_log_r = ( new_contribution - old_contributions ) - log( exp( new_contribution - old_contributions )*heller_odds + 1 ) + heller_log_odds;
      }
      return heller_log_r;
   }
   else
   {
      double d, newlik, max_newlik = -DBL_MAX;
      int temp_proposed_number_of_singleton_clusters = number_of_singleton_clusters;
      double temp_proposed_yty_total = yty_total;
      bool cl1_singleton=false, cl2_singleton=false;
      background_random_effect_correction = 0;
      if( exclude_singleton_clusters )
      {
	 cl1_singleton = cl1->is_singleton_cluster();
	 if( cl1_singleton )
	 {
	    temp_proposed_number_of_singleton_clusters--;
	    temp_proposed_yty_total += cl1->get_yty_sum();
	    if( random_effect_variances )
	       background_random_effect_correction += .5 * random_effect_log_variances[ cl1->get_first_subject_allocated() ];
	 }
	 cl2_singleton = cl2->is_singleton_cluster();
	 if( cl2_singleton )
	 {
	    temp_proposed_number_of_singleton_clusters--;
	    temp_proposed_yty_total += cl2->get_yty_sum();
	    if( random_effect_variances )
	       background_random_effect_correction += .5 * random_effect_log_variances[ cl2->get_first_subject_allocated() ];
	 }
      }
      for( int i = 0; i < number_of_vs; i++ )
      {
         set_v_index( i );
         d = calculate_closeness_contribution( cl1, cl2, false, false ) - old_contributions;
	 if( !exclude_singleton_clusters )
	    newlik = a_star_lookup[ 0 ] * ( log( yty_total - proposed_ytd_vstar_dty_sum ) - log( yty_total - proposed_ytd_vstar_dty_sum - d ) );
	 else
	 {
	    newlik = ln_gamma_a_star_lookup[ num_subjects - temp_proposed_number_of_singleton_clusters ] - a_star_lookup[ num_subjects - temp_proposed_number_of_singleton_clusters ] * log( temp_proposed_yty_total - proposed_ytd_vstar_dty_sum - d );
	    if( num_subjects > number_of_singleton_clusters )
	       newlik += -ln_gamma_a_star_lookup[ num_subjects - number_of_singleton_clusters ] + a_star_lookup[ num_subjects - number_of_singleton_clusters ] * log( yty_total - proposed_ytd_vstar_dty_sum );
	    newlik -= background_correction * (number_of_singleton_clusters-temp_proposed_number_of_singleton_clusters) + background_random_effect_correction;
	 }
         gsl_matrix_int_memcpy( num_obsns_working, cl1->get_num_obsns() );
         gsl_matrix_int_memcpy( num_obsns_working2, cl2->get_num_obsns() );
	 if( !exclude_singleton_clusters || !cl1_singleton )
	 {
	    set_v_index( cl1->get_v_index() );
	    newlik -= half_log_det_vstar( num_obsns_working );
	 }
	 if( !exclude_singleton_clusters || !cl2_singleton )
	 {
	    set_v_index( cl2->get_v_index() );
	    newlik -= half_log_det_vstar( num_obsns_working2 );
	 }
         gsl_matrix_int_add( num_obsns_working, num_obsns_working2 );
         set_v_index( optimal_v_index );
         newlik += half_log_det_vstar( num_obsns_working );
         if( !inputs_repeated_every )
         {
            gsl_matrix* dd = gsl_matrix_alloc( num_design_cols, dtd_cols );
            gsl_matrix_memcpy( dd, cl1->get_dtd() );
            gsl_matrix_add( dd, cl2->get_dtd() );
            newlik += get_half_lndet_invvinvplusdtd( dd ) - get_half_lndet_invvinvplusdtd( cl1 ) - get_half_lndet_invvinvplusdtd( cl2 );
            gsl_matrix_free( dd );
         }
         if( newlik > max_newlik )
         {
            max_newlik = newlik;
            optimal_v_index = i;
         }
      }
      newlik = max_newlik;
      set_v_index( optimal_v_index );
      return newlik;
   }
}

bool GLM_MVN_Clustering::clusters_nearest_neighbours( Cluster_GLM_MVN*cl1, Cluster_GLM_MVN*cl2 )  
{
   bool only_for_singletons = false;
   if( singletons_require_best_friend )//== 2 )
      only_for_singletons = true;
   bool cl1_is_singleton =false;
   bool cl1_likes_cl2 = false;
   bool cl2_likes_cl1 = false;

   if( only_for_singletons )
   {
      cl1_is_singleton = cl1->is_singleton_cluster();
      cl1_likes_cl2 = !cl1_is_singleton;
   }

   list<int> cl1_subjects = cl1->get_subjects_allocated();
   list<int> cl2_subjects = cl2->get_subjects_allocated();
   list<int>::iterator iter;

   if( !cl1_likes_cl2 )
   {
      iter = cl1_subjects.begin();
      while( !cl1_likes_cl2 && iter != cl1_subjects.end() )
      {
         int cl1_subject_closest_subject = single_subject_closest_subject[ *iter ];
         if( cl1_subject_closest_subject == -1 || find( cl2_subjects.begin(), cl2_subjects.end(), cl1_subject_closest_subject ) != cl2_subjects.end() )
            cl1_likes_cl2 = true;
         ++iter;
      }
   }
   if( singletons_require_best_friend == 2 && !cl1_likes_cl2 )
      return false;
   else if( (only_for_singletons && !cl1_is_singleton ) || singletons_require_best_friend == 2 || !cl1_likes_cl2 )
   {
      if( only_for_singletons )
         cl2_likes_cl1 = !cl2->is_singleton_cluster();

      iter = cl2_subjects.begin();
      while( !cl2_likes_cl1 && iter != cl2_subjects.end() )
      {
         int cl2_subject_closest_subject = single_subject_closest_subject[ *iter ];
         if( cl2_subject_closest_subject == -1 || find( cl1_subjects.begin(), cl1_subjects.end(), cl2_subject_closest_subject ) != cl1_subjects.end() )
            cl2_likes_cl1 = true;
         ++iter;
      }
      return cl2_likes_cl1;
   }
   return true;
}

bool GLM_MVN_Clustering::check_triangle_inequality( Cluster_GLM_MVN*cl1, Cluster_GLM_MVN*cl2 )
{
    double d12 = exp( -cl1->get_cluster_closeness( cl2 ) );
    for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
    {
        Cluster_GLM_MVN*cl3 = map_iter->first;
        if( cl1 != cl3 && cl2 != cl3 )
        {
            double d13 = exp( -cl1->get_cluster_closeness( cl3 ) );
            if( d12 > d13 )
            {
                double d23 = exp( -cl2->get_cluster_closeness( cl3 ) );
                if( d12 > d13 + d23 )
                {
                    cout << cl1->get_first_subject_allocated() << " " << cl2->get_first_subject_allocated()  << " ^ " << cl3->get_first_subject_allocated() << "    " << d12 << " > " << d13 + d23 << endl;
                    return false;
                }
            }
        }
    }
    return true;
}
   
void GLM_MVN_Clustering::calculate_posterior_mean_parameters( Cluster_GLM_MVN* cl )
{
   find_parameter_values = true;
   calculate_closeness_contribution( cl, false );
   find_parameter_values = false;
//   e_sigma_sq = gsl_matrix_get( b_star, 0, 0 ) / ( a_star - 1 );
   e_sigma_sq = gsl_matrix_get( b_star, 0, 0 ) / ( a_star + 1 );//use mode in case a_star < 1
}

double GLM_MVN_Clustering::calculate_corrected_closeness( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   double d;
   if( cl2 )
   {
      d = calculate_closeness( cl1, cl2 );
      if( !euclidean_or_correlation_clustering )
         d += get_change_log_prior_cluster_size( cl1, cl2, false );
   }
   else
   {
      d = calculate_closeness_contribution( cl1 );
      if( !euclidean_or_correlation_clustering )
         d += log_prior_cluster_size[ cl1->get_num_subjects_allocated() ];
   }
   return d;
}

double GLM_MVN_Clustering::calculate_tree_corrected_closeness( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   if( !cl2 )
      return calculate_corrected_closeness( cl1, cl2 );
   double d = calculate_closeness( cl1, cl2 );
   d += get_change_log_prior_cluster_size( cl1, cl2, true );
   return d;
}

double GLM_MVN_Clustering::calculate_squared_euclidean_or_correlation_distance( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   gsl_matrix* y1 = cl1->get_y_averages();
   gsl_matrix* y2 = cl2->get_y_averages();
   double d = calculate_squared_euclidean_or_correlation_distance( y1, y2 );
   return d;
}

double GLM_MVN_Clustering::calculate_squared_euclidean_or_correlation_distance( list<int>& subj_list1, list<int>& subj_list2 )
{
   gsl_matrix* y1 = get_target_averages( subj_list1 );
   gsl_matrix* y2 = get_target_averages( subj_list2 );
   double d = calculate_squared_euclidean_or_correlation_distance( y1, y2 );
   gsl_matrix_free( y1 );
   gsl_matrix_free( y2 );
   return d;
}

double GLM_MVN_Clustering::calculate_squared_euclidean_or_correlation_distance( int subj1, int subj2 )
{
   list<int> subject_list;
   subject_list.push_back( subj1 );
   gsl_matrix* y1 = get_target_averages( list<int>( subject_list ) );
   subject_list.clear();
   subject_list.push_back( subj2 );
   gsl_matrix* y2 = get_target_averages( list<int>( subject_list ) );
   double d = calculate_squared_euclidean_or_correlation_distance( y1, y2 );
   gsl_matrix_free( y1 );
   gsl_matrix_free( y2 );
   return d;
}

double GLM_MVN_Clustering::calculate_squared_euclidean_or_correlation_distance( gsl_matrix* y1, gsl_matrix* y2 )
{
   if( !euclidean_not_correlation )
      return - calculate_correlation( y1, y2 );
   return calculate_squared_euclidean_distance( y1, y2 );
}

double GLM_MVN_Clustering::get_log_prior_cluster_size( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   int cls = cl1->get_num_subjects_allocated();
   if( cl2 )
      cls += cl2->get_num_subjects_allocated();
   return log_prior_cluster_size[ cls ];
}

double GLM_MVN_Clustering::get_change_log_prior_cluster_size( int cl1s, int cl2s, bool tree_part )
{
   double d;
   if( cl1s == 1 && cl2s == 1 )
      d = singleton_merge_prior_change;
   else
      d = log_prior_cluster_size[ cl1s + cl2s ] - log_prior_cluster_size[ cl1s ] - log_prior_cluster_size[ cl2s ];
   if( tree_part )
      d += get_uniform_tree_log_prior_change( cl1s, cl2s );
   return d;
}

double GLM_MVN_Clustering::get_change_log_prior_cluster_size( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2, bool tree_part )
{
   int cl1s = cl1->get_num_subjects_allocated();
   int cl2s = cl2->get_num_subjects_allocated();
   return get_change_log_prior_cluster_size( cl1s, cl2s, tree_part );
}

double GLM_MVN_Clustering::get_uniform_tree_log_prior_change( int cl1s, int cl2s )
{
   cl1s--;
   cl2s--;
   if( !conditional_tree_distribution )
      return 0;
   return log( (double)( cl1s + cl2s + 1 ) )
      - log( (double)( cl1s + 1 ) ) - log( (double)( cl2s + 1 ) )
      + log( gsl_ran_hypergeometric_pdf( cl1s, 2 * cl1s, 2 * cl2s, cl1s + cl2s ) );
}

double GLM_MVN_Clustering::get_uniform_tree_log_prior_change( int cl1s, int cl2s, int numclust )
{
   numclust--;
   if( !conditional_tree_distribution )
      return 0;
   return get_uniform_tree_log_prior_change( cl1s, cl2s ) + log( (double)( 4 * numclust - 2 ) ) - log( (double)( numclust + 1 ) );
}

double GLM_MVN_Clustering::get_optimal_subtree_log_prob( int num_leaves )
{
   if( conditional_tree_distribution == 0 )
      return 0;
   if( conditional_tree_distribution == 3 )
      return log( 1 + tree_prior_parameter ) - get_log_catalan_number( num_leaves );
   return get_log_one_plus_alpha_catalan_number( num_leaves ) - get_log_catalan_number( num_leaves );
}

double GLM_MVN_Clustering::get_tree_branch_log_prior( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   if( conditional_tree_distribution )
      return 0;
   bool psuedo_tree_likelihood = true;
   double d = 0, closeness;
   if( psuedo_tree_likelihood )
   {
      while( cl2 )
      {
         Cluster_GLM_MVN* cl12 = new Cluster_GLM_MVN( cl1, cl2, true );
         closeness = calculate_tree_corrected_closeness( cl12 );
         delete cl12;
         double closeness2 = calculate_tree_corrected_closeness( cl2 );
         if( tree_prior_parameter >= 0 )
            d += tree_prior_parameter * ( closeness - closeness2 );
         else
            d += tree_prior_parameter * ( closeness * closeness - closeness2 * closeness2 );
         cl2 = cl2->get_parent_cluster();
      }
   }
   else
   {
      closeness = calculate_tree_corrected_closeness( cl1, cl2 );
      d = tree_prior_parameter * closeness;
      if( tree_prior_parameter < 0 )
         d *= closeness;
      Cluster_GLM_MVN* cl2_sibling = cl2->get_sibling_cluster();
      while( cl2 && cl2_sibling )
      {
         Cluster_GLM_MVN* cl12 = new Cluster_GLM_MVN( cl1, cl2, true );
         closeness = calculate_tree_corrected_closeness( cl12, cl2_sibling );
         delete cl12;
         double closeness2 = calculate_tree_corrected_closeness( cl2, cl2_sibling );
         if( tree_prior_parameter >= 0 )
            d += tree_prior_parameter * ( closeness - closeness2 );
         else
            d += tree_prior_parameter * ( closeness * closeness - closeness2 * closeness2 );
         cl2 = cl2->get_parent_cluster();
         if( cl2 )
            cl2_sibling = cl2->get_sibling_cluster();
      }
   }
   return d;
}

double GLM_MVN_Clustering::get_number_of_possible_clusterings_for_tree_containging_cluster( Cluster_GLM_MVN* cl )
{
   return cl->get_my_root_cluster()->get_number_of_possible_clusterings();
}

double GLM_MVN_Clustering::get_log_catalan_number( int m )
{
   m--;
   map<int,double>::iterator iter = catalan_numbers.find( m );
   if( iter != catalan_numbers.end() )
      return iter->second;
   double log_catalan_m = gsl_sf_lnchoose( 2 * m, m ) - log( (double)( m + 1 ) );
   if( conditional_tree_distribution == 3 && m < 500 )
      log_catalan_m = log( exp( log_catalan_m ) + get_tree_prior_parameter() );
   else if( conditional_tree_distribution == 4 )
      log_catalan_m += log( 1 + get_tree_prior_parameter() );
   if( !( conditional_tree_distribution == 4 && functional_tree_prior_parameter ) )
      catalan_numbers[ m ] = log_catalan_m;
   return log_catalan_m;
}

double GLM_MVN_Clustering::get_log_one_plus_alpha_catalan_number( int m )
{ 
   double log_catalan_m = get_log_catalan_number( m ) - log( 1 + get_tree_prior_parameter() ) + log( get_tree_prior_parameter() );
   if( m < 500 )
      return log( 1 + exp( log_catalan_m ) );
   else
      return log_catalan_m;
}

double GLM_MVN_Clustering::get_log_one_plus_alpha_catalan_number( Cluster_GLM_MVN* cl )
{ 
   return get_log_one_plus_alpha_catalan_number( cl->get_num_subjects_allocated() );
}

double GLM_MVN_Clustering::get_tree_prior_parameter()
{
   if( !( conditional_tree_distribution == 4 && functional_tree_prior_parameter ) )
      return tree_prior_parameter;
   return 1 / ( 1 - pow( tree_prior_parameter / ( 1 + tree_prior_parameter ), 1.0 / ( proposed_number_of_clusters + 1 ) ) );
}

double GLM_MVN_Clustering::calculate_log_predictive_probability( Cluster_GLM_MVN* c1, Cluster_GLM_MVN* c2 )
{
   if( !c2 )
      return -DBL_MAX;
   int c1_n = c1->get_total_num_obsns();
   return calculate_closeness_contribution( c1, c2 ) - c2->get_closeness_contribution() - c1_n * p_y * LOG_SQRT_PI + get_change_log_prior_cluster_size( c1, c2, false );
//   return c2->get_cluster_closeness( c1 ) + c1->get_closeness_contribution() - (double)c1_n / 2 * p_y * LOG_PI;
}

double GLM_MVN_Clustering::calculate_predictive_probability( Cluster_GLM_MVN* c1, Cluster_GLM_MVN* c2 )
{
   if( !c2 )
      return 0;
   return exp( calculate_log_predictive_probability( c1, c2 ) );
}

double GLM_MVN_Clustering::calculate_predictive_probability( Cluster_GLM_MVN* c1, int subject )
{
   Cluster_GLM_MVN* cl = create_temporary_cluster_for_subject( subject );
   double temp_prob = calculate_predictive_probability( c1, cl );
   delete cl;
   return temp_prob;
}

double GLM_MVN_Clustering::calculate_predictive_probability( Cluster_GLM_MVN* cl )
{
   double mixture_size = 0, num_clust = 0;
   cluster_ptrs::iterator iter;
   for( iter = mergeable_cluster_deque.begin(); iter != mergeable_cluster_deque.end(); ++iter )
      if( clusters_mergeable( cl, *iter ) )
      {
         mixture_size += (*iter)->get_total_num_obsns();
         num_clust++;
      }
   double temp_prob = 0;
   for( iter = mergeable_cluster_deque.begin(); iter != mergeable_cluster_deque.end(); ++iter )
   {
      if( clusters_mergeable( cl, *iter ) )
      {
         double cl_weight = (double) (*iter)->get_total_num_obsns();
         if( dirichlet_process )
            cl_weight /= mixture_size + dirichlet_parameter;
         else
         {
            cl_weight += dirichlet_parameter;
            cl_weight /= mixture_size + num_clust * dirichlet_parameter;
         }
         temp_prob += cl_weight * calculate_predictive_probability( cl, *iter );
      }
   }
   int cl_n = cl->get_total_num_obsns();
   if( dirichlet_process && dirichlet_parameter > 0 )
      temp_prob += dirichlet_parameter / ( mixture_size + dirichlet_parameter ) * exp( cl->get_closeness_contribution() - cl_n * p_y * LOG_SQRT_PI );
   return temp_prob;
}

double GLM_MVN_Clustering::calculate_conditional_probability( int subject, Cluster_GLM_MVN* c1 )
{
   return exp( calculate_log_conditional_probability( subject, c1 ) );
}

double GLM_MVN_Clustering::calculate_log_conditional_probability( int subject, Cluster_GLM_MVN* c1 )
{
//     Cluster_GLM_MVN* cl = create_temporary_cluster_for_subject( subject );
//     Cluster_GLM_MVN* cl2 = create_temporary_cluster_without_subject( subject, c1 );
//     double log_temp_prob = calculate_log_predictive_probability( cl, cl2 );
//     delete cl;
//     delete cl2;
//     return log_temp_prob;
   return calculate_log_conditional_probability( subject, c1, c1->cluster_contains_subject( subject ) );
}

double GLM_MVN_Clustering::calculate_log_conditional_probability( int subject, Cluster_GLM_MVN* c1, bool cl_contains_subject, Cluster_GLM_MVN* single_subject_cluster_ptr )
{
   if( euclidean_or_correlation_clustering )
   {
      Cluster_GLM_MVN* cl2 = c1;
      if( cl_contains_subject )
      {
         cl2 = create_temporary_cluster_without_subject( subject, c1 );
         if( !cl2 )
            return 0;
      }
      Cluster_GLM_MVN* cl = create_temporary_cluster_for_subject( subject );
      double log_temp_prob =-calculate_squared_euclidean_or_correlation_distance( cl, cl2 );
      delete cl;
      if( cl_contains_subject )
         delete cl2;
      return log_temp_prob;
   }
//    int c1_n = 0;
//    for( int j = 0; j < num_experiments; j++ )
//       c1_n += NOBs[ subject ][ j ];
//    double log_temp_prob = - c1_n * p_y * LOG_SQRT_PI;
   double change_in_contribution = 0, log_temp_prob = 0, alternative_c1_contribution = 0, change_in_hlvs = 0;
   double current_c1_contribution = c1->get_closeness_contribution();
   if( !heteroskedastic )
   {
      change_in_hlvs = half_log_det_vstar( c1->get_num_obsns() ) - ml_const;
      if( !inputs_repeated_every )
         change_in_hlvs += get_half_lndet_invvinvplusdtd( c1 );
//       calculate_closeness_contribution( c1 );
//       change_in_hlvs = current_hlvs;
   }

   Cluster_GLM_MVN* cl2 = single_subject_cluster_ptr;
   if( cl_contains_subject )
   {
      log_temp_prob = get_change_log_prior_cluster_size( 1, c1->get_num_subjects_allocated()-1, false );
      //      if( cl2 )
      if( heteroskedastic )
      {
         if( !single_subject_cluster_ptr )
         {
             cl2 = create_temporary_cluster_for_subject( subject );
             alternative_c1_contribution = calculate_closeness_contribution( c1, cl2, true );
//            cl2 = create_temporary_cluster_without_subject( subject, c1 );
//            alternative_c1_contribution = cl2->get_closeness_contribution();
         }
         else
            alternative_c1_contribution = calculate_closeness_contribution( c1, single_subject_cluster_ptr, true );
      }
      if(!heteroskedastic )
      {
	 cl2 = create_temporary_cluster_without_subject( subject, c1 );
	 if(cl2)
	 {
	    change_in_hlvs -= half_log_det_vstar( cl2->get_num_obsns() ) - ml_const;
	    if( !inputs_repeated_every )
	       change_in_hlvs -= get_half_lndet_invvinvplusdtd( cl2 );
//            change_in_hlvs -= current_hlvs;
	 }
      }
      if( heteroskedastic )
	 change_in_contribution = current_c1_contribution - alternative_c1_contribution;
      else
         log_temp_prob += change_in_hlvs - a_star_lookup[ 0 ] * log( yty_total - current_ytd_vstar_dty_sum );
   }
   else
   {
     if( Cluster_GLM_MVN::get_using_types() && subject_cluster_types && subject_cluster_types[ subject ] != c1->get_type() )
	 return -DBL_MAX;
      log_temp_prob = get_change_log_prior_cluster_size( 1, c1->get_num_subjects_allocated(), false );
         if( !single_subject_cluster_ptr )
         {
//             cl2 = create_temporary_cluster_for_subject( subject );
//             alternative_c1_contribution = calculate_closeness_contribution( c1, cl2 );
            alternative_c1_contribution = calculate_closeness_contribution_with_subject( c1, subject );
         }
         else
            alternative_c1_contribution = calculate_closeness_contribution( c1, single_subject_cluster_ptr );
      change_in_contribution += alternative_c1_contribution - current_c1_contribution;
      if( !heteroskedastic )
         log_temp_prob += current_hlvs - change_in_hlvs - a_star_lookup[ 0 ] * log( yty_total - proposed_ytd_vstar_dty_sum - change_in_contribution );
   }
   if( heteroskedastic )
      log_temp_prob += change_in_contribution;
   if( cl2 && cl2 != single_subject_cluster_ptr )
      delete cl2;
   return log_temp_prob;
}

void GLM_MVN_Clustering::calculate_cluster_label_probabilities()
{
   if( mergeable_cluster_deque.begin() == mergeable_cluster_deque.end() )
      initialise_mergeable_cluster_deque();
   for( cllabtoprob::iterator iter0 = cluster_and_label_probability.begin(); iter0 != cluster_and_label_probability.end(); ++iter0 )
      (iter0->second) = 0;
   string* sptr;
   double prob;

   for( cluster_ptrs::iterator iter2 = unmergeable_cluster_deque.begin(); iter2 != unmergeable_cluster_deque.end(); iter2++ )
      for( cluster_ptrs::iterator iter = mergeable_cluster_deque.begin(); iter != mergeable_cluster_deque.end(); ++iter )
      {
	 sptr = (*iter)->get_label();
	 if( sptr )//then this mergeable cluster has a label...
         {
            prob = 0;
            pair< Cluster_GLM_MVN*, string > clstr_pair( *iter2, *sptr );
            if( !nearest_neighbour_discrim )
               prob = calculate_predictive_probability( *iter2, *iter );
            else
            {
               list<int> cl_subjects = (*iter)->get_subjects_allocated();
               for( list<int>::iterator iter0 = cl_subjects.begin(); iter0 != cl_subjects.end(); ++iter0 )
               {
                  double temp_prob = calculate_predictive_probability( *iter2, *iter0 );
                  if( temp_prob > prob )
                     prob = temp_prob;
               }
            }
            if( maximal_probs )
            {
               if( prob > cluster_and_label_probability[ clstr_pair ] )
                  cluster_and_label_probability[ clstr_pair ] = prob;
            }
            else
               cluster_and_label_probability[ clstr_pair ] += prob * (*iter)->get_total_num_obsns() / (double)num_obsns_total;
         }
      }
}

void GLM_MVN_Clustering::update_cluster_label_probabilities()
{
   for( str_to_int::iterator iter = labels.begin(); iter != labels.end(); ++iter )
   {
      string s = iter->first;
      update_cluster_label_probabilities( s );
   }
}

void GLM_MVN_Clustering::update_cluster_label_probabilities( string& s )
{
   if( !unmergeable_cluster_deque.size() )
      return;
   for( cllabtoprob::iterator iter0 = cluster_and_label_probability.begin(); iter0 != cluster_and_label_probability.end(); ++iter0 )
      if( (iter0->first).second == s )
         (iter0->second) = 0;
   string* sptr;
   double prob;
   for( cluster_ptrs::iterator iter = mergeable_cluster_deque.begin(); iter != mergeable_cluster_deque.end(); ++iter )
   {
      sptr = (*iter)->get_label();
      if( sptr && s == *sptr )//then this mergeable cluster has the same label...
      {
         prob = 0;
         for( cluster_ptrs::iterator iter2 = unmergeable_cluster_deque.begin(); iter2 != unmergeable_cluster_deque.end(); iter2++ )
         {
            pair< Cluster_GLM_MVN*, string > clstr_pair( *iter2, *sptr );
            if( !nearest_neighbour_discrim )
               prob = calculate_predictive_probability( *iter2, *iter );
            else
            {
               list<int> cl_subjects = (*iter)->get_subjects_allocated();
               for( list<int>::iterator iter0 = cl_subjects.begin(); iter0 != cl_subjects.end(); ++iter0 )
               {
                  double temp_prob = calculate_predictive_probability( *iter2, *iter0 );
                  if( temp_prob > prob )
                     prob = temp_prob;
               }
            }
            if( maximal_probs )
            {
               if( prob > cluster_and_label_probability[ clstr_pair ] )
                  cluster_and_label_probability[ clstr_pair ] = prob;
            }
            else
               cluster_and_label_probability[ clstr_pair ] += prob * (*iter)->get_total_num_obsns() / (double)num_obsns_total;
         }
      }
   }
}

void GLM_MVN_Clustering::update_mean_label_probabilities()
{
   for( cllabtoprob::iterator iter0 = cluster_and_label_probability.begin(); iter0 != cluster_and_label_probability.end(); ++iter0 )
   {
      pair< Cluster_GLM_MVN*, string > clstr_pair( (iter0->first).first, (iter0->first).second );
      if( model_averaging )
         mean_cluster_and_label_probability[ clstr_pair ] += iter0->second * model_weight;
      else
         mean_cluster_and_label_probability[ clstr_pair ] = iter0->second * model_weight;
   }
}

void GLM_MVN_Clustering::calculate_membership_probabilities()
{
   if( !membership_probabilities_required )
      return;
   bool allow_new_clusters = variable_dimension_allocation_sweeps && !euclidean_or_correlation_clustering && minimum_cluster_size <= 1 && !no_optimal_clusters_totally_missing_experiments;// && max_map_allocation_sweeps > 0;
   if( number_of_clusters == 1 && !allow_new_clusters )
      return;
   if( keep_vstars == 2 )
      empty_vstar_map();
   if( !map_memberships )
   {
      map_memberships = new int[ num_subjects ];
      for( int i = 0; i < num_subjects; i++ )
         map_memberships[ i ] = -2;//initialise to something nonsensical for a later check that we have looked at this subject.
   }
//   double** membership_contributions = 0;
   double entry_log_likelihood = log_likelihood, previous_log_likelihood = log_likelihood;
   int previous_number_not_in_map_membership;
   bool likelihood_dropped = false;
   if( !max_log_probs )// && !checking_memberships_during_clustering )
      max_log_probs = new double[ num_subjects ];
   if( !probsums && !checking_memberships_during_clustering )
      probsums = new double[ num_subjects ];
   map_allocation_sweep = 0;
   int number_to_be_reallocated = 0;
   bool originally_allow_new_clusters = allow_new_clusters;
   bool switched_on = true;
   bool new_or_deleted_clusters = true;
   bool one_cluster_at_a_time = false;
   bool move_random_subject = reallocate_worst_each_sweep == 3 || reallocate_subjects_at_random;
   bool one_reallocation_per_sweep_store = one_reallocation_per_sweep;
   int number_requiring_new_cluster = 0;
   int most_moveable_subject = -1, cluster_of_most_moveable_subject = -1;
   int cluster_of_subjects_not_allowed_to_move = -1;
   int cluster_of_most_moveable_subject_last_time;
//   int* numbers_not_in_map_membership = 0;
//   if( max_map_allocation_sweeps > 0 && !one_reallocation_per_sweep )
//      numbers_not_in_map_membership = new int[ max_map_allocation_sweeps + 1 ];
//   int progress_gap = 20;
   ofstream MisallocationHistoryStream;
   if( strlen( Subject_Misallocation_History_Filename ) && max_map_allocation_sweeps )
      MisallocationHistoryStream.open( Subject_Misallocation_History_Filename, ios::app );
   double singleton_prob = 0;
   double cooling_factor = 1;
   list<Cluster_GLM_MVN*> new_clusterlist;
   Cluster_GLM_MVN** cluster_vector = new Cluster_GLM_MVN*[ number_of_clusters ];
   list<Cluster_GLM_MVN*>::iterator iter;
   bool *cluster_changed = NULL;
   int num_clusters_changed = 0;

   if( checking_memberships_during_clustering || trying_best_singleton )
      create_zeroed_array( cluster_changed, number_of_clusters );
   int c1 = 0, c2 = 0;
   int changed_cluster_number = -3;
   for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
   {
      if( checking_memberships_during_clustering && map_iter->first == most_mergeable_cluster )
      {
         cluster_changed[ c1 ] = true;
         num_clusters_changed++;
         changed_cluster_number = c1;
      }
      if( trying_best_singleton )
      { 
         if( map_iter->first == utility_cluster_pointer )
         {
            cluster_changed[ c1 ] = true;
            num_clusters_changed++;
         }
         else if( map_iter->first == utility_cluster_pointer2 )
         {
            cluster_changed[ number_of_clusters ] = true;
            num_clusters_changed++;
         }
      }
      if( (map_iter->first)->get_mergeable() || (map_iter->first)->is_root_cluster() )
      {
         if( trying_best_singleton && map_iter->first == utility_cluster_pointer2 )
            cluster_vector[ number_of_clusters ] = map_iter->first;
         else
            cluster_vector[ c1++ ] = map_iter->first;
      }
   }

   while( switched_on )
   {
      bool currently_using_types = Cluster_GLM_MVN::get_using_types();
      if( new_or_deleted_clusters )
      {
	//	 zap_array( membership_probability, num_subjects, membership_probability_dim );
	 int new_membership_probability_dim = number_of_clusters + ((reallocate_subjects_at_random||allow_new_clusters)? 1: 0);
	 if( membership_probability )
	 {
	    if( new_membership_probability_dim == membership_probability_dim - 1)
	       array_delete_column( membership_probability, changed_cluster_number >= 0 ? changed_cluster_number:new_membership_probability_dim, num_subjects, membership_probability_dim );
	    else
	       zap_array( membership_probability, num_subjects, membership_probability_dim );
	 }
	 membership_probability_dim = new_membership_probability_dim;
	 if( !membership_probability && (!check_allocations_at_each_merger || reallocate_subjects_at_random ) )
	     create_array( membership_probability, num_subjects, membership_probability_dim );
         if( !( check_allocations_at_each_merger) || (trying_best_singleton ) )
	    zap_array( membership_contributions, num_subjects, membership_contribution_dim );
         if( !membership_contributions )
         {
             membership_contribution_dim = ( check_allocations_at_each_merger || try_best_singletons ) ? (num_subjects + 1): membership_probability_dim;
             create_array( membership_contributions, num_subjects, membership_contribution_dim );
         }
         else if( checking_memberships_during_clustering )
            new_or_deleted_clusters = false;
         if( new_or_deleted_clusters )
            for( int i = 0; i < num_subjects; i++ )
               map_memberships[ i ] = -2;//initialise to something nonsensical for a later check that we have looked at this subject.
      }
//      if( map_allocation_sweep > max_map_allocation_sweeps / 2 )
//         allow_new_clusters = false;
      number_not_in_map_membership = number_to_be_reallocated = 0;
      subjects_not_in_map_membership.clear();
      number_requiring_new_cluster = 0;
      cluster_of_most_moveable_subject_last_time = cluster_of_most_moveable_subject;
      cluster_of_most_moveable_subject = -1;
      bool same_cluster_as_before = false;
      double log_prob, prob = 0, total_ssq = 0, cl1_contribution = 0;
      double max_prob = reallocate_worst_each_sweep > 0 ? -DBL_MAX : DBL_MAX;
      double change_in_prior = ( number_of_clusters < num_data_blocks ? log_prior_num_clusters[ number_of_clusters + 1 ] - log_prior_num_clusters[ number_of_clusters ] : 0 );// - p_y * LOG_SQRT_PI;//the change in prior if subject were to move to a new cluster on its own.
      double alt_change_in_prior = ( number_of_clusters > 0 ? log_prior_num_clusters[ number_of_clusters ] - log_prior_num_clusters[ number_of_clusters - 1 ] : 0 );// - p_y * LOG_SQRT_PI;//the change in prior if subject were to move to a new cluster on its own.
      if( reallocate_subjects_at_random && max_map_allocation_sweeps != 0 )
	 cooling_factor = 1.0/(map_allocation_sweep+1);//cooling_schedule( map_allocation_sweep + 1, max_map_allocation_sweeps + 1 );
      for( c1 = 0; c1 < number_of_clusters; c1++ )
      {
         Cluster_GLM_MVN *cl1 = cluster_vector[ c1 ];
         list<int>cl_subjects = cl1->get_subjects_allocated();
         int cl_num_subjects = cl_subjects.size();
         bool subjects_cluster_changed = new_or_deleted_clusters || cluster_changed[ c1 ]; //clusters_changed.find( cl1 ) != clusters_changed.end()
         if( !heteroskedastic )
            cl1_contribution = cl1->get_closeness_contribution();
	 if( cl_num_subjects == 1 )
	 {
	    int cl_sub = cl1->get_first_subject_allocated();
	    if( map_memberships[ cl_sub ] > - 2 )
	       map_memberships[ cl_sub ] = c1;
	 }
         if( !checking_memberships_during_clustering || cl_num_subjects > 1 )
	   //	   if( !(checking_memberships_during_clustering && subjects_cluster_changed && num_clusters_changed == 1 && cl_num_subjects == 2 ) )
             for( list<int>::iterator iter2 = cl_subjects.begin(); iter2 != cl_subjects.end(); iter2++ )
         {
            int subject = *iter2;
	    bool not_looked_at_subject_before = map_memberships[ subject ] < -1;
            double cl1_minus_subject_hlvs = 0;
            Cluster_GLM_MVN* single_sub_cluster = NULL;
            if( !retain_singleton_clusters )
               single_sub_cluster = create_temporary_cluster_for_subject( subject, false );
            else
               single_sub_cluster = single_subject_cluster_ptrs[ subject ];
            if( subjects_cluster_changed || not_looked_at_subject_before || !heteroskedastic )
            {
               if( !heteroskedastic )
               {
                   proposed_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum;
                   proposed_ytd_vstar_dty_sum -= cl1_contribution;
                   Cluster_GLM_MVN* cl1_minus_subject = create_temporary_cluster_without_subject( subject, cl1 );
                   if( cl1_minus_subject )
                   {
                      proposed_ytd_vstar_dty_sum += cl1_minus_subject->get_closeness_contribution();
                      cl1_minus_subject_hlvs = current_hlvs;
                      delete cl1_minus_subject;
                   }
//                  double yty_sum_subject = 0;
//                  for( j = 0; j < yty_cols; j++ )
//                     yty_sum_subject += YTYs[ subject ][ j ];
//                  proposed_ytd_vstar_dty_sum -= 0.5 * yty_sum_subject;
               }
               log_prob = calculate_log_conditional_probability( subject, cl1, true, single_sub_cluster );
               membership_contributions[ subject ][ c1 ] = log_prob;
            }
            else
               log_prob = membership_contributions[ subject ][ c1 ];
            if( euclidean_or_correlation_clustering )
               total_ssq -= log_prob;
            if( allow_new_clusters && cl_num_subjects > 1 )
            {
               singleton_prob = change_in_prior - get_change_log_prior_cluster_size( 1, cl_num_subjects-1, false );
               if( heteroskedastic )
                  singleton_prob += single_subject_closeness_contributions[ subject ];
               else
                  singleton_prob += single_subject_hldvs[ subject ] - a_star_lookup[ 0 ] * log( yty_total - proposed_ytd_vstar_dty_sum - single_subject_closeness_contributions[ subject ] );
               membership_contributions[ subject ][ number_of_clusters ] = singleton_prob;
            }
            else if( membership_contribution_dim == (number_of_clusters + 1) )//allow_new_clusters )
               membership_contributions[ subject ][ number_of_clusters ] = singleton_prob = -DBL_MAX;
            map_memberships[ subject ] = c1;
            double probsum = 1, max_log_prob = log_prob;
            if( checking_memberships_during_clustering && !not_looked_at_subject_before && heteroskedastic && num_clusters_changed == 1 )
	    {
	       if( subjects_cluster_changed && max_log_probs[ subject ] <= log_prob )
	       {
		  max_log_probs[ subject ] = log_prob;
		  if( single_sub_cluster && !retain_singleton_clusters )
		     delete single_sub_cluster;
		  continue;
	       }
	       else if( !subjects_cluster_changed )//&& !number_not_in_map_membership )//&& changed_cluster_number != map_memberships[ subject ] )
	       {
		  Cluster_GLM_MVN *cl2 = cluster_vector[ changed_cluster_number ];
		  log_prob = calculate_log_conditional_probability( subject, cl2, false, retain_singleton_clusters ? single_subject_cluster_ptrs[ subject ] : NULL );
		  if( cl_num_subjects == 1 && !euclidean_or_correlation_clustering )
		    log_prob -= alt_change_in_prior;
		  membership_contributions[ subject ][ changed_cluster_number ] = log_prob;
		  if( log_prob <= max_log_prob )
		  {
		     max_log_probs[ subject ] = max_log_prob;
//                   max_log_probs[ subject ] = log_prob;
//                   map_memberships[ subject ] = changed_cluster_number;
		     if( single_sub_cluster && !retain_singleton_clusters )
		        delete single_sub_cluster;
		     continue;
		  }
///                 else if( most_mergeable_clusters_closest_number != map_memberships[ subject ] )
///                    continue;
	       }
            }
            for( c2 = 0; c2 < number_of_clusters; c2++ )
            {
               if( c2 != c1 )
               {
                  Cluster_GLM_MVN *cl2 = cluster_vector[ c2 ];
		  if( !currently_using_types || cl1->get_type() == cl2->get_type() ){
                  if( new_or_deleted_clusters || cluster_changed[ c2 ] || not_looked_at_subject_before || !heteroskedastic )//clusters_changed.find( cl2 ) != clusters_changed.end() )
                  {
//                cout << cl2 << endl;
                     log_prob = calculate_log_conditional_probability( subject, cl2, false, single_sub_cluster );
		     if( cl_num_subjects == 1 && !euclidean_or_correlation_clustering )
		        log_prob -= alt_change_in_prior;
                     membership_contributions[ subject ][ c2 ] = log_prob;
                  }
                  else
                     log_prob = membership_contributions[ subject ][ c2 ];
                  if( log_prob > max_log_prob )
                  {
                     probsum *= exp( max_log_prob - log_prob );
                     probsum += 1;
                     max_log_prob = log_prob;
                     map_memberships[ subject ] = c2;
                  }
                  else
                     probsum += exp( log_prob - max_log_prob );
               }
	       }
            }
            if( allow_new_clusters && cl_num_subjects > 1 )
	    {
               if( singleton_prob > max_log_prob )
               {
                  probsum *= exp( max_log_prob - singleton_prob );
                  probsum += 1;
                  map_memberships[ subject ] = -1;//highest probability is in being in its own new cluster.
                  max_log_prob = singleton_prob;
               }
               else
                  probsum += exp( singleton_prob - max_log_prob );
            }
            if( single_sub_cluster && !retain_singleton_clusters )
               delete single_sub_cluster;
            bool potentially_disallowed = subject == subject_not_allowed_to_move || subject == subject2_not_allowed_to_move;
	    if( potentially_disallowed )
               cluster_of_subjects_not_allowed_to_move = c1;
	    if( potentially_disallowed && !checking_memberships_during_clustering )
	       map_memberships[ subject ] = c1;
	    bool not_moving = potentially_disallowed && ( !checking_memberships_during_clustering || map_memberships[ subject ] == -1 );
	    if( map_memberships[ subject ] != c1 && !not_moving )
	    {
               number_not_in_map_membership++;
	       subjects_not_in_map_membership.push_back( subject );
	       if( map_memberships[ subject ] == -1 )
		  number_requiring_new_cluster++;
	    } 

	    if( max_log_probs )
	       max_log_probs[ subject ] = max_log_prob;
	    if( probsums )
	       probsums[ subject ] = probsum;

	    if( reallocate_subjects_at_random && max_map_allocation_sweeps != 0 )
	    {
               probsum = pow( probsum, cooling_factor );
	       membership_probability[ subject ][ number_of_clusters ] = 0;
	       double new_prob = 0;
	       if( allow_new_clusters && cl_num_subjects > 1 )
	       {
		  new_prob = exp( ( singleton_prob - max_log_prob ) / cooling_factor );
		  probsum += new_prob;
		  new_prob = new_prob / probsum;
		  membership_probability[ subject ][ number_of_clusters ] = new_prob;
	       }
	       for( int j = 0; j < number_of_clusters; j++ )
		  membership_probability[ subject ][ j ] = exp( ( membership_contributions[ subject ][ j ] - max_log_prob ) / cooling_factor ) / probsum;
	       double u = gsl_ran_flat( rn, 0, 1 );
	       c2 = -1;
	       while( u > new_prob && c2 < number_of_clusters - 1 )
	       {
		  c2++;
		  new_prob += membership_probability[ subject ][ c2 ];
	       }
	       //	       if( map_memberships[ subject ] == c1 && c2 != c1 )
	       //		  number_not_in_map_membership--;
	       map_memberships[ subject ] = c2;
	    }
            if( map_memberships[ subject ] != c1 && cl_num_subjects > 1 && !not_moving )
            {
	       number_to_be_reallocated++;
               if( one_reallocation_per_sweep && reallocate_worst_each_sweep )
               {
                  if( reallocate_worst_each_sweep == 1 || reallocate_worst_each_sweep == -1 )
                  {
//                      if( !allow_new_clusters )
//                         prob = 1 / probsum;
//                      else
//                      {
//                         prob = exp( singleton_prob - max_log_prob );
//                         if( map_memberships[ subject ] == -1 )
//                            prob = prob / ( probsum + prob );
//                         else
//                            prob = 1 / ( probsum + prob );
//                      }
                     prob = max_log_prob;
                  }
                  else
                  {
//                      if( !allow_new_clusters )
//                         prob = 1 - exp( membership_contributions[ subject ][ c1 ] - max_log_prob ) / probsum;
//                      else
//                         prob = 1 - exp( membership_contributions[ subject ][ c1 ] - max_log_prob ) / ( probsum + exp( singleton_prob - max_log_prob ) );
                     prob = max_log_prob - membership_contributions[ subject ][ c1 ];
                  }
                  bool override = false;
                  if( one_cluster_at_a_time && !same_cluster_as_before && cluster_of_most_moveable_subject_last_time == c1 )
                      override = same_cluster_as_before = true;
                  if( !one_cluster_at_a_time || !same_cluster_as_before || cluster_of_most_moveable_subject_last_time == c1 )
                     if( override || (reallocate_worst_each_sweep > 0 && prob > max_prob) || (reallocate_worst_each_sweep < 0 && prob < max_prob) )
                     {
                        max_prob = prob;
                        most_moveable_subject = subject;
                        cluster_of_most_moveable_subject = c1;
                     }
               }
               else if( cluster_of_most_moveable_subject == -1 )
                  cluster_of_most_moveable_subject = c1;
            }
            if( !heteroskedastic )
               proposed_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum;
         }
      }
      if( print_to_screen )
      {
         cout << number_not_in_map_membership;
         if( allow_new_clusters && number_requiring_new_cluster > 0 )
            cout << "("<< number_requiring_new_cluster << ")";
         cout << " subjects not in their optimal cluster" << endl;
      }
      if( MisallocationHistoryStream.good() )
      {
         MisallocationHistoryStream << number_not_in_map_membership << "\t" << log_likelihood;
         if (euclidean_or_correlation_clustering )
            MisallocationHistoryStream << "\t" << total_ssq;
         MisallocationHistoryStream << endl;
      }
      if( number_not_in_map_membership == 0 )
         number_to_be_reallocated = 0;
//      if( numbers_not_in_map_membership )
//         numbers_not_in_map_membership[ map_allocation_sweep ] = number_not_in_map_membership;
      switched_on = number_to_be_reallocated > 0 && map_allocation_sweep < max_map_allocation_sweeps;

      if( switched_on )
      {
         map_allocation_sweep++;
         most_mergeable_cluster = NULL;
         mcmc_sampling = true;
         new_or_deleted_clusters = false;
         if( allow_new_clusters || !cluster_changed )
         {        
            if( cluster_changed )
               delete [] cluster_changed;
            create_zeroed_array( cluster_changed, number_of_clusters );
         }
         else
            zero_array( cluster_changed, number_of_clusters );
	 num_clusters_changed = 0;
//      zap_array( closeness_matrix, num_subjects, num_subjects );
         int old_number_of_clusters = number_of_clusters;
         int number_reallocated = 0;
         int counter = 0;
         c1 = 0;
         if( one_reallocation_per_sweep )
            c1 = cluster_of_most_moveable_subject;
         if( move_random_subject )
         {
            c1 = 0;
            most_moveable_subject = rand() % number_to_be_reallocated;//gsl_ran_sample( rn, number_to_be_reallocated );
         }
         while( c1 < old_number_of_clusters && switched_on )
         {
            Cluster_GLM_MVN *cl1 = cluster_vector[ c1 ];
            list<int>cl_subjects = cl1->get_subjects_allocated();
            list<int>::iterator iter2 = cl_subjects.begin();
            if( checking_memberships_during_clustering || !cl1->is_singleton_cluster() )
               while( iter2 != cl_subjects.end() && switched_on )
            {
               int subject = *iter2;
               c2 = map_memberships[ subject ];
	       bool potentially_disallowed = (subject == subject_not_allowed_to_move) || (subject == subject2_not_allowed_to_move);
	       bool not_moving = potentially_disallowed && ( !checking_memberships_during_clustering || c2 == -1 );
               if( c2 != c1 && c2 != -2 && !not_moving )
               {
                  bool move_this_subject = !(one_reallocation_per_sweep && reallocate_worst_each_sweep);
                  if( one_reallocation_per_sweep )
		  {
                     if( move_random_subject )
                     {
                        if( counter == most_moveable_subject )
                           move_this_subject = true;
                        else
                           move_this_subject = false;
                     } 
                     else
                        if( reallocate_worst_each_sweep && subject == most_moveable_subject )
                           move_this_subject = true;
		  }
//                  if( !allow_new_clusters && cl1->get_num_subjects_allocated() == 1 )
                  if( cl1->get_num_subjects_allocated() == 1 )
                     move_this_subject = false;
                  if( move_this_subject )
                  {
                     cluster_changed[ c1 ] = true;
                     num_clusters_changed++;
		     total_number_of_reallocations++;
		     subject_ever_reallocated[ subject ] = true;
		     changed_cluster_number = c1;
                     Cluster_GLM_MVN* cl_split = cl1;
                     Cluster_GLM_MVN *cl2 = NULL;
                     if( cl1->get_num_subjects_allocated() == 1 )
                     {
                        if( c2 != -1 )
                        {
                           number_of_clusters--;
                           cluster_vector[ c1 ] = NULL;
                           new_or_deleted_clusters = true;
                        }
                     }
                     else
                     {
                        cl_split = propose_split_cluster( cl1, subject );
			//                        if( cl1->get_num_subjects_allocated() == 1 )
			//                           map_memberships[ cl1->get_first_subject_allocated() ] = -2;//need to reevaluate this subject now.
			if( cl1->is_singleton_cluster() )
			   number_of_singleton_clusters++;
                     }
//		  cl_split = cl1->split_cluster( subject );

                     if( c2 == -1 )
                     {
                        if( cl_split != cl1 )
                        {
                           new_clusterlist.push_back( cl_split );
                           number_of_clusters++;
			   number_of_singleton_clusters++;
                           new_or_deleted_clusters = true;
                           if( checking_memberships_during_clustering )//update closenesses
                           {
                              execute_merge_part_two__update_cluster_map( cl1 );
                              execute_merge_part_two__update_cluster_map( cl_split );
                           }
                        }
                     }
                     else
                     {
                        cl2 = cluster_vector[ c2 ];
                        if( cl2 )
                        {
			   if( checking_memberships_during_clustering )
			      cl2->get_cluster_closeness( cl_split, false );
			   if( cl2->is_singleton_cluster() )
			      number_of_singleton_clusters--;
                           cl2->merge_cluster( cl_split, checking_memberships_during_clustering );
                           if( nn_constraint || singletons_require_best_friend )
                              cl2->set_closeness_contribution( calculate_closeness_contribution( cl2 ) );
                           if( checking_memberships_during_clustering )//update closenesses
                           {
			      if( cl1 != cl_split )
                                 execute_merge_part_two__update_cluster_map( cl1 );
			      else
				cluster_map.erase( cl1 );
                              execute_merge_part_two__update_cluster_map( cl2 );
                           }
                        }
                        else//other reallocations must have deleted this cluster
                        {
                           cluster_vector[ c2 ] = cl_split;
                           number_of_clusters++;
                           new_or_deleted_clusters = true;
                        }
                        cluster_changed[ c2 ] = true;
			num_clusters_changed++;
//	       (*iter3)->merge_cluster( cl_split );
                     }
                     number_reallocated++;
                     if( cluster_of_subjects_not_allowed_to_move >= 0 && ( ( cl1 != utility_cluster_pointer && c1 != cluster_of_subjects_not_allowed_to_move ) || ( cl2 != utility_cluster_pointer && c2 != cluster_of_subjects_not_allowed_to_move ) ) )
                     {
                        altering_current_model = true;
//                        subject_not_allowed_to_move = -1;
                     }
////                  if( one_reallocation_per_sweep || map_allocation_sweep > max_map_allocation_sweeps / 2 )//<= (number_to_be_reallocated+1)/2 ) )//if already halfway through max no. of sweeps, probably stuck so only do the first reallocation.
                     if( one_reallocation_per_sweep || number_reallocated == number_to_be_reallocated )//if not making progress, only do the first reallocation.
                        switched_on = false;
                  }
                  else
                     counter++;
               }
               ++iter2;
            }
            c1++;
         }
         switched_on = true;

//          if( checking_memberships_during_clustering )
//          {
//             if( subject_not_allowed_to_move >= 0 )
//             {
//                map_memberships[subject_not_allowed_to_move] = -1;
//                subject_not_allowed_to_move = -1;
//             }
//             if( subject2_not_allowed_to_move >= 0 )
//             {
//                map_memberships[subject2_not_allowed_to_move] = -1;
//                subject2_not_allowed_to_move = -1;
//             }
//          }

         if( new_or_deleted_clusters )//check any clusters weren't deleted in the previous sweep, and add any new ones that were created:
         {
            if( !checking_memberships_during_clustering )//otherwise no clusters will have been deleted,and updates will have been done.
            {
               cluster_map.clear();
               for( c1 = 0; c1 < old_number_of_clusters; c1++ )
                  if( cluster_vector[ c1 ] )
                  {
                     cluster_map[ cluster_vector[ c1 ] ] = -DBL_MAX;
                     if( cluster_changed && cluster_changed[ c1 ] )
                        cluster_vector[ c1 ]->set_closeness_contribution( calculate_closeness_contribution( cluster_vector[ c1 ] ) );
                  }
	       for( iter = new_clusterlist.begin(); iter != new_clusterlist.end(); ++iter )
	       {
		  cluster_map[ *iter ] = -DBL_MAX;
		  (*iter)->set_closeness_contribution( calculate_closeness_contribution( *iter ) );
	       }
	    }
//            if( checking_memberships_during_clustering )
//	    {
//	       for( iter = new_clusterlist.begin(); iter != new_clusterlist.end(); ++iter )
	       //		  cluster_map[ *iter ] = calculate_closest_cluster( *iter );
	      //	       for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
	      //		  map_iter->second = (map_iter->first)->find_closest_cluster();
	      //	       for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
	      //		  map_iter->second = calculate_closest_cluster( map_iter->first );
	       //	    }
            new_clusterlist.clear();
            delete [] cluster_vector;
            cluster_vector = new Cluster_GLM_MVN*[ number_of_clusters ];
            c1 = 0;
            for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
               cluster_vector[ c1++ ] = map_iter->first;
            zap_array( membership_contributions, num_subjects, num_subjects + 1 );
         }
         else
            for( c1 = 0; c1 < old_number_of_clusters; c1++ )
               if( cluster_changed && cluster_changed[ c1 ] )
                  cluster_vector[ c1 ]->set_closeness_contribution( calculate_closeness_contribution( cluster_vector[ c1 ] ) );
//         calculate_inter_cluster_closeness();
         if( euclidean_or_correlation_clustering )
         {
            int euclidean_or_correlation_clustering_store = euclidean_or_correlation_clustering;
            euclidean_or_correlation_clustering = 0;
            calculate_closeness_contributions();
            euclidean_or_correlation_clustering = euclidean_or_correlation_clustering_store;
         }
//         calculate_closeness_contributions();
         if( !likelihood_dropped )
         {
            previous_log_likelihood = log_likelihood;
            previous_number_not_in_map_membership = number_not_in_map_membership;
         }
         calculate_log_likelihood();
         log_likelihood = proposed_log_likelihood;
         BIC = proposed_BIC;
         current_ytd_vstar_dty_sum = proposed_ytd_vstar_dty_sum;
         mcmc_sampling = false;

         if( originally_allow_new_clusters && merge_after_each_sweep && !euclidean_or_correlation_clustering && !checking_memberships_during_clustering )
         {
            initialise_mergeable_cluster_deque();
            if( reduce_closeness_matrix )
               create_closeness_matrix();
            else if( closeness_matrix )
               for( int i = 1; i < num_subjects; i++ )
                  for( int j = 0; j < i; j++ )
                     closeness_matrix[ i ][ j ] = -DBL_MAX;
            int number_of_clusters_store = number_of_clusters;
            bool unimodal_bic_function_store = unimodal_bic_function;
	    if( check_allocations_at_each_merger )
	    {
	       if( map_memberships )
		 for( int i = 0; i < num_subjects; i++ )
		   map_memberships[ i ] = -2;
	       zap_array( membership_contributions, num_subjects, num_subjects + 1 );
	    }
            unimodal_bic_function = true;
 //            give_clusters_different_types();
 //            restart_subjects_in_own_clusters();
            bool print_to_screen_store = print_to_screen;
            print_to_screen = false;
            merge_until_desired_num_clusters( false );
            print_to_screen = print_to_screen_store;
            unimodal_bic_function = unimodal_bic_function_store;
            if( number_of_clusters != number_of_clusters_store )
            {
               delete [] cluster_vector;
               cluster_vector = new Cluster_GLM_MVN*[ number_of_clusters ];
               c1 = 0;
               for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
                  cluster_vector[ c1++ ] = map_iter->first;
               new_or_deleted_clusters = true;
               altering_current_model = true;
            }
         }
         if( print_to_screen )
         {
            cout << "Reallocation sweep " << map_allocation_sweep << ":  " << number_of_clusters << " clusters,  log marginal likelihood = " << log_likelihood;
            if( bic_criterion == 1 )
               cout << "  BIC = " << BIC;
            cout << endl;
         }
         if( likelihood_dropped && !(log_likelihood > previous_log_likelihood) && !one_reallocation_per_sweep )//&& previous_number_not_in_map_membership == number_not_in_map_membership && !significantly_different( log_likelihood, previous_log_likelihood ) )
//         if( !one_reallocation_per_sweep && map_allocation_sweep > progress_gap && likelihood_dropped && number_not_in_map_membership >= numbers_not_in_map_membership[map_allocation_sweep-progress_gap] )
         {
               one_reallocation_per_sweep = true;
               allow_new_clusters = false;
               if( print_to_screen )
                  cout << "Switching to reallocating one at a time..." << endl;
         }
         likelihood_dropped = !(log_likelihood > previous_log_likelihood);
      }
   }
   if( one_reallocation_per_sweep )
      one_reallocation_per_sweep = one_reallocation_per_sweep_store;
   bool start_again_passing_through_current_model = (map_allocation_sweep > 0) && rebuild_tree_after_sweeps;
   if( rebuild_tree_after_sweeps && !start_again_passing_through_current_model && !checking_memberships_during_clustering && check_allocations_at_each_merger )
   {
      start_again_passing_through_current_model = true;
      check_allocations_at_each_merger = false;//so don't get stuck here
   }
   if( start_again_passing_through_current_model )
   {
      if( map_allocation_sweep > 0 && print_to_screen )
         cout << "(after " << map_allocation_sweep << " reallocation sweeps)" << endl;
      int old_number_of_clusters = number_of_clusters;
      heller_algorithm = originally_heller_algorithm;
      if( !checking_memberships_during_clustering && subject_not_allowed_to_move < 0 )
	 ac_through_current_partition();
//      int max_map_allocation_sweeps_store = max_map_allocation_sweeps;
//      max_map_allocation_sweeps = 0;
      if( number_of_clusters != old_number_of_clusters && !heller_algorithm )//then clustering has changed
      {
//         int number_not_in_map_membership_store = number_not_in_map_membership;
//         calculate_membership_probabilities();
//         max_map_allocation_sweeps = max_map_allocation_sweeps_store;
//         if( number_not_in_map_membership > number_not_in_map_membership_store )//agglomerative clustering may have made changed the number of clusters and worsened the membership probabilities, so restart:
//         {
	    if( log_likelihood <= entry_log_likelihood )
	       one_reallocation_per_sweep = true;
            max_map_allocation_sweeps -= map_allocation_sweep;
            calculate_membership_probabilities();
	    one_reallocation_per_sweep = one_reallocation_per_sweep_store;
//         }
      }
      else if( !checking_memberships_during_clustering )//still need to recaluate membership probabilities, as cluster order may have changed
      {
         int max_map_allocation_sweeps_store = max_map_allocation_sweeps;
	 int map_allocation_sweep_store = map_allocation_sweep;
         max_map_allocation_sweeps = 0;
         calculate_membership_probabilities();
         max_map_allocation_sweeps = max_map_allocation_sweeps_store;
	 map_allocation_sweep = map_allocation_sweep_store;
      }
   }
   if( ( max_map_allocation_sweeps == 0 || ( map_allocation_sweep == 0 && number_to_be_reallocated == 0 ) ) && membership_contributions && !checking_memberships_during_clustering )
   {
      for( int subject = 0; subject < num_subjects; subject++ )
         for( int j = 0; j < membership_probability_dim; j++ )
            membership_probability[ subject ][ j ] = exp( membership_contributions[ subject ][ j ] - max_log_probs[ subject ] ) / probsums[ subject ];
   }
//   if( numbers_not_in_map_membership )
//      delete [] numbers_not_in_map_membership;
   if( !check_allocations_at_each_merger )
      zap_array( membership_contributions, num_subjects, num_subjects + 1 );
   if( cluster_changed )
      delete [] cluster_changed;
   //   delete [] max_log_probs;
   //   delete [] probsums;
   delete [] cluster_vector;
   map_allocation_sweep = 0;
}

void GLM_MVN_Clustering::ac_through_current_partition()
{
   give_clusters_different_types();
   restart_subjects_in_own_clusters();
   if( subject_not_allowed_to_move < 0 )//otherwise we may have dropped in likelihood.
      max_log_likelihood = -DBL_MAX;
   merge_until_desired_num_clusters();
}

int GLM_MVN_Clustering::get_num_subjects_ever_reallocated()
{
   if( !subject_ever_reallocated )
      return 0;
   int num_subjects_ever_reallocated = 0;
   for( int i = 0; i < num_subjects; i++ )
      if( subject_ever_reallocated[ i ] )
	 num_subjects_ever_reallocated++;
   return num_subjects_ever_reallocated;
}

int GLM_MVN_Clustering::find_subject_with_highest_new_singleton_cluster_probability()
{
    if( !membership_probability )
       return -1;
    bool made_gain = false;
    double max_new_cl_prob = -DBL_MAX, minmax_cl_prob = DBL_MAX;
    int max_new_cl_subject = -1, minmax_cl_subject = -1;
    for( int subject = 0; subject < num_subjects; subject++ )
    {
//        cout << subject << "  " << membership_probability[ number_of_clusters ][ subject ] << endl;
       double new_cl_prob = membership_probability[ subject ][ number_of_clusters ];
       if( new_cl_prob > max_new_cl_prob )
       {
          max_new_cl_subject = subject;
          max_new_cl_prob = new_cl_prob;
       }
       double max_j = -DBL_MAX;
       for( int j = 0; j < number_of_clusters; j++ )
          if( membership_probability[ subject ][ j ] > max_j )
             max_j = membership_probability[ subject ][ j ];
       if( max_j < minmax_cl_prob )
       {
          minmax_cl_subject = subject;
          minmax_cl_prob = max_j;
       }
    }
    cout << "Subject with least affinity to existing clusters: " << minmax_cl_subject << endl;//"   " << gsl_matrix_get( Y, get_subject_index( max_new_cl_subject ) * data_block_sizes_sum / num_data_block_sizes, 0 ) << endl;
    cout << "Subject most wanting own cluster: " << max_new_cl_subject << endl;//"   " << gsl_matrix_get( Y, get_subject_index( max_new_cl_subject ) * data_block_sizes_sum / num_data_block_sizes, 0 ) << endl;

    subject_not_allowed_to_move = max_new_cl_subject;

    int* running_order = NULL;
    create_indexing_array( running_order, num_subjects );
    sort(running_order,running_order+num_subjects,ProxyGreater(*this));
    double** membership_contributions_store = NULL;
    
    int i = 0;
    do
    {
    subject_not_allowed_to_move = running_order[ i ];
    if( !membership_contributions_store && membership_contributions )
       copy_array( membership_contributions_store, membership_contributions, num_subjects, membership_probability_dim );
    Cluster_GLM_MVN* new_cl = move_subject_to_a_singlteon_cluster( subject_not_allowed_to_move );
    if( new_cl )
    {
       trying_best_singleton = true;
       Cluster_GLM_MVN* cl_containing_subject = utility_cluster_pointer;
//       double original_cl_contribution = utility_contribution;
       if( print_to_screen )
       {
          cout << i <<  ": Trying subject " << subject_not_allowed_to_move << " in its own cluster:" << endl;
	  cout << number_of_clusters << " clusters,  log marginal likelihood = " << log_likelihood << endl;
       }
       if( membership_contributions )
          array_insert_column( membership_contributions, membership_probability_dim-1, num_subjects, membership_probability_dim, true );
       membership_probability_dim++;
       zap_vector( map_memberships );
       merge_after_each_sweep = true;
       double max_log_likelihood_store = max_log_likelihood;
       int number_of_clusters_store = number_of_clusters - 1;
       altering_current_model = false;
       double max_BIC_store = max_BIC;
       double current_ytd_vstar_dty_sum_store = current_ytd_vstar_dty_sum;
       calculate_membership_probabilities();
       trying_best_singleton = false;
       subject_not_allowed_to_move = -1;
       if( !altering_current_model && number_of_clusters_store < number_of_clusters && log_likelihood < max_log_likelihood_store )//then nothing has happened, just merge the new cluster back to the one it started from
       {
          merge_clusters( cl_containing_subject, new_cl );
          number_of_clusters--;
//          cluster_map.erase( new_cl );
//          cl_containing_subject->merge_cluster( new_cl, true );
//          cl_containing_subject->set_closeness_contribution( original_cl_contribution );
          log_likelihood = max_log_likelihood_store;
          BIC = max_BIC_store;
          if( !heteroskedastic )
             current_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum_store;
          zap_array( membership_contributions, num_subjects, num_subjects + 1 );
          membership_probability_dim--;
          if( membership_contributions_store )
          {
             create_array( membership_contributions, num_subjects, num_subjects + 1 );
             copy_array( membership_contributions, membership_contributions_store, num_subjects, membership_probability_dim );
          }
       }
       else if( !significantly_different( log_likelihood, max_log_likelihood_store, 1e-5 ) )
          altering_current_model = false;
       if( number_of_clusters_store != number_of_clusters || altering_current_model )
       {
          if( ( bic_criterion == 1 && BIC > max_BIC_store ) || ( bic_criterion == 2 && log_likelihood > max_log_likelihood_store ) )
          {
             if( print_to_screen )
                cout << "Improvement from new custer, now have " << number_of_clusters << " clusters,  log marginal likelihood = " << log_likelihood << endl;
	     //	     cout << calculate_log_likelihood() << endl;
             update_optimal_clustering();
             made_gain = true;
          }
          else
          {
             merge_to_single_cluster();
             split_to_optimal_clustering();
             if( print_to_screen )
                cout << "No improvement from new cluster, revert to " << number_of_clusters << " clusters,  log marginal likelihood = " << log_likelihood << endl;
          }
          zap_array( membership_contributions_store, num_subjects, membership_probability_dim );
       }
       else if( print_to_screen )
          cout << "No change from new cluster, still have " << number_of_clusters << " clusters,  log marginal likelihood = " << log_likelihood << endl;
    }
    } while( ++i < try_best_singletons && !made_gain );
    zap_vector( running_order );
    zap_array( membership_contributions_store, num_subjects, membership_probability_dim );
    if( made_gain )
    {
       made_gain_from_best_singletons = true;
       calculate_membership_probabilities();
       find_subject_with_highest_new_singleton_cluster_probability();//start all over again.
    }
//    if( made_gain_from_best_singletons )
    ac_through_current_partition();
    return max_new_cl_subject;
}

bool GLM_MVN_Clustering::compare_new_cluster_membership_probs( const int sub1, const int sub2)
{
    double diff = membership_probability[ sub1 ][ number_of_clusters ] - membership_probability[ sub2 ][ number_of_clusters ];
    if( diff > 0 )
       return true;
    return false;
}

// int GLM_MVN_Clustering::compare_new_cluster_membership_probs(const void * a, const void * b)
// {
//     double diff = membership_probability[ *(int*)a ][ number_of_clusters ] - membership_probability[ *(int*)b ][ number_of_clusters ];
//     if( diff > 0 )
//         return -1;
//     if( diff < 0 )
//         return 1;
//     return 0;
// }


Cluster_GLM_MVN* GLM_MVN_Clustering::find_cluster_containing_subject( int sub )
{
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( iter->first->cluster_contains_subject( sub ) )
         return iter->first;
   return NULL;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::move_subject_to_a_singlteon_cluster( int sub )
{
    Cluster_GLM_MVN* cl_containing_subject = find_cluster_containing_subject( sub );
    if( cl_containing_subject->is_singleton_cluster() )
       return NULL;
//    Cluster_GLM_MVN* cl_split = cl_containing_subject->split_cluster( sub );
    utility_contribution = cl_containing_subject->get_closeness_contribution();
    Cluster_GLM_MVN* cl_split = split_cluster( cl_containing_subject, sub );
    log_likelihood = proposed_log_likelihood;
    BIC = proposed_BIC;
    number_of_clusters++;
    if( !heteroskedastic )
       current_ytd_vstar_dty_sum = proposed_ytd_vstar_dty_sum;
    for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
        map_iter->second = -DBL_MAX;
    utility_cluster_pointer = cl_containing_subject;//useful to keep track of the cluster sub came from
//    utility_cluster_pointer2 = cl_split;
    return cl_split;
}
    
bool GLM_MVN_Clustering::clusters_mergeable( Cluster_GLM_MVN* c1, Cluster_GLM_MVN* c2  )
{
   if( c1->get_distinct() && c2->get_distinct() )
      return 0;
   if( Cluster_GLM_MVN::get_using_types() && c1->get_type() != c2->get_type() )
      return 0;
   if( !cluster_by_labels )
      return 1;
   string* s1_ptr = c1->get_label();
   if( !s1_ptr )
      return 1;
   string s1 = *s1_ptr;
   string* s2_ptr = c2->get_label();
   if( !s2_ptr )
      return 1;
   if( s1 == *s2_ptr )
      return 1;
   return 0;
}

bool GLM_MVN_Clustering::closeness_preferable( Cluster_GLM_MVN* cl1, double d1, Cluster_GLM_MVN* cl2,  double d2 )
{
/*    Cluster_GLM_MVN* cl1_nearest = NULL;
    if( (nn_constraint || singletons_require_best_friend) && cl1->is_singleton_cluster() )
    {
        cl1_nearest = cl1->get_closest_cluster();
        if( !cl1_nearest || !cl1_nearest->cluster_contains_subject( single_subject_closest_subject[ cl1->get_first_subject_allocated() ] ) )
           return false;
           }*/
    bool average_subject_gain = false;
    if( average_subject_gain )
    {
        if( cl1 && cl1->get_closest_cluster() )
           d1 /= (double)(cl1->size() + cl1->get_closest_cluster()->size());
        if( cl2 && cl2->get_closest_cluster() )
           d2 /= (double)(cl2->size() + cl2->get_closest_cluster()->size());
    }
    if( require_outstanding_merge )
    {
       Cluster_GLM_MVN* cl1_second_nearest = cl1->get_second_closest_cluster();
       Cluster_GLM_MVN* cl2_second_nearest = cl2 ? cl2->get_second_closest_cluster() : NULL;
       if( !cl1_second_nearest || !cl2_second_nearest )
          return d1 > d2;
       double cl1_second_nearest_closeness = cl1->get_cluster_closeness( cl1_second_nearest );
       if( cl1_second_nearest_closeness < 0 )
          cl1_second_nearest_closeness = 0;//(it can always stay by itself)
       double cl2_second_nearest_closeness = cl2->get_cluster_closeness( cl2_second_nearest );
       if( cl2_second_nearest_closeness < 0 )
          cl2_second_nearest_closeness = 0;//(it can always stay by itself)
       return d1 - cl1_second_nearest_closeness > d2 - cl2_second_nearest_closeness;
    }
    if( !worst_first || !cl2 || ( aim_for_positive_closeness && d2 < 0 ) )
       return d1 > d2;
    if( aim_for_positive_closeness && d1 < 0 )
       return false;//look for the smallest positive answer
//    if( !cl1_nearest )
    Cluster_GLM_MVN* cl1_nearest = cl1->get_closest_cluster();
    if( cl1 != cl1_nearest->get_closest_cluster() )
       return false;//require that they are mutually nearest neighbours
    return d1 < d2;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::find_next_input_merger()
{
   most_mergeable_cluster = find_cluster_containing_subject( input_merger_details[ merger_details_rows_original - number_of_clusters ][ 0 ] );
   most_mergeable_clusters_closest = find_cluster_containing_subject( input_merger_details[ merger_details_rows_original - number_of_clusters ][ 2 ] );
   max_closeness = most_mergeable_cluster->get_cluster_closeness( most_mergeable_clusters_closest );
   //      max_closeness = calculate_closeness( most_mergeable_cluster, most_mergeable_clusters_closest );
   return most_mergeable_cluster;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::find_best_merger()
{
   bool new_closeness_highest = false;
   if( preserve_tree && most_mergeable_cluster )
      most_mergeable_cluster = most_mergeable_cluster->get_parent_cluster();
   else if( most_mergeable_cluster && heteroskedastic && !finished_mcmc_sampling && !require_outstanding_merge )
   {
      double new_closeness = cluster_map[ most_mergeable_cluster ];
      if( closeness_preferable( most_mergeable_cluster, new_closeness, most_mergeable_cluster, max_closeness ) )
      {
         new_closeness_highest = true;
         max_closeness = new_closeness;
         most_mergeable_clusters_closest = most_mergeable_cluster->get_closest_cluster();
      }
   }

   if( !new_closeness_highest )
   {
      if( !heteroskedastic && !average_complete_single_link )
         calculate_inter_cluster_closeness( cluster_map );
      most_mergeable_cluster = most_mergeable_clusters_closest = NULL;
      max_closeness = -DBL_MAX;
      cluster_ptrtodbl::iterator iter;
      for( iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
         if( (iter->first)->get_mergeable() )
         {
	    if( require_outstanding_merge )
	       iter->first->find_closest_cluster();
            if( closeness_preferable( iter->first, iter->second, most_mergeable_cluster, max_closeness ) )
            { 
               Cluster_GLM_MVN* closest = (iter->first)->get_closest_cluster();
               if( closest )
               {
                  max_closeness = iter->second;
                  most_mergeable_cluster = iter->first;
                  most_mergeable_clusters_closest = closest;
               }
            }
         }
   }

   return most_mergeable_cluster;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::find_random_best_merger()
{
   cluster_ptrtodbl::iterator iter = cluster_map.begin(), iter2;
   double probsum = 0;
   bool look_at_all_possible_merges = stochastic_agglomeration == 2;
   max_closeness = -DBL_MAX;
   most_mergeable_cluster = NULL;
   double cooling_factor = 1.0;
   if( simulated_annealing )
//      cooling_factor = (num_subjects-number_of_clusters+1)/(num_subjects+1);
      cooling_factor = cooling_schedule( num_subjects-number_of_clusters + 1, num_subjects + 1 );
   while( iter != cluster_map.end() )
   {
      Cluster_GLM_MVN* cl_iter = iter->first;
      Cluster_GLM_MVN* closest = cl_iter->get_closest_cluster();
      if( cl_iter->get_mergeable() )
      {
         double closeness_iter = iter->second;
	 if( closest )
	 {
            if( closeness_preferable( cl_iter, closeness_iter, most_mergeable_cluster, max_closeness ) )
            { 
	       most_mergeable_cluster = cl_iter;
	       most_mergeable_clusters_closest = closest;
	       probsum *= exp( (max_closeness - closeness_iter)/cooling_factor );
	       probsum += 1;
	       max_closeness = closeness_iter;
            }
	    else
               probsum += exp( (closeness_iter - max_closeness)/cooling_factor );
	 }
      }
      ++iter;
      if( look_at_all_possible_merges )
      {
          iter2 = iter;
          while( iter2 != cluster_map.end() )
          {
             if( (iter2->first) != closest && (iter2->first)->get_mergeable() )
                 probsum += exp( (cl_iter->get_cluster_closeness(iter2->first) - max_closeness)/cooling_factor );
             ++iter2;
          }
      }
   }
   double u = gsl_ran_flat( rn, 0, probsum );
   double prob = 1;
   if( u > prob )
   {
      u -= prob;
      iter = cluster_map.begin();
      while( iter != cluster_map.end() )
      {
	 if( (iter->first)->get_mergeable() && iter->first != most_mergeable_cluster )
	 {
	    Cluster_GLM_MVN* closest = (iter->first)->get_closest_cluster();
	    if( closest )
	    {
               prob = exp( (iter->second - max_closeness)/cooling_factor );
	       if( prob > u )
	       {
		  max_closeness = iter->second;
		  most_mergeable_cluster = iter->first;
		  most_mergeable_clusters_closest = closest;
		  return most_mergeable_cluster;
	       }
	       else
		  u -= prob;
	    }
	 }
	 ++iter;
      }
      if( look_at_all_possible_merges )
      {
          iter = cluster_map.begin();
          while( iter != cluster_map.end() )
          {
              if( (iter->first)->get_mergeable() )
              {
                  Cluster_GLM_MVN* closest = (iter->first)->get_closest_cluster();
                  iter2 = iter;
                  ++iter2;
                  while( iter2 != cluster_map.end() )
                  {
                      if( (iter2->first) != closest && (iter2->first)->get_mergeable() )
                      {
                          double closeness_iter = (iter->first)->get_cluster_closeness(iter2->first);
                          prob = exp( (closeness_iter - max_closeness)/cooling_factor );
                          if( prob > u )
                          {
                              max_closeness = closeness_iter;
                              most_mergeable_cluster = iter->first;
                              most_mergeable_clusters_closest = iter2->first;
                              return most_mergeable_cluster;
                          }
                          else
                              u -= prob;
                      }
                      ++iter2;
                  }
              }
              ++iter;
          }
      }
   }
   return most_mergeable_cluster;
}

void GLM_MVN_Clustering::propose_best_merger()
{
   double change_in_log_ml, change_in_prior = 0;
   if( number_distinct && most_mergeable_clusters_closest->get_distinct() )//then switch merger so that distinct cluster stays in its position.
      switch_values( most_mergeable_cluster, most_mergeable_clusters_closest );

   if( number_of_vs > 1 )
      calculate_closeness_contribution( most_mergeable_cluster, most_mergeable_clusters_closest );//to find again which was the optimal v.

   change_in_log_ml = max_closeness;
   if( average_complete_single_link )
      change_in_log_ml = calculate_closeness( most_mergeable_cluster, most_mergeable_clusters_closest ) + get_change_log_prior_cluster_size( most_mergeable_cluster, most_mergeable_clusters_closest, false );
   if( heller_algorithm )
   {
      int number_of_models_evaluated_store = number_of_models_evaluated;
      calculate_closeness( most_mergeable_cluster, most_mergeable_clusters_closest );
      number_of_models_evaluated = number_of_models_evaluated_store;
      change_in_log_ml = heller_current_contribution - old_contributions + get_change_log_prior_cluster_size( most_mergeable_cluster, most_mergeable_clusters_closest, false );
   }
   if( !euclidean_or_correlation_clustering )
   {
      change_in_prior = log_prior_num_clusters[ number_of_clusters - 1 ] - log_prior_num_clusters[ number_of_clusters ];
      change_in_log_ml += change_in_prior;
   }

   proposed_log_likelihood = log_likelihood + change_in_log_ml;

   proposed_BIC = BIC + change_in_log_ml + 0.5 * num_design_cols * log( (double)( regression_n * p_y ) );
   if( !heteroskedastic )
   {
      bool cl1_singleton=false, cl2_singleton=false;
      proposed_yty_total = yty_total;
      proposed_number_of_singleton_clusters = number_of_singleton_clusters;
      background_random_effect_correction = 0;
      if( exclude_singleton_clusters )
      {
	 cl1_singleton = most_mergeable_cluster->is_singleton_cluster();
	 if( cl1_singleton )
	 {
	    proposed_number_of_singleton_clusters--;
	    proposed_yty_total += most_mergeable_cluster->get_yty_sum();
	    if( random_effect_variances )
	       background_random_effect_correction += .5 * random_effect_log_variances[ most_mergeable_cluster->get_first_subject_allocated() ];
	 }
	 cl2_singleton = most_mergeable_clusters_closest->is_singleton_cluster();
	 if( cl2_singleton )
	 {
	    proposed_number_of_singleton_clusters--;
	    proposed_yty_total += most_mergeable_clusters_closest->get_yty_sum();
	    if( random_effect_variances )
	       background_random_effect_correction += .5 * random_effect_log_variances[ most_mergeable_clusters_closest->get_first_subject_allocated() ];
	 }
      }
      if( !euclidean_or_correlation_clustering )
         change_in_prior += get_change_log_prior_cluster_size( most_mergeable_cluster, most_mergeable_clusters_closest, false );
      change_in_log_ml -= change_in_prior;
      double newlik = change_in_log_ml;
      if( !exclude_singleton_clusters )
	 newlik -= a_star_lookup[ 0 ] * log( yty_total - current_ytd_vstar_dty_sum );
      else if( number_of_singleton_clusters != num_subjects )
      {
	 newlik += -a_star_lookup[ num_subjects - number_of_singleton_clusters ] * log( yty_total - current_ytd_vstar_dty_sum ) + ln_gamma_a_star_lookup[ num_subjects - number_of_singleton_clusters ];
      }
      gsl_matrix_int_memcpy( num_obsns_working, most_mergeable_cluster->get_num_obsns() );
      gsl_matrix_int_memcpy( num_obsns_working2, most_mergeable_clusters_closest->get_num_obsns() );
      if( !exclude_singleton_clusters || !cl1_singleton )
      {
	 set_v_index( most_mergeable_cluster->get_v_index() );
	 newlik += half_log_det_vstar( num_obsns_working );
      }
      if( !exclude_singleton_clusters || !cl2_singleton )
      {
	 set_v_index( most_mergeable_clusters_closest->get_v_index() );
	 newlik += half_log_det_vstar( num_obsns_working2 );
      }
      gsl_matrix_int_add( num_obsns_working, num_obsns_working2 );
      set_v_index( optimal_v_index );
      newlik -= half_log_det_vstar( num_obsns_working );
      if( !inputs_repeated_every )
      {
         gsl_matrix* cl12dd = gsl_matrix_alloc( num_design_cols, dtd_cols );
         gsl_matrix_memcpy( cl12dd, most_mergeable_cluster->get_dtd() );
         gsl_matrix_add( cl12dd, most_mergeable_clusters_closest->get_dtd() );
         newlik -= get_half_lndet_invvinvplusdtd( cl12dd ) - get_half_lndet_invvinvplusdtd( most_mergeable_cluster ) - get_half_lndet_invvinvplusdtd( most_mergeable_clusters_closest );
      }
      if( !exclude_singleton_clusters )
	 proposed_ytd_vstar_dty_sum = -exp( -newlik / a_star_lookup[ 0 ] ) + yty_total;
      else
      {
	 newlik += background_correction * (number_of_singleton_clusters-proposed_number_of_singleton_clusters) + background_random_effect_correction - ln_gamma_a_star_lookup[ num_subjects - proposed_number_of_singleton_clusters ];
	 proposed_ytd_vstar_dty_sum = -exp( -newlik / a_star_lookup[ num_subjects - proposed_number_of_singleton_clusters ] ) + proposed_yty_total;
      }
   }
}


void GLM_MVN_Clustering::best_merge_for_cluster( Cluster_GLM_MVN* cl )
{
   Cluster_GLM_MVN* cluster_ptr;
   if( !cl )
   {
      cl = most_mergeable_cluster;
      cluster_ptr = most_mergeable_clusters_closest;
   }
   else
      cluster_ptr = cl->get_closest_cluster();
   execute_merge_clusters( cl, cluster_ptr );
   log_likelihood = proposed_log_likelihood;
   BIC = proposed_BIC;
   current_ytd_vstar_dty_sum = proposed_ytd_vstar_dty_sum;
   if( exclude_singleton_clusters )
      yty_total = proposed_yty_total;
}

void GLM_MVN_Clustering::merge_clusters( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2)
{
   propose_merge_clusters( cl1, cl2 );
   execute_merge_clusters( cl1, cl2 );
}

void GLM_MVN_Clustering::propose_merge_clusters( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2)
{
   double change_in_log_ml = cl1->get_cluster_closeness( cl2 );
   if( number_of_vs > 1 )
      calculate_closeness_contribution( cl1, cl2 );//to find again which was the optimal v.
   proposed_log_likelihood = log_likelihood + change_in_log_ml;
   double change_in_prior = log_prior_num_clusters[ number_of_clusters - 1 ] - log_prior_num_clusters[ number_of_clusters ];
   proposed_log_likelihood += change_in_prior;
   proposed_BIC = BIC + change_in_log_ml + change_in_prior + 0.5 * num_design_cols * log( (double)( regression_n * p_y ) );
   if( !heteroskedastic )
   {
      double newlik = change_in_log_ml;
      newlik -= a_star_lookup[ 0 ] * log( yty_total - current_ytd_vstar_dty_sum );
      gsl_matrix_int* cl1n = cl1->get_num_obsns();
      gsl_matrix_int* cl2n = cl2->get_num_obsns();
      int j;
      for( j = 0; j < dim_num_obsns; j++ )
      {
         gsl_matrix_int_set( num_obsns_working, 0, j, gsl_matrix_int_get( cl1n, 0, j ) );
         gsl_matrix_int_set( num_obsns_working2, 0, j, gsl_matrix_int_get( cl2n, 0, j ) );
      }
      set_v_index( cl1->get_v_index() );
      newlik += half_log_det_vstar( num_obsns_working );
      set_v_index( cl2->get_v_index() );
      newlik += half_log_det_vstar( num_obsns_working2 );
      gsl_matrix_int_add( num_obsns_working, num_obsns_working2 );
      set_v_index( optimal_v_index );
      newlik -= half_log_det_vstar( num_obsns_working ); 
      if( !inputs_repeated_every )
      {
         gsl_matrix* cl12dd = gsl_matrix_alloc( num_design_cols, dtd_cols );
         gsl_matrix_memcpy( cl12dd, cl1->get_dtd() );
         gsl_matrix_add( cl12dd, cl2->get_dtd() );
         newlik -= get_half_lndet_invvinvplusdtd( cl12dd ) - get_half_lndet_invvinvplusdtd( cl1 ) - get_half_lndet_invvinvplusdtd( cl2 );
      }
      proposed_ytd_vstar_dty_sum = -exp( -newlik / a_star_lookup[ 0 ] ) + yty_total;
   }
   if( gibbs_two_mean_separation )
   { // finding prob of splitting back
      list<int> cl1_subjects = cl1->get_subjects_allocated();
      list<int> cl2_subjects = cl2->get_subjects_allocated();
      Cluster_GLM_MVN* cl1_copy = create_temporary_cluster_for_subjects( cl1_subjects );
      Cluster_GLM_MVN* cl2_copy = create_temporary_cluster_for_subjects( cl2_subjects );
      cl1_copy->merge_cluster( cl2_copy );
      cl2_copy = cl1_copy->split_cluster( &cl1_subjects );
      delete cl1_copy;
      delete cl2_copy;
   }
}

void GLM_MVN_Clustering::execute_merge_clusters( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2)
{
   Cluster_GLM_MVN* cl = execute_merge_part_one__merge_the_clusters( cl1, cl2 );
   execute_merge_part_two__update_cluster_map( cl );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::execute_merge_part_one__merge_the_clusters( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2)
{
   Cluster_GLM_MVN* cl;
   Cluster_GLM_MVN* cl1p = cl1->get_parent_cluster();
   Cluster_GLM_MVN* cl2p = cl2->get_parent_cluster();
   cluster_ptrtodbl::iterator iter;
   if( average_complete_single_link )
   {
      int cl1_s = 0, cl2_s = 0, cl12_s = 0;
      if( average_complete_single_link == 1 )
      {
         cl1_s = cl1->get_num_subjects_allocated();
         cl2_s = cl2->get_num_subjects_allocated();
         cl12_s = cl1_s + cl2_s;
      }
      for( iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
	 if( iter->first != cl1 && iter->first != cl2 )
	 {
	    double d_cl1 = (iter->first)->get_cluster_closeness( cl1 );
	    double d_cl2 = (iter->first)->get_cluster_closeness( cl2 );
            if( average_complete_single_link == 1 )
            {
               double d_ave = ( cl1_s * d_cl1 + cl2_s * d_cl2 ) / cl12_s; 
               (iter->first)->set_cluster_closeness( cl1, d_ave );
               (iter->first)->set_cluster_closeness( cl2, d_ave );
            }
            else
               if( d_cl1 < d_cl2 )
                  if( average_complete_single_link == 3 )
                     (iter->first)->set_cluster_closeness( cl1, d_cl2 );
                  else
                     (iter->first)->set_cluster_closeness( cl2, d_cl1 );
               else
                  if( average_complete_single_link == 3 )
                     (iter->first)->set_cluster_closeness( cl2, d_cl1 );
                  else
                     (iter->first)->set_cluster_closeness( cl1, d_cl2 );
	 }
   }
   if( !preserve_tree || !executing_move_subjects || ( !cluster_or_child_in_model && cluster_to_merge_in_model ) )
   {
      cluster_map.erase( cl1 );
      cluster_map.erase( cl2 );
   }
   if( preserve_tree && cl1p && cl2p && cl1p == cl2p )
      cl = cl1p;
   else
      cl = cl1->merge_cluster( cl2 );
   for( iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
   {
      Cluster_GLM_MVN* cl3 = (iter->first)->get_closest_cluster();
      if( cl3 == cl1 || cl3 == cl2 )
         (iter->first)->set_closest_cluster( cl );
      if( cl != cl1 )
         (iter->first)->erase_from_closeness_map( cl1 );
      (iter->first)->erase_from_closeness_map( cl2 );
   }
   return cl;
}

void GLM_MVN_Clustering::execute_merge_part_two__update_cluster_map( Cluster_GLM_MVN* cl1 )
{
   double d, d_max = -DBL_MAX;
   Cluster_GLM_MVN *cl_iter, *cl_max = NULL, *cl_nearest;
   int cl1_s = 0, cl_iter_s = 0;
   if( !euclidean_or_correlation_clustering )
      cl1_s = cl1->get_num_subjects_allocated();
   if( preserve_tree )
   {
      cl_max = cl1->get_sibling_cluster();
      if( cl_max && is_cluster_in_model( cl_max ) )
      {
         d_max = calculate_closeness( cl_max, cl1 );
         if( !euclidean_or_correlation_clustering )
            d_max += get_change_log_prior_cluster_size( cl_max->get_num_subjects_allocated(), cl1_s, false );
         if( storing_cluster_closenesses )
         {
            cl_max->set_cluster_closeness( cl1, d_max );
            if( !closeness_matrix )
               cl1->set_cluster_closeness( cl_max, d_max );//by symmetry.
         }
         if( Cluster_GLM_MVN::using_types && cl1->get_type() != cl_max->get_type() )
            d_max = -DBL_MAX;
         if( cluster_map[ cl_max ] < d_max )
            cluster_map[ cl_max ] = d_max;
      }
   }

   if( (!mcmc_sampling || checking_memberships_during_clustering ) && !cl_max )
   {
      for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      {
         cl_iter = iter->first;
         if( cl_iter != cl1 )
         {
            if( average_complete_single_link )
               d = cl1->get_cluster_closeness( cl_iter );
            else
            {
               d = calculate_closeness( cl1, cl_iter );
               if( !(d <=0 || d>=0 ) )
               {
		  cout << "** " << calculate_closeness_contribution( cl_iter, cl1 ) << ", " << d << endl;
		  if( heller_algorithm )
		     cout <<       heller_log_odds << " " << heller_reverse_odds << " " << heller_pi << " " << heller_d << endl;
                  cout << cl_iter << endl;
		  cout << cl_iter->get_closeness_contribution() << endl;
                  cout << cl1 << endl;
		  cout << cl1->get_closeness_contribution() << endl;
                  cout << "problem" << endl;
                  exit(1);
               }
               if( !euclidean_or_correlation_clustering )
               {
                  cl_iter_s = cl_iter->get_num_subjects_allocated();
                  d += get_change_log_prior_cluster_size( cl_iter_s, cl1_s, false );
               }
               if( storing_cluster_closenesses )
               {
                  cl_iter->set_cluster_closeness( cl1, d );
                  if( !closeness_matrix )
                     cl1->set_cluster_closeness( cl_iter, d );//by symmetry.
               }
            }
            cl_nearest = cl_iter->get_closest_cluster();
            if( !heteroskedastic && cl_nearest && !average_complete_single_link )
            {
               iter->second = calculate_closeness( cl_iter, cl_nearest );//need to recalculate its revised closeness.
               if( !euclidean_or_correlation_clustering )
                  iter->second += get_change_log_prior_cluster_size( cl_iter_s, cl_nearest->get_num_subjects_allocated(), false );
            }
            if( cl_nearest == cl1 && d <= iter->second )//Note, iter->second is an upper bound for the maximum closeness of cl_iter to the rest of the cluster map.
            {
               if( storing_cluster_closenesses )
                  iter->second = cl_iter->find_closest_cluster();
               else
                  iter->second = calculate_closest_cluster( cl_iter );
            }
//now only need to compare newly merged cluster closeness with old highest closeness
            if( d > iter->second && (!Cluster_GLM_MVN::using_types || cl1->get_type() == cl_iter->get_type()) )
            {
               cl_iter->set_closest_cluster( cl1 );
               iter->second = d;
            }
            if( d > d_max && cl_iter->get_mergeable() && (!Cluster_GLM_MVN::using_types || cl1->get_type() == cl_iter->get_type()) )
            {
               d_max = d;
               cl_max = cl_iter;
            }
         }
      }
   }

   cluster_map[ cl1 ] = d_max;
   cl1->set_closest_cluster( cl_max );
}

void GLM_MVN_Clustering::propose_move_up_tree( Cluster_GLM_MVN* cl1 )
{
   Cluster_GLM_MVN* cl2 = cl1->get_sibling_cluster();
   propose_merge_clusters( cl1, cl2 );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::cascade_down_tree( Cluster_GLM_MVN* cl1 )
{
   // we wish to preserve the same number of clusters in the model. so.....
   //if (cl1) cluster_or_child_in_model, then can only cascade down as far as a cluster in the model;
   //if not, then must cascade down below a cluster in the model.
   Cluster_GLM_MVN *cl2, *cl21, *cl22;
   double d12, d121, d122, total_prob, max_log_prob;
   log_proposed_path_probability = 0;
   if( !cascade_from_cluster_in_model )
      cl2 = cl1->get_my_root_cluster();
   else
      cl2 = childs_parent_in_model;
   d12 = calculate_log_cascade_probability( cl1, cl2 );
   bool merge_chosen = 0;
   bool above_the_line = 1;
   double u = 0;
   double left_prob, right_prob, merge_prob = prob_stop_cascading;// * exp( d12 );

   while( !merge_chosen )
   {
      if( !cl2->get_num_clusters_allocated() )
         merge_chosen = 1;
      else
      {
         cl2->get_clusters_allocated( cl21, cl22 );
         d121 = calculate_log_cascade_probability( cl1, cl21 );
         d122 = calculate_log_cascade_probability( cl1, cl22 );
         max_log_prob = d121;
         if( d122 > max_log_prob )
            max_log_prob = d122;
         if( !( above_the_line && !cluster_or_child_in_model ) && d12 > max_log_prob )
            max_log_prob = d12;
         merge_prob = prob_stop_cascading * exp( d12 - max_log_prob );
         left_prob = exp( d121 - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
         right_prob = exp( d122 - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
         if( above_the_line && !cluster_or_child_in_model )
         {
            merge_prob = 0;
            left_prob = exp( d121 - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
            right_prob = exp( d122 - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
         }
         if( is_cluster_in_model( cl2 ) )
            above_the_line = 0;
         if( !above_the_line && ( cluster_or_child_in_model || stop_cascading_at_model ) )
         {
            left_prob = right_prob = 0;
            merge_prob = 1;
         }
         total_prob = merge_prob + left_prob + right_prob;
         merge_prob /= total_prob;
         left_prob /= total_prob;
         right_prob /= total_prob;
         u = gsl_ran_flat( rn, 0, 1 );
         if( u < merge_prob )
         {
            log_proposed_path_probability += log( merge_prob );
            merge_chosen = 1;
         }
         else
         {
            if( u < merge_prob + left_prob )
            {
               cl2 = cl21;
               d12 = d121;
               log_proposed_path_probability += log( left_prob );
            }
            else
            {
               cl2 = cl22;
               d12 = d122;
               log_proposed_path_probability += log( right_prob );
            }
            merge_prob = prob_stop_cascading;// * exp( d12 );
         }
      }
   }
   return cl2;
}

void GLM_MVN_Clustering::calculate_path_probability( Cluster_GLM_MVN* cl0, Cluster_GLM_MVN* cl1 )
{
   Cluster_GLM_MVN *cl = cl1, *cli, *clii, *cl_parent;
   double merge_prob, left_prob, right_prob, total_prob, log_merge_casc_prob, log_casc_prob_i, log_casc_prob_ii, max_log_prob;
   log_path_probability = 0;
   Cluster_GLM_MVN *cl_target, *cl_root;//work up from cl to cl_target, then to cl_root.
   bool passed_target = 0, reached_root = 0;
   cl_root = cl->get_my_root_cluster();
   if( cluster_or_child_in_model )
      cl_target = cl_root;
   else
   {
      cl_target = find_parent_in_model( cl );
      if( stop_cascading_at_model && cl_target )
         cl = cl_target;
   }
   if( !(cluster_or_child_in_model && is_cluster_in_model( cl )) )
      if( cl->get_num_clusters_allocated() == 2 )
      {
         log_merge_casc_prob = calculate_log_cascade_probability( cl0, cl );
         cl->get_clusters_allocated( cli, clii );
         log_casc_prob_i = calculate_log_cascade_probability( cl0, cli );
         log_casc_prob_ii = calculate_log_cascade_probability( cl0, clii );
         max_log_prob = log_casc_prob_i;
         if( log_casc_prob_ii > max_log_prob )
            max_log_prob = log_casc_prob_ii;
         if( log_merge_casc_prob > max_log_prob )
            max_log_prob = log_merge_casc_prob;
         merge_prob = prob_stop_cascading * exp( log_merge_casc_prob - max_log_prob );
         left_prob = exp( log_casc_prob_i - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
         right_prob = exp( log_casc_prob_ii - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
         total_prob = merge_prob + left_prob + right_prob;
         log_path_probability = log( merge_prob / total_prob );
      }

   if( cl == cl_root )
      return;

   cl_parent = cl->get_parent_cluster();
   if( cl_parent == cl_target )
      passed_target = 1;
   log_merge_casc_prob = calculate_log_cascade_probability( cl0, cl_parent );
   merge_prob = prob_stop_cascading;// * exp( log_merge_casc_prob );
   while( !reached_root && ( !cascade_from_cluster_in_model || !passed_target ) )//keep going until reached root cluster, or, if cascading from cluster in model, until reached target.
   {
      if( cl_parent == cl_root )
         reached_root = 1;
      cl_parent->get_clusters_allocated( cli, clii );
      log_casc_prob_i = calculate_log_cascade_probability( cl0, cli );
      log_casc_prob_ii = calculate_log_cascade_probability( cl0, clii );
      max_log_prob = log_casc_prob_i;
      if( log_casc_prob_ii > max_log_prob )
         max_log_prob = log_casc_prob_ii;
      if( !passed_target && log_merge_casc_prob > max_log_prob )
         max_log_prob = log_merge_casc_prob;//this is all just to prevent doing exp( something large ).
      merge_prob = prob_stop_cascading * exp( log_merge_casc_prob - max_log_prob );
      left_prob = exp( log_casc_prob_i - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
      right_prob = exp( log_casc_prob_ii - max_log_prob ) * ( 1 - prob_stop_cascading ) / 2;
      total_prob = left_prob + right_prob;
      if( !passed_target )
         total_prob += merge_prob;
      if( cl == cli )
      {
         log_path_probability += log( left_prob / total_prob );
         log_merge_casc_prob = log_casc_prob_i;
      }
      else
      {
         log_path_probability += log( right_prob / total_prob );
         log_merge_casc_prob = log_casc_prob_ii;
      }
      cl = cl_parent;
      cl_parent = cl->get_parent_cluster();
      if( cl_parent == cl_target )
         passed_target = 1;
   }
}

double GLM_MVN_Clustering::calculate_log_cascade_probability( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   if( !cl2 )
      return -DBL_MAX;
   if( !tree_shift_distribution )
      return 0;
   if( tree_shift_distribution == 1 )
      return calculate_log_predictive_probability( cl1, cl2 ) - get_change_log_prior_cluster_size( cl1, cl2 );
   return calculate_log_predictive_probability( cl1, cl2 );
}

double GLM_MVN_Clustering::calculate_cascade_probability( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   if( !cl2 )
      return 0;
   return exp( calculate_log_cascade_probability( cl1, cl2 ) );
}

bool GLM_MVN_Clustering::is_cluster_in_model( Cluster_GLM_MVN* cl )
{
   if( !preserve_tree )
      return true;
   if( cluster_map.find( cl ) != cluster_map.end() )
      return true;
   return false;
}

int GLM_MVN_Clustering::get_number_of_mergeable_clusters_in_my_model( Cluster_GLM_MVN* cl )
{
   int cl_count = 0;
   Cluster_GLM_MVN* cl_root = cl->get_my_root_cluster();
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( iter->first->get_mergeable() && iter->first->get_my_root_cluster() == cl_root )
         cl_count++;
   return cl_count;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::find_parent_in_model( Cluster_GLM_MVN* cl )
{
   if( !preserve_tree )
      return cl;
   Cluster_GLM_MVN *cl_parent = cl->get_parent_cluster();
   while( cl_parent && cluster_map.find( cl_parent ) == cluster_map.end() )
      cl_parent = cl_parent->get_parent_cluster();
   return cl_parent;
}

bool GLM_MVN_Clustering::has_child_in_model( Cluster_GLM_MVN* cl )
{
   if( !preserve_tree )
      return false;
   if( is_cluster_in_model( cl ) || find_parent_in_model( cl ) )
      return false;
   return true;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::split_cluster( Cluster_GLM_MVN* cl1, list<int>* cl_subjects )
{
   return execute_split_cluster( cl1, propose_split_cluster( cl1, cl_subjects ) );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::split_cluster( Cluster_GLM_MVN* cl1, int cl_subject )
{
   list<int> cl_subjects;
   cl_subjects.push_back( cl_subject );
   return split_cluster( cl1, &cl_subjects );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::propose_split_cluster( Cluster_GLM_MVN*& cl1, list<int>* cl_subjects )
{
   double cl1_contribution = cl1->get_closeness_contribution();
   Cluster_GLM_MVN* cl2;
   cluster_in_model = cluster_or_child_in_model = clusters_parent_in_model = 1;
   proposed_parent_cl = 0;
   proposed_original_cl = cl1;
   int num_cls_allocated = cl1->get_num_clusters_allocated();
   if( num_cls_allocated == 2 )
      cl2 = split_off_branch( cl1, cl_subjects );
   else
      cl2 = cl1->split_cluster( cl_subjects );
   if( !cl2 )
      return NULL;
   if( splitting_to_optimal && !recalculate_whilst_splitting_to_optimal )
      return cl2;
   
   if( !heteroskedastic && num_cls_allocated == 2 )
      proposed_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum - cl1_contribution + cl1->get_closeness_contribution() + cl2->get_closeness_contribution();
   double change_in_log_ml = - cl1->get_cluster_closeness( cl2 );
   proposed_log_likelihood = log_likelihood + change_in_log_ml;
   double change_in_prior = log_prior_num_clusters[ number_of_clusters + 1 ] - log_prior_num_clusters[ number_of_clusters ];
   proposed_log_likelihood += change_in_prior;
   proposed_BIC = BIC + change_in_log_ml + change_in_prior - 0.5 * num_design_cols * log( (double)( regression_n * p_y ) );
   return cl2;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::propose_split_cluster( Cluster_GLM_MVN*& cl1, int cl_subject )
{
   list<int> cl_subjects;
   cl_subjects.push_back( cl_subject );
   return propose_split_cluster( cl1, &cl_subjects );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::execute_split_cluster( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   if( !cl2 )
      return NULL;
   double d1_max = -DBL_MAX, d2_max = -DBL_MAX;
   Cluster_GLM_MVN *cl2_max = 0, *cl1_max = 0, *cl_iter;
   if( !preserve_tree )
   {
      if( !( mcmc_sampling || splitting_to_optimal ) )
      {
         for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
         {
            cl_iter = iter->first;
            if( cl_iter != cl1 )
            {
               double d1 = calculate_closeness( cl_iter, cl1 );
               double d2 = calculate_closeness( cl_iter, cl2 );
               if( !euclidean_or_correlation_clustering )
               {
                  d1 += get_change_log_prior_cluster_size( cl_iter, cl1, false );
                  d2 += get_change_log_prior_cluster_size( cl_iter, cl2, false );
               }
               if( storing_cluster_closenesses )
               {
                  cl_iter->set_cluster_closeness( cl1, d1 );
                  if( !closeness_matrix )
                     cl1->set_cluster_closeness( cl_iter, d1 );//by symmetry.
                  cl_iter->set_cluster_closeness( cl2, d2 );
                  if( !closeness_matrix )
                     cl2->set_cluster_closeness( cl_iter, d2 );//by symmetry.
               }
               Cluster_GLM_MVN* cl3 = (cl_iter)->get_closest_cluster();
               if( cl3 == cl1 )
                  if( storing_cluster_closenesses )
                     iter->second = cl_iter->find_closest_cluster();
                  else
                     iter->second = calculate_closest_cluster( cl_iter );
               else //only need to compare 2 newly formed clusters closeness with old highest closeness
                  if( d1 > d2 && d1 > iter->second )
                  {
                     cl_iter->set_closest_cluster( cl1 );
                     iter->second = d1;
                  }
                  else if( d2 > d1 && d2 > iter->second )
                  {
                     cl_iter->set_closest_cluster( cl2 );
                     iter->second = d2;
                  }
               if( d1 > d1_max )
               {
                  d1_max = d1;
                  cl1_max = cl_iter;
               }
               if( d2 > d2_max )
               {
                  d2_max = d2;
                  cl2_max = cl_iter;
               }
            }
         }
      }
      cluster_map[ cl1 ] = d1_max;
      cl1->set_closest_cluster( cl1_max );
      cluster_map[ cl2 ] = d2_max;
      cl2->set_closest_cluster( cl2_max );
   }
   else
   {
      if( clusters_parent_in_model )
         cluster_map[ cl1 ] = 0;//0 is an arbitrary value, hopefully not to be used
      if( cluster_in_model )
         cluster_map[ cl2 ] = 0;
   }
   // then update closeness contribution of all superclusters which contained cl2
   if( preserve_tree && !mcmc_sampling )
      while( proposed_parent_cl && proposed_parent_cl != proposed_original_cl )
      {
         proposed_parent_cl->set_closeness_contribution( calculate_closeness_contribution( proposed_parent_cl ) );
         proposed_parent_cl = proposed_parent_cl->get_parent_cluster();
      }
   return cl2;
}

void GLM_MVN_Clustering::undo_split_cluster( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   if( !heteroskedastic )
      proposed_ytd_vstar_dty_sum = 2 * current_ytd_vstar_dty_sum - proposed_ytd_vstar_dty_sum;
   Cluster_GLM_MVN* cl = execute_merge_part_one__merge_the_clusters( cl1, cl2 );
   if( !heteroskedastic )
      proposed_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum;
   execute_merge_part_two__update_cluster_map( cl );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::split_off_branch( Cluster_GLM_MVN*& cl1, list<int>* cl_subjects )
{
   if( cl_subjects && (int)cl_subjects->size() == cl1->get_num_subjects_allocated() )
      return NULL;

   Cluster_GLM_MVN *cl3, *cl2;
   cl1->get_clusters_allocated( cl3, cl2 );
   proposed_parent_cl = 0;
   if( cl_subjects )//drop down tree until one of the child clusters contains all of *cl_subjects
   {
      list<int> split_subjects = *cl_subjects;
      Cluster_GLM_MVN* cl4 = cl1->find_sub_cluster_containing_subjects( split_subjects );

      Cluster_GLM_MVN* cl5 = cl4->find_sub_cluster_containing_subjects( split_subjects );
      if( cl5 )
      {
         while( cl5 )
         {
            proposed_parent_cl = cl1;
            cl1 = cl4;
            cl4 = cl5;
            cl5 = cl4->find_sub_cluster_containing_subjects( split_subjects );
         }
         cl1->get_clusters_allocated( cl3, cl2 ); 
      }
      if( cl2 != cl4 )
         switch_values( cl2, cl3 );
   }
   else //with probability 1/2, switch cl2 and cl3 around so that the other gets snapped off - important if we are modifying the tree.
      if( !splitting_to_optimal && ( ( move_single_subjects_in_mcmc && preserve_tree && cl2->get_num_subjects_allocated() != 1 ) || ( preserve_tree && ( !move_single_subjects_in_mcmc || cl3->get_num_subjects_allocated() == 1 ) && gsl_ran_bernoulli( rn, 0.5 ) ) ) )
         switch_values( cl2, cl3 );

   switch_values( cl1, cl3 );
   if( is_cluster_in_model( cl3 ) )
      cluster_map.erase( cl3 );

   if( proposed_parent_cl )
   {
      list<Cluster_GLM_MVN*> parent_cls_allocated = proposed_parent_cl->get_clusters_allocated();
      parent_cls_allocated.remove( cl3 );
      parent_cls_allocated.push_back( cl1 );
      proposed_parent_cl->set_clusters_allocated( parent_cls_allocated );
      cl1->set_parent_cluster( proposed_parent_cl );
      cl1 = proposed_original_cl;
   }
   cl1->set_closeness_contribution( calculate_closeness_contribution( cl1 ) );
   if( kill_the_parent )
   {
      cl2->set_parent_cluster( NULL );
      if( Cluster_GLM_MVN::get_root_cluster() == cl3 )
         Cluster_GLM_MVN::set_root_cluster( cl1 );
      string* cl2_label = cl2->get_label();
      if( cl2_label && Cluster_GLM_MVN::get_root_cluster( *cl2_label ) == cl3 )
         Cluster_GLM_MVN::set_root_cluster( *cl2_label, cl1 );
      Cluster_GLM_MVN* cl3_parent = cl3->get_parent_cluster();
      cl3->set_parent_cluster( NULL );
      cl1->set_parent_cluster( cl3_parent );
      delete cl3;
   }
   else
   {
      cl1->set_parent_cluster( cl3 );
      cl2->set_parent_cluster( cl3 );
   }

   return cl2;
}

void GLM_MVN_Clustering::move_subjects( Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   execute_move_subjects( propose_move_subjects( cl1, cl2 ), cl1, cl2 );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::propose_move_subjects( Cluster_GLM_MVN*& cl1, Cluster_GLM_MVN*& cl2, list<int>* cl1_subjects )
{
   score_change = 0;
   bool cascade_from_cluster_in_model_store = cascade_from_cluster_in_model;
   int old_cl1_v_index = cl1->get_v_index();
   Cluster_GLM_MVN* cl1p = find_parent_in_model( cl1 );
   node_in_model_1 = cl1p;
   if( preserve_tree )
   {
      clusters_parent_in_model = is_cluster_in_model( cl1 );
      if( clusters_parent_in_model )
         node_in_model_1 = cl1;
   }
   double cl1_contribution = 0;
   if( node_in_model_1 )
   {
      cl1_contribution = node_in_model_1->get_closeness_contribution();
      if( preserve_model_with_tree_shifts )//then don't alter model
         cascade_from_cluster_in_model = 1;
   }

   if( node_in_model_1 && ( conditional_tree_distribution >= 2 && conditional_tree_distribution <= 4 ) )
   {
      node_in_model_1_score = node_in_model_1->get_score();
      if( node_in_model_1_score )
      {
	 if( conditional_tree_distribution != 4 )
	    score_change--;
	 else
	    score_change -= get_log_one_plus_alpha_catalan_number( node_in_model_1 );
      }
   }

   double change_contribution_sum = - cl1_contribution;
   Cluster_GLM_MVN* cl0;
   int num_cls_allocated = cl1->get_num_clusters_allocated();

   if( num_cls_allocated == 2 )
      cl0 = split_off_branch( cl1, cl1_subjects );
   else
       //if( move_type == SINGLE_SUBJECT_SHIFT )
           cl0 = cl1->split_cluster( cl1_subjects );
//       else
//           cl0 = cl1->split_cluster();

   if( preserve_tree )
   {
      if( cascade_from_cluster_in_model )
      {
         if( clusters_parent_in_model )
            childs_parent_in_model = cl1;
         else
            childs_parent_in_model = cl1p;
      }
      cluster_or_child_in_model = cluster_in_model = is_cluster_in_model( cl0 );
      if( !cl1p && !clusters_parent_in_model )//then cl0 is, or its children lower down the tree are, in the model, so treat as if it is.
         cluster_or_child_in_model = true;
      if( cascade_move_clusters )
         calculate_path_probability( cl0, cl1 );
      if( clusters_parent_in_model )
      {
         cluster_map[ cl1 ] = 0;//a dummy value, hopefully not to be used.
         cl1p = cl1;
         node_in_model_1 = cl1p;
      }
      if( cascade_move_clusters )
         cl2 = cascade_down_tree( cl0 );
      cluster_to_merge_in_model = is_cluster_in_model( cl2 );
   }
   Cluster_GLM_MVN* cl2p = find_parent_in_model( cl2 );

   if( !cl2p && cluster_to_merge_in_model && !cluster_or_child_in_model )
      cl2p = cl2;
   node_in_model_2 = cl2p;
   if( node_in_model_2 && node_in_model_2 != node_in_model_1 && ( conditional_tree_distribution >= 2 && conditional_tree_distribution <= 4 ) )
   {
      if( node_in_model_2->get_score() )
      {
	 if( conditional_tree_distribution != 4 )
	    score_change--;
	 else
	    score_change -= get_log_one_plus_alpha_catalan_number( node_in_model_2 );
      }
   }
   
   double change_in_log_ml = 0;

   if( cl1p && cl2p && cl1p != cl2p )//|| cluster_or_child_in_model )
   {
      altering_current_model = 1;
      int cl1s = cl1p->get_num_subjects_allocated();
      int cl2s = cl2p->get_num_subjects_allocated();
      int cl0s = cl0->get_num_subjects_allocated();
      if( heteroskedastic )
      {
         change_in_log_ml += calculate_closeness( cl0, cl2p ) + cl0->get_closeness_contribution();
         if( cl1p )
            change_in_log_ml += change_contribution_sum + cl1p->get_closeness_contribution();
      }
      else
      {
         if( num_cls_allocated == 2 )
            proposed_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum - cl1_contribution + cl1p->get_closeness_contribution() + cl0->get_closeness_contribution();
         change_contribution_sum -= cl2p->get_closeness_contribution();
//         num_obsns_working = gsl_matrix_int_calloc( 1, dim_num_obsns );
         gsl_matrix_int* cl0n = gsl_matrix_int_alloc( 1, dim_num_obsns );
         gsl_matrix_int_memcpy( cl0n, cl0->get_num_obsns() );
         gsl_matrix_int* cl1n = 0;
         if( cl1p )
         {
            cl1n = gsl_matrix_int_alloc( 1, dim_num_obsns );
            gsl_matrix_int_memcpy( cl1n, cl1p->get_num_obsns() );
         }
         gsl_matrix_int* cl2n = gsl_matrix_int_alloc( 1, dim_num_obsns );
         gsl_matrix_int_memcpy( cl2n, cl2p->get_num_obsns() );
         gsl_matrix_int* cl02n = gsl_matrix_int_alloc( 1, dim_num_obsns );
         gsl_matrix_int_memcpy( cl02n, cl0n );
         gsl_matrix_int_add( cl02n, cl2n );
         gsl_matrix_int* cl01n = gsl_matrix_int_alloc( 1, dim_num_obsns );
         gsl_matrix_int_memcpy( cl01n, cl0n );
         if( cl1n )
            gsl_matrix_int_add( cl01n, cl1n );
         gsl_matrix* cl02y = gsl_matrix_alloc( p_y, yty_cols );
         gsl_matrix_memcpy( cl02y, cl0->get_yty() );
         gsl_matrix_add( cl02y, cl2p->get_yty() );
         gsl_matrix* cl02d = gsl_matrix_alloc( p_y, ytd_cols );
         gsl_matrix_memcpy( cl02d, cl0->get_ytd() );
         gsl_matrix_add( cl02d, cl2p->get_ytd() );
         gsl_matrix *cl01dd = 0, *cl02dd = 0;
         if( !inputs_repeated_every )
         {
            cl01dd = gsl_matrix_alloc( num_design_cols, dtd_cols );
            cl02dd = gsl_matrix_alloc( num_design_cols, dtd_cols ); 
            gsl_matrix_memcpy( cl01dd, cl0->get_dtd() ); 
            gsl_matrix_memcpy( cl02dd, cl01dd );
            gsl_matrix_add( cl01dd, cl1p->get_dtd() );
            gsl_matrix_add( cl02dd, cl2p->get_dtd() );
         }

         change_contribution_sum += cl1p->get_closeness_contribution();
         change_contribution_sum += calculate_closeness_contribution( cl02n, cl02y, cl02d, cl02dd );
         second_proposed_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum + change_contribution_sum;
         change_in_log_ml += a_star_lookup[ 0 ] * ( log( yty_total - current_ytd_vstar_dty_sum ) - log( yty_total - second_proposed_ytd_vstar_dty_sum ) );
         set_v_index( old_cl1_v_index );
         change_in_log_ml -= half_log_det_vstar( cl01n );
         set_v_index( cl2->get_v_index() );
         change_in_log_ml -= half_log_det_vstar( cl2n );
         set_v_index( cl1p->get_v_index() );
         change_in_log_ml += half_log_det_vstar( cl1n );
         set_v_index( optimal_v_index );
         change_in_log_ml += half_log_det_vstar( cl02n );
         if( !inputs_repeated_every )
         {
            change_in_log_ml += get_half_lndet_invvinvplusdtd( cl02dd ) - get_half_lndet_invvinvplusdtd( cl2p );
            change_in_log_ml += get_half_lndet_invvinvplusdtd( cl1p ) - get_half_lndet_invvinvplusdtd( cl01dd );
         }
         gsl_matrix_int_free( cl0n );
         if( cl1n )
            gsl_matrix_int_free( cl1n );
         gsl_matrix_int_free( cl2n );
         gsl_matrix_int_free( cl01n );
         gsl_matrix_int_free( cl02n );
         gsl_matrix_free( cl02y );
         gsl_matrix_free( cl02d );
         if( !inputs_repeated_every )
         {
            gsl_matrix_free( cl01dd );
            gsl_matrix_free( cl02dd );
         }
      }
      change_in_log_ml += log_prior_cluster_size[ cl1s ] + log_prior_cluster_size[ cl0s + cl2s ]- log_prior_cluster_size[ cl1s + cl0s ] - log_prior_cluster_size[ cl2s ];
      if( preserve_tree )
      {
         if( conditional_tree_distribution == 1 )
            LogProposalRatio += get_uniform_tree_log_prior_change( cl2s, cl0s ) - get_uniform_tree_log_prior_change( cl1s, cl0s );
         else if( conditional_tree_distribution == 3 || conditional_tree_distribution == 4 )
            proposed_tree_log_normalising_constant += get_log_catalan_number( cl2s + cl0s ) - get_log_catalan_number( cl2s ) + get_log_catalan_number( cl1s ) - get_log_catalan_number( cl1s + cl0s );
      }
   }
   else
   {
      altering_current_model = 0;
      if( !heteroskedastic )
         second_proposed_ytd_vstar_dty_sum = proposed_ytd_vstar_dty_sum;
   }
   if( preserve_model_with_tree_shifts )
      cascade_from_cluster_in_model = cascade_from_cluster_in_model_store;

   if( ( conditional_tree_distribution >= 2 && conditional_tree_distribution <= 4 ) && !stop_cascading_at_model )
      proposed_tree_score += score_change;

   proposed_log_likelihood = log_likelihood + change_in_log_ml;
   proposed_BIC = BIC + change_in_log_ml;
   return cl0;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::propose_move_subject( Cluster_GLM_MVN*& cl1, Cluster_GLM_MVN*& cl2, int cl1_subject )
{
   list<int> cl_subjects;
   cl_subjects.push_back( cl1_subject );
   return propose_move_subjects( cl1, cl2, &cl_subjects );
}
    
Cluster_GLM_MVN* GLM_MVN_Clustering::execute_move_subjects( Cluster_GLM_MVN* cl0, Cluster_GLM_MVN* cl1, Cluster_GLM_MVN* cl2 )
{
   execute_split_cluster( cl1, cl0 );
   if( !heteroskedastic )
      proposed_ytd_vstar_dty_sum = current_ytd_vstar_dty_sum + second_proposed_ytd_vstar_dty_sum - proposed_ytd_vstar_dty_sum;
   executing_move_subjects = 1;
   Cluster_GLM_MVN* cl = execute_merge_part_one__merge_the_clusters( cl2, cl0 );
   executing_move_subjects = 0;
   if( !heteroskedastic )
      proposed_ytd_vstar_dty_sum = second_proposed_ytd_vstar_dty_sum;
   if( !preserve_tree || ( !cluster_or_child_in_model && cluster_to_merge_in_model ) )
      execute_merge_part_two__update_cluster_map( cl );
   if( preserve_tree && ( conditional_tree_distribution >= 2 && conditional_tree_distribution <= 4 ) )
   {
      if( node_in_model_1 == cl2 && !cluster_in_model )
         node_in_model_1 = cl;
      if( node_in_model_2 == cl2 && !cluster_in_model )
         node_in_model_2 = cl;
      bool nodes_in_model_the_same = node_in_model_2 == node_in_model_1;
      node_in_model_1 = find_parent_in_model( cl1 );
      if( !node_in_model_1 && clusters_parent_in_model )
         node_in_model_1 = cl1;
      if( stop_cascading_at_model && ( node_in_model_1 || node_in_model_2 ) )
         tree_score += score_change;
      proposed_tree_score = tree_score;
      if( node_in_model_1 )
      {
         if( !stop_cascading_at_model )
            node_in_model_1->set_score( node_in_model_1_proposed_score );
         else
	 {
            node_in_model_1->set_score( 0 );
            sample_model_node_subtree_from_full_conditional( node_in_model_1 );
	 }
         if( nodes_in_model_the_same )
            node_in_model_2 = node_in_model_1;
      }
      if( node_in_model_2 && !nodes_in_model_the_same )
      {
         if( !stop_cascading_at_model )
            node_in_model_2->set_score( node_in_model_2_proposed_score );
         else
         {
            node_in_model_2->set_score( 0 );
            sample_model_node_subtree_from_full_conditional( node_in_model_2 );
         }
      }
   }
   return cl;
}

void GLM_MVN_Clustering::undo_move_subjects( Cluster_GLM_MVN* cl0, Cluster_GLM_MVN* cl1 )
{
   if( !heteroskedastic )
      proposed_ytd_vstar_dty_sum = 2 * current_ytd_vstar_dty_sum - proposed_ytd_vstar_dty_sum;
   Cluster_GLM_MVN* cl = cl1->merge_cluster( cl0 );
   if( clusters_parent_in_model )
   {
      cluster_map.erase( cl1 );
      cluster_map[ cl ] = 0;//a dummy value, hopefully not to be used;
      if( conditional_tree_distribution >= 2 && conditional_tree_distribution <= 4 )
         cl->set_score( node_in_model_1_score );
   }
}

void GLM_MVN_Clustering::merge()
{
   best_merge_for_cluster();
}

void GLM_MVN_Clustering::merge_until_desired_num_clusters( bool write_merger_details )
{
   if( v_grid_size == 1 )
   {
      calculate_inter_cluster_closeness();
      merge_until( desired_num_clusters, write_merger_details );
   }
   else
   {
      if( !best_merger_details )
         create_zeroed_array( best_merger_details, merger_details_rows, merger_details_cols );
      if( !best_dendrogram )
         best_dendrogram = new int[ num_subjects ];
      double v_max = v_multiplier;
      double log10_v_range = log10( v_range );
      double log10_v_start = log10( v_multiplier ) - log10_v_range / 2.0;
      for( int i = 0; i < v_grid_size; i++ )
      {
         double old_v_multiplier = v_multiplier;
         double old_max_log_likelihood = max_log_likelihood;
         v_multiplier = pow( 10, log10_v_start + (double)i / (double)( v_grid_size - 1 ) * log10_v_range );
         if( !non_conjugate_model && number_of_vs == 1 )
            ml_const -= 0.5 * p_y * dim_V * log( v_multiplier / old_v_multiplier );
         if( V_ )
            gsl_matrix_scale( V_, v_multiplier / old_v_multiplier );
         gsl_matrix_scale( V_inv, old_v_multiplier / v_multiplier );
         empty_vstar_map();
         cout << " V = " << v_multiplier << endl;;
         restart_subjects_in_own_clusters();
         merge_until( desired_num_clusters, write_merger_details );
         if( max_log_likelihood > old_max_log_likelihood )
         {
            v_max = v_multiplier;
            switch_values( merger_details, best_merger_details );
            switch_values( dendrogram, best_dendrogram );
         }
      }
      if( !non_conjugate_model && number_of_vs == 1 )
         ml_const -= 0.5 * p_y * dim_V * log( v_max / v_multiplier );
      if( V_ )
         gsl_matrix_scale( V_, v_max /v_multiplier );
      gsl_matrix_scale( V_inv, v_multiplier / v_max );
      v_multiplier = v_max;
      cout << " Maximizing V = " << v_multiplier << endl;
      switch_values( merger_details, best_merger_details );
      switch_values( dendrogram, best_dendrogram );
      for( int j = 0; j < num_subjects; j++ )
         inverse_dendrogram[ dendrogram[ j ] ] = j;
      empty_vstar_map();
      calculate_inter_cluster_closeness();
   }

   if( print_to_screen && number_of_models_evaluated )
      cout << number_of_models_evaluated << " models evaluated so far." << endl;


   if( ( !unimodal_bic_function && ( ( bic_criterion == 1 && BIC < max_BIC ) || ( bic_criterion == 2 && log_likelihood < max_log_likelihood ) ) ) || ( !bic_criterion && desired_num_clusters > 1 ) )
      split_to_optimal_clustering();
   else
      number_of_clusters = cluster_map.size() - number_unmergeable;

   if( euclidean_or_correlation_clustering || heller_algorithm )
   {
      int euclidean_or_correlation_clustering_store = euclidean_or_correlation_clustering;
      euclidean_or_correlation_clustering = 0;
      heller_algorithm = false;
      calculate_closeness_contributions();
      number_of_models_evaluated -= number_of_clusters;
      calculate_log_likelihood();
      log_likelihood = proposed_log_likelihood;
      BIC = proposed_BIC;
      if( print_to_screen )
         cout << number_of_clusters << " clusters,  log marginal likelihood = " << log_likelihood << "  BIC = " << BIC << endl;
      euclidean_or_correlation_clustering = euclidean_or_correlation_clustering_store;
   }
   if( print_to_screen && bic_criterion )
   {
      cout << number_of_clusters << " clusters is optimal,  log marginal likelihood = " << log_likelihood;
      if( bic_criterion == 1 )
         cout << "  BIC = " << BIC;
      cout << endl;
   }

   update_any_stats();

   if( print_to_screen )
   {
     //      cout << "Number of (mergeable) clusters = " << number_of_clusters << endl;
      cout << "Number of clusters = " << number_of_clusters << endl;
      cout << "(" << number_of_singleton_clusters << " singleton clusters)"<< endl;
      cout << "Log marginal probability = " << log_likelihood << endl;
      if( max_map_allocation_sweeps )
	 cout << "Total number of reallocations performed = " << total_number_of_reallocations << ", involving " << get_num_subjects_ever_reallocated() << " subjects." << endl;
   }

   if( hier_discrim )
      model_weight = 1;
   else
   {
      calculate_cluster_label_probabilities();
      update_mean_label_probabilities();
   }
   singletons_require_best_friend = 0;
   nn_constraint = false;
   worst_first = false;
   if( simulate_data )
      sample_clusters_from_prior();
}

void GLM_MVN_Clustering::merge_until( int n_clust, bool write_merger_details )
{
   ofstream AllPartitionsStream;
   if( output_all_partitions && strlen( All_Partitions_Output_Filename ) )
      AllPartitionsStream.open( All_Partitions_Output_Filename, ios::out );

   number_of_clusters = get_number_mergeable_in_cluster_map();
   if( n_clust > number_of_clusters )
   {
      cout << "Cannot merge down to " << n_clust << " clusters, only have " << number_of_clusters << " to start with" << endl;
      exit(1);
   }
   if( n_clust < minimum_num_clusters )
      n_clust = minimum_num_clusters;

   if( hier_discrim || association_matrix )
   {
      starting_log_likelihood = log_likelihood;
      model_weight = 1;
      if( hier_discrim )
      {
         calculate_cluster_label_probabilities();
         update_mean_label_probabilities();
      }
   }
   
   if( !dendrogram_scores )
      dendrogram_scores = new double[ num_subjects ];
   dendrogram_scores[number_of_clusters - 1] = bic_criterion == 1 ? BIC : log_likelihood;

   if( !unimodal_bic_function && ( ( bic_criterion == 1 && BIC > max_BIC ) || ( bic_criterion == 2 && log_likelihood > max_log_likelihood ) ) )
      update_optimal_clustering();//max_log_likelihood = log_likelihood;
   if( write_merger_details )
   {
      update_merger_details_first_row();
      write_closeness_matrix_to_file();
   }

   if( check_allocations_at_each_merger && number_of_clusters < num_subjects && !nn_constraint )//don't bother while nn_constraint is on.
      check_allocations_after_merger();
   
   int smallest_subject = 0;
   int effective_lowest_number_of_clusters_visited = number_of_clusters;
   int progress_gap = 0, maximum_progress_gap = 10;//when we allow new clusters to be formed during agglomerative clustering, if this maximum_progress_gap is exceeded without reducing effective_lowest_number_of_clusters_visited, we stop allowing new clusters.
   bool originally_allow_variable_dimension_allocation_sweeps_at_each_merger = variable_dimension_allocation_sweeps_at_each_merger;

   if( timing_agglomerative_clustering )
   {
       iteration_time = time = clock();
       TimingStream << number_of_clusters << "\t" << 0 << endl;
   }

   bool time_to_update = false, ready_to_update = true;
   while( number_of_clusters > minimum_num_clusters )
   {
      if( print_to_screen )
      {
         cout << number_of_clusters - number_unmergeable << " clusters";
         if( !euclidean_or_correlation_clustering )
         {
            cout << ",  log marginal likelihood = " << log_likelihood;
            if( bic_criterion == 1 )
               cout << "  BIC = " << BIC;
         }
         else
            cout << ", objective score = " << log_likelihood;
         cout << "   ..." << endl;
      }

      if( input_merger_details )
	 find_next_input_merger();
      else
      {
	 if( stochastic_agglomeration )
	    find_random_best_merger();
	 else
	    find_best_merger();
      }
      most_mergeable_cluster_size = most_mergeable_cluster->get_num_subjects_allocated();
      most_mergeable_clusters_closest_size = most_mergeable_clusters_closest->get_num_subjects_allocated();
      propose_best_merger();
      if( print_to_screen )
      {
         cout << " (Number of subjects in optimal clusters for merger = " << most_mergeable_cluster_size << ", " << most_mergeable_clusters_closest_size << ")" << endl;
	 if( heller_algorithm )
	   cout << "  [r_k=" << exp(heller_log_r) << ", pi_k=" << heller_pi << "]" << endl;
      }
      if( output_all_partitions )
      {
	 update_current_clustering();
	 for( int sub = 0; sub < num_subjects; sub++ )
	    AllPartitionsStream << current_clustering[ sub ] << " ";
	 AllPartitionsStream << endl;
      }

      if( unimodal_bic_function && ( ( bic_criterion == 1 && proposed_BIC < BIC ) || ( bic_criterion == 2 && proposed_log_likelihood < log_likelihood ) ) )
      {
         if( print_to_screen )
         {
            cout << number_of_clusters - number_unmergeable - 1 << " clusters,  would have ";
            if( !euclidean_or_correlation_clustering )
            {
               cout << "marginal likelihood = " << proposed_log_likelihood;
               if( bic_criterion == 1 )
                  cout << "  BIC = " << proposed_BIC;
            }
            else
               cout << "objective score = " << proposed_log_likelihood;
            cout << "   ..." << endl;
         }
         number_of_clusters = 0;//breaks the while loop as BIC has been maixmised
      }
      else
      {
         double old_max_log_likelihood = max_log_likelihood;
         time_to_update = ( ( !unimodal_bic_function && ( ( bic_criterion == 1 && proposed_BIC < BIC && BIC >= max_BIC ) || ( bic_criterion == 2 && proposed_log_likelihood < log_likelihood && log_likelihood >= max_log_likelihood ) ) ) || ( bic_criterion == 0 && number_of_clusters - number_unmergeable == n_clust ) );
	 //	 if( heller_algorithm )
	 //	    time_to_update = ready_to_update && (heller_log_r < -LOG_TWO);
	 if( time_to_update )
            update_optimal_clustering();
	 if( heller_algorithm )
	 {
	    if( time_to_update )
	       ready_to_update = false;
	    else if( !ready_to_update )
	       ready_to_update = heller_log_r > -LOG_TWO;
	 }

         if( write_merger_details )
            smallest_subject = update_merger_details();
         else if( check_allocations_at_each_merger && variable_dimension_allocation_sweeps )
         {
             most_mergeable_cluster_smallest_subject = most_mergeable_cluster->get_smallest_subject_allocated();
             most_mergeable_clusters_closest_smallest_subject = most_mergeable_clusters_closest->get_smallest_subject_allocated();
         }
         if( check_allocations_at_each_merger )
         {
             int pos = find_position_in_cluster_map( most_mergeable_clusters_closest );
	     array_delete_column( membership_contributions, pos, num_subjects, number_of_clusters, true );
         }
	 if( nn_constraint && number_of_clusters == (nn_equivalence_relation_partition_size + 1) )
	 {
            if( nn_constraint )
               Cluster_GLM_MVN::set_using_types( false );
            nn_constraint = false;
//	    singletons_require_best_friend = 0;
	    calculate_inter_cluster_closeness( cluster_map );
	 }
         if( subjects_first_merge )
            update_subjects_first_merge();
	 if( most_mergeable_cluster->is_singleton_cluster() )
	    number_of_singleton_clusters--;
	 if( most_mergeable_clusters_closest->is_singleton_cluster() )
	    number_of_singleton_clusters--;
         merge();

         if( write_merger_details )
            write_ammended_closeness_matrix_to_file( smallest_subject );
         if( hier_discrim || association_matrix )
            model_weight = exp( log_likelihood - max_log_likelihood );
	 //         if( log_likelihood > max_log_likelihood )
	 //            max_log_likelihood = log_likelihood;
         number_of_clusters--;
         if( originally_allow_variable_dimension_allocation_sweeps_at_each_merger )
         {
            if( number_of_clusters < effective_lowest_number_of_clusters_visited || max_log_likelihood > old_max_log_likelihood )
            {
               effective_lowest_number_of_clusters_visited = number_of_clusters;
               progress_gap = 0;
               variable_dimension_allocation_sweeps_at_each_merger = originally_allow_variable_dimension_allocation_sweeps_at_each_merger;
            }
            else
               if( ++progress_gap > maximum_progress_gap )
               {
                  variable_dimension_allocation_sweeps_at_each_merger = false;
//                  if( print_to_screen )
//                     cout << "-----Suspending allowance of new clusters to be formed during agglomerative clustering-----" << endl;
               }
         }
         if( check_allocations_at_each_merger && !nn_constraint && !input_merger_details )//don't bother while nn_constraint is on or we are taking mergers directly from an input.
            check_allocations_after_merger();
         if( timing_agglomerative_clustering )
         {
             clock_t new_iteration_time = clock();
             double time_change = (double)( new_iteration_time - iteration_time ) * 1000.0 / CLOCKS_PER_SEC;
             iteration_time = new_iteration_time;
             TimingStream << number_of_clusters << "\t" << time_change << endl;
         }
         if( number_of_clusters == number_of_cluster_types )
         {
             Cluster_GLM_MVN::set_using_types( false );
             number_of_cluster_types = 0;
             calculate_inter_cluster_closeness( cluster_map );
         }
         if( hier_discrim )
         {
            string* sptr = most_mergeable_cluster->get_label();
            int j = 0, j_max = mergeable_cluster_deque.size();
            Cluster_GLM_MVN* cl_ptr;
            bool found_it = 0;
            while( !found_it && j < j_max )
            {
               cl_ptr = *mergeable_cluster_deque.begin();
               mergeable_cluster_deque.pop_front();
               if( cl_ptr == most_mergeable_clusters_closest )
                  found_it = 1;
               else
                  mergeable_cluster_deque.push_back( cl_ptr );
               j++;
            }
            if( sptr )
               update_cluster_label_probabilities( *sptr );
            model_weight = exp( log_likelihood - starting_log_likelihood );
            update_mean_label_probabilities();
         }
         if( dendrogram_scores )
            dendrogram_scores[number_of_clusters - 1] = bic_criterion == 1 ? BIC : log_likelihood;
         if( association_matrix )
            increment_association_matrix();// &model_weight );
         if( euclidean_or_correlation_clustering )
         {
            calculate_log_likelihood();
            if( write_merger_details )
           {
               merger_details[ merger_details_rows - number_of_clusters ][ merger_details_cols - 2 ] = proposed_log_likelihood;
               merger_details[ merger_details_rows - number_of_clusters ][ merger_details_cols - 1 ] = proposed_BIC;
            }
         }
      }
   }
   time_to_update = ( ( ( bic_criterion == 1 && BIC >= max_BIC ) || ( bic_criterion == 2&& log_likelihood >= max_log_likelihood )  ) || ( bic_criterion == 0 && number_of_clusters - number_unmergeable == n_clust ) );
	 //	 if( heller_algorithm )
	 //	    time_to_update = ready_to_update && (heller_log_r < -LOG_TWO);
   if( time_to_update )
       update_optimal_clustering();
   if( output_all_partitions )
   {
      update_current_clustering();
      for( int sub = 0; sub < num_subjects; sub++ )
	 AllPartitionsStream << current_clustering[ sub ] << " ";
      AllPartitionsStream << endl;
   }
   
   most_mergeable_cluster = NULL;
   if( check_allocations_at_each_merger )
   {
      if( map_memberships )
	 for( int i = 0; i < num_subjects; i++ )
	    map_memberships[ i ] = -2;
      //      zap_array( membership_contributions, num_subjects, num_subjects + 1 );
      //      zap_array( membership_probability, num_subjects, membership_probability_dim );
//      reduce_closeness_matrix = reduce_closeness_matrix_store;
   }
   if( reduce_closeness_matrix )
      zap_array( closeness_matrix, num_subjects, num_subjects );

   write_association_matrix_to_file();
   write_subjects_first_merge_to_file();
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( (iter->first)->get_mergeable() )
      {
         string* cl_label = 0;
         if( cluster_by_labels )
            cl_label = (iter->first)->get_label();
         if( cluster_by_labels && cl_label )
            Cluster_GLM_MVN::set_root_cluster( *cl_label, iter->first );
         else
            Cluster_GLM_MVN::set_root_cluster( iter->first );
      }
   store_when_subjects_first_merge = false;

   if( print_to_screen && ( !bic_criterion || number_of_clusters == minimum_num_clusters ) )
   {
      cout << number_of_clusters - number_unmergeable << " clusters";
      if( !euclidean_or_correlation_clustering )
      {
         cout << ",  log marginal likelihood = " << log_likelihood;
         if( bic_criterion == 1 )
            cout << "  BIC = " << BIC;
         cout << "   ...";
      }
      cout << endl;
   }
   update_dendrogram();
}

void GLM_MVN_Clustering::check_allocations_after_merger()
{
   long store_max_map_allocation_sweeps = max_map_allocation_sweeps;
   max_map_allocation_sweeps = check_at_each_max_map_allocation_sweeps;
   bool store_variable_dimension_allocation_sweeps = variable_dimension_allocation_sweeps;
   bool store_one_reallocation_per_sweep = one_reallocation_per_sweep;
   long store_desired_num_clusters = desired_num_clusters;
   int store_subject_not_allowed_to_move = subject_not_allowed_to_move;
   int store_subject2_not_allowed_to_move = subject2_not_allowed_to_move;
   if( !variable_dimension_allocation_sweeps_at_each_merger )
      variable_dimension_allocation_sweeps = false;
//   one_reallocation_per_sweep = true;
   desired_num_clusters = number_of_clusters;
   checking_memberships_during_clustering = true;
//             bool store_vbl = storing_cluster_closenesses;
//             storing_cluster_closenesses = false;
   int map_allocation_sweep_store = map_allocation_sweep;
   if( variable_dimension_allocation_sweeps )
   {
       if( most_mergeable_cluster_size == 1 )
          subject_not_allowed_to_move = most_mergeable_cluster_smallest_subject;
       if( most_mergeable_clusters_closest_size == 1 )
          subject2_not_allowed_to_move = most_mergeable_clusters_closest_smallest_subject;
   }
   calculate_membership_probabilities();
   subject_not_allowed_to_move = store_subject_not_allowed_to_move;
   subject2_not_allowed_to_move = store_subject2_not_allowed_to_move;
//             storing_cluster_closenesses = store_vbl;
   checking_memberships_during_clustering = false;
//	    	    cout << log_likelihood<< ", lik should be " << calculate_log_likelihood() << endl;
//	    		if( significantly_different( log_likelihood, proposed_log_likelihood, .1 ) )exit(1);
   variable_dimension_allocation_sweeps = store_variable_dimension_allocation_sweeps;
   one_reallocation_per_sweep = store_one_reallocation_per_sweep;
   desired_num_clusters = store_desired_num_clusters;
   map_allocation_sweep = map_allocation_sweep_store;
   max_map_allocation_sweeps = store_max_map_allocation_sweeps;
   if( merger_details )//alter the merger details likelihood, BIC now the model has changed
   {
      merger_details[ merger_details_rows + ( minimum_num_clusters - 1 ) - number_of_clusters ][ merger_details_cols - 2 ] = proposed_log_likelihood;
      merger_details[ merger_details_rows + ( minimum_num_clusters - 1 ) - number_of_clusters ][ merger_details_cols - 1 ] = proposed_BIC;
   }
}

void GLM_MVN_Clustering::increment_association_matrix( double* increment_ptr )
{
   double increment = 1;
   if( increment_ptr )
   {
      if( *increment_ptr < 1 )
         increment = *increment_ptr;
      else
         for( int i = 0; i < num_subjects; i++ )
            for( int j = 0; j < num_subjects; j++ )
               association_matrix[ i ][ j ] /= *increment_ptr;
   }
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
   {
      list<int> subs_alloc = iter->first->get_subjects_allocated();
      for( list<int>::iterator iter1 = subs_alloc.begin(); iter1 != subs_alloc.end(); ++iter1 )
         for( list<int>::iterator iter2 = iter1; iter2 != subs_alloc.end(); ++iter2 )
         {
            association_matrix[ *iter1 ][ *iter2 ] += increment;
            if( *iter1 != *iter2 )
               association_matrix[ *iter2 ][ *iter1 ] += increment;
         }
   }
}

void GLM_MVN_Clustering::normalise_association_matrix()
{
   if( !association_matrix )
      return;
   double first_entry = association_matrix[ 0 ][ 0 ];
   if( first_entry )
      for( int i = 0; i < num_subjects; i++ )
	 for( int j = 0; j < num_subjects; j++ )
	    association_matrix[ i ][ j ] /= first_entry;
}

int* GLM_MVN_Clustering::argmax_association_matrix()
{
   int* arg_max = new int[2];
   arg_max[ 0 ] = 0;
   arg_max[ 1 ] = 1;
   double max = association_matrix[ 0 ][ 1 ];
   for( int i = 0; i < num_subjects; i++ )
      for( int j = i+1; j < num_subjects; j++ )
         if( max < association_matrix[ i ][ j ] )
         {
            max = association_matrix[ i ][ j ];
            arg_max[ 0 ] = i;
            arg_max[ 1 ] = j;
         }
   return arg_max;
}
   
int GLM_MVN_Clustering::rebuild_agglomerative_tree_from_cluster( Cluster_GLM_MVN*& cl, bool permanent, bool optimal )
{
   int num_clusters_in_map, num_differences = 0;
   cluster_ptrtodbl map_of_clusters;
   bool store_status = store_data_throughout_tree, mcmc_status = mcmc_sampling;
   if( !permanent )
   {
      map_of_clusters = cl->get_single_subject_clusters_allocated( permanent );
      num_clusters_in_map = map_of_clusters.size();
   }
   else
      num_clusters_in_map = cl->get_num_single_subject_clusters_allocated();
   if( num_clusters_in_map <= 2 )
      return 1;
   Cluster_GLM_MVN* cl_root = NULL;
   if( permanent )
   {
      cl_root = cl->get_my_root_cluster();
      map_of_clusters = cl->get_single_subject_clusters_allocated( permanent );
      store_data_throughout_tree = true;
      mcmc_sampling = false;
      if( !closeness_matrix )
      {
         closeness_matrix = new double* [ num_subjects ];
         closeness_matrix[ 0 ] = 0;
         for( int i = 1; i < num_subjects; i++ )
            closeness_matrix[ i ] = new double[ i ];
      }
   }

   calculate_inter_cluster_closeness( map_of_clusters );
   Cluster_GLM_MVN* cl_new;
   cluster_ptrtodbl::iterator iter;
   bool zero_one = true;

   for( int i = num_clusters_in_map; i > 1; i-- )
   {
      if( optimal )
      {
         max_closeness = -DBL_MAX;
         most_mergeable_clusters_closest = most_mergeable_cluster = NULL;
         for( iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
         {
            Cluster_GLM_MVN* closest = (iter->first)->get_closest_cluster();
            if( closest )
            {
               double closeness = iter->second;
               if( max_closeness < closeness )
               {
                  max_closeness = closeness;
                  most_mergeable_cluster = iter->first;
                  most_mergeable_clusters_closest = closest;
               }
            }
         }
      }
      else
      {
         int clnum1 = (int)gsl_rng_uniform_int( rn, i );
         int clnum2 = (int)gsl_rng_uniform_int( rn, i - 1 );
         if( clnum2 == clnum1 )
            clnum2 = i - 1;
         else if ( clnum2 < clnum1 )
            switch_values( clnum1, clnum2 );
         iter = map_of_clusters.begin();
         for( int j = 0; j < clnum2; j++ )
         {
            if( j == clnum1 )
               most_mergeable_cluster = iter->first;
            ++iter;
         }
         most_mergeable_clusters_closest = iter->first;
      }
      if( !permanent && preserve_tree )
      {
         if( most_mergeable_clusters_closest != most_mergeable_cluster->get_sibling_cluster() )
            num_differences++;
         if( zero_one && num_differences )
            return 0;
      }
      map_of_clusters.erase( most_mergeable_cluster );
      map_of_clusters.erase( most_mergeable_clusters_closest );
      if( preserve_tree )
      {
         if( permanent )
            cl_new = new Cluster_GLM_MVN( most_mergeable_cluster, most_mergeable_clusters_closest, !permanent );
         else
            cl_new = most_mergeable_cluster->get_parent_cluster(); 
      }
      else
         cl_new = most_mergeable_cluster->merge_cluster( most_mergeable_clusters_closest );
      Cluster_GLM_MVN *cl_max = NULL, *cl_iter = NULL;
      double d, d_max = -DBL_MAX;
      if( optimal )
      {
         for( iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
         {
            cl_iter = iter->first;
            if( cl_iter->get_mergeable() )
            {
               d = cl_new->get_cluster_closeness( cl_iter, false );
               if( d > d_max )
               {
                  d_max = d;
                  cl_max = cl_iter;
               }
               Cluster_GLM_MVN* closest = cl_iter->get_closest_cluster();
               if( ( closest == most_mergeable_cluster || closest == most_mergeable_clusters_closest ) && d < iter->second )
	       {
                  if( closeness_matrix )
                     iter->second = cl_iter->find_closest_cluster( &map_of_clusters );
                  else
                     iter->second = calculate_closest_cluster( cl_iter, map_of_clusters );
	       }
               if( d > iter->second )
               {
                  cl_iter->set_closest_cluster( cl_new );
                  iter->second= d;
               }
            }
         }
         cl_new->set_closest_cluster( cl_max );
      }
      map_of_clusters[ cl_new ] = d_max;
      if( !preserve_tree && i == 3 )
      {
         if( !proposed_subject_list )
            proposed_subject_list = new list<int>;
         *proposed_subject_list = cl_new->get_subjects_allocated();
      }
   }

   if( !permanent )
   {
      if( zero_one )
         return 1;
      else
         return num_clusters_in_map - minimum_num_clusters - num_differences;
   }
   else
   {
      Cluster_GLM_MVN* cl_parent = cl->get_parent_cluster();
      cl_new->set_parent_cluster( cl_parent );
      if( cl_parent )
         cl_parent->remove_allocated_cluster( cl );
      else if( cl_root == cl )
         cl_new->set_my_root_cluster( cl_new );
      if( is_cluster_in_model( cl ) )
      {
         cluster_map[ cl_new ] = cluster_map[ cl ];
         cluster_map.erase( cl );
      }
      delete cl;
      cl = cl_new;
   }
   zap_array( closeness_matrix, num_subjects, num_subjects );
   store_data_throughout_tree = store_status;
   mcmc_sampling = mcmc_status;
   return 1;
}


void GLM_MVN_Clustering::sample_model_node_subtree_from_full_conditional( Cluster_GLM_MVN*& cl )
{
   double log_prob = get_optimal_subtree_log_prob( cl->get_num_subjects_allocated() );
   double u = 0;
   if( log_prob < 0 )
      u = log( gsl_ran_flat( rn, 0, 1 ) );
   if( u <= log_prob )
   {
      if( !cl->get_score() )
      {
         rebuild_agglomerative_tree_from_cluster( cl, true );
         cl->set_score( 1 );
         if( conditional_tree_distribution != 4 )
            tree_score++;
         else
            tree_score += get_log_one_plus_alpha_catalan_number( cl );
         proposed_tree_score = tree_score;
      }
   }
   else
   {
      if( cl->get_score() )
      {
         if( conditional_tree_distribution != 4 )
            tree_score--;
         else
            tree_score -= get_log_one_plus_alpha_catalan_number( cl );
         proposed_tree_score = tree_score;
      }
      do
      {
         rebuild_agglomerative_tree_from_cluster( cl, true, false );
      } while( rebuild_agglomerative_tree_from_cluster( cl, false ) );
      cl->set_score( 0 );
   }
}

void GLM_MVN_Clustering::update_current_clustering()
{
   if( !current_clustering )
      current_clustering = new int[ num_subjects ];
   int counter = 0;
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( iter->first->get_mergeable() )
      {
         list<int> cl_subjects = iter->first->get_subjects_allocated();
	 bool not_proper_cluster = false;//singleton_clusters_uniformly_distributed && iter->first->is_singleton_cluster();
         for( list<int>::iterator iter2 = cl_subjects.begin(); iter2 != cl_subjects.end(); iter2++ )
	 {
	    if( not_proper_cluster )
	      current_clustering[ *iter2 ] = -1;
	    else
	       current_clustering[ *iter2 ] = counter;
	 }
	 if( !not_proper_cluster )
	    counter++;
      }
}

void GLM_MVN_Clustering::update_optimal_clustering()
{
   cluster_ptrtodbl::iterator iter;
   if( minimum_cluster_size > 1 || no_optimal_clusters_totally_missing_experiments )
      for( iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      {
	 if( minimum_cluster_size > 1 && iter->first->get_num_subjects_allocated() < minimum_cluster_size )
	    return;
         if( no_optimal_clusters_totally_missing_experiments )
         {
             bool* some_data_in_expt = new bool[ num_experiments ];
             int j;
             for( j = 0; j < num_experiments; j++ )
                some_data_in_expt[ j ] = false;
             list<int> cl_subjects = iter->first->get_subjects_allocated();
             list<int>::iterator sub_iter = cl_subjects.begin();
             bool all_experiments_represented = false;
             while( !all_experiments_represented && sub_iter != cl_subjects.end() )
             {
                all_experiments_represented = true;
                for( j = num_experiments; j >= 0; j-- )
                {
                   if( data_block_sizes )
                      data_block_size = data_block_sizes[ j ];
                   if( subject_exp_num_missing_values[ *sub_iter ][ j ] != data_block_size )
                      some_data_in_expt[ j ] = true;
                   all_experiments_represented *= some_data_in_expt[ j ];
                }
                ++sub_iter;
             }
             delete[] some_data_in_expt;
             if( !all_experiments_represented )
                return;
         }
      }
   optimal_labels.clear();
   if( !optimal_clustering )
      optimal_clustering = new int[ num_subjects ];
   int counter = 0;
   for( iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( iter->first->get_mergeable() )
      {
         list<int> cl_subjects = iter->first->get_subjects_allocated();
         for( list<int>::iterator iter2 = cl_subjects.begin(); iter2 != cl_subjects.end(); iter2++ )
            optimal_clustering[ *iter2 ] = counter;
         string* cl_label = iter->first->get_label();
         if( cl_label )
            optimal_labels[ counter ] = *cl_label;
         counter++;
      }
   max_log_likelihood = log_likelihood;
   max_BIC = BIC;
   optimal_num_clusters = counter;
}

void GLM_MVN_Clustering::split_to_optimal_clustering()
{
   int number_of_splits = optimal_num_clusters - number_of_clusters;
   if( !number_of_splits )
      return;
   Cluster_GLM_MVN* cl = 0;
   kill_the_parent = 0;
   splitting_to_optimal = 1;
   int i;
   for( int counter = 0; counter < number_of_splits; counter++ )
   {
      i = 0;
      bool found_suitable_child = false;
      while( i < optimal_num_clusters && !found_suitable_child )
      {
         list<int> cl_subjects;
         for( int j = 0; j < num_subjects; j++ )
            if( optimal_clustering[ j ] == i )
               cl_subjects.push_back( j );
         // Now find the cluster which contains these subjects - finding the first subject will do
         int first_subject = *(cl_subjects.begin());
         cluster_ptrtodbl::iterator iter = cluster_map.begin();
         while( iter!=cluster_map.end() && ( !(iter->first)->cluster_contains_subject( first_subject ) || (iter->first)->cluster_has_subjects( cl_subjects ) ) )
            ++iter;
         if( iter !=cluster_map.end() )
         {
            if( !preserve_tree )
               cl = split_cluster( iter->first, &cl_subjects );
            else
               cl = split_cluster( iter->first );
            if( recalculate_whilst_splitting_to_optimal )
            {
               log_likelihood = proposed_log_likelihood;
               BIC = proposed_BIC;
            }
            number_of_clusters++;
	    if( cl->is_singleton_cluster() )
	       number_of_singleton_clusters++;
	    if( (iter->first)->is_singleton_cluster() )
	       number_of_singleton_clusters++;
            if( !heteroskedastic )
               current_ytd_vstar_dty_sum = proposed_ytd_vstar_dty_sum;
            found_suitable_child = true;
         }
         else
            i++;
      }
      if( optimal_labels.find( i ) != optimal_labels.end() )
         cl->set_label( optimal_labels[ i ] );
   }
   if( !recalculate_whilst_splitting_to_optimal )
   {
      calculate_closeness_contributions();
      calculate_log_likelihood();
      log_likelihood = proposed_log_likelihood;
      BIC = proposed_BIC;
   }
   splitting_to_optimal = 0;

   for( i = 0; i < optimal_num_clusters; i++ )//sort out labels
   {
      bool found_subject = 0;
      int j = 0;
      int cl_subject = -1;
      while( !found_subject && j < num_subjects )
      {
         if( optimal_clustering[ j ] == i )
         {
            cl_subject = j;
            found_subject = 1;
         }
         else
            j++;
      }
      bool found_cluster = 0;
      cluster_ptrtodbl::iterator iter = cluster_map.begin();
      while( iter!=cluster_map.end() && !found_cluster )
      {
         if( (iter->first)->cluster_contains_subject( cl_subject ) )
         {
            if( optimal_labels.find( i ) != optimal_labels.end() )
               (iter->first)->set_label( optimal_labels[ i ] );
            found_cluster = 1;
         }
         else
            ++iter;
      }
   }
}

void GLM_MVN_Clustering::merge_to_single_cluster()
{
   int number_of_merges = number_of_clusters - 1;
   for( int counter = 0; counter < number_of_merges; counter++ )
   {
      cluster_ptrtodbl::iterator iter = cluster_map.begin();
      Cluster_GLM_MVN* cl1 = iter->first;
      Cluster_GLM_MVN* cl2 = (++iter)->first;
      merge_clusters( cl1, cl2 );
      number_of_clusters--;
   }
   number_of_singleton_clusters = 0;
   log_likelihood = calculate_log_likelihood();
   BIC = proposed_BIC;
   current_ytd_vstar_dty_sum = proposed_ytd_vstar_dty_sum;
}

void GLM_MVN_Clustering::get_subject_cluster_types()
{
   if( !Cluster_GLM_MVN::get_using_types() )
   {
      if( subject_cluster_types != best_clustering && subject_cluster_types != nn_equivalence_relation_partition )
	 zap_vector( subject_cluster_types );
      subject_cluster_types = NULL;
   }
   if( !subject_cluster_types )
      subject_cluster_types = new int[ num_subjects ];
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
   {
      int type = iter->first->get_type();
      list<int> cl_subjects = iter->first->get_subjects_allocated();
      for( list<int>::iterator iter2 = cl_subjects.begin(); iter2 != cl_subjects.end(); iter2++ )
         subject_cluster_types[ *iter2 ] = type;
   }
}

void GLM_MVN_Clustering::give_clusters_different_types()
{
   Cluster_GLM_MVN::set_using_types( true );
   number_of_cluster_types = cluster_map.size();
   int type = 0;
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
   {
      iter->first->set_type( type );
      type++;
   }
   get_subject_cluster_types();
}

Cluster_GLM_MVN* GLM_MVN_Clustering::create_temporary_cluster_for_subject( int subject_number, bool find_closeness_contribution )
{
   list<int> cl_subjects;
   cl_subjects.push_back( subject_number );
   return create_temporary_cluster_for_subjects( cl_subjects, find_closeness_contribution );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::create_temporary_cluster_for_subjects( list<int>& cl_subjects, bool find_closeness_contribution )
{
   Cluster_GLM_MVN* cl;
   bool cl_distinct = 0;
   double cl_closeness_contribution = 0;
   list<int>::iterator iter = cl_subjects.begin();
   int subject_number = *iter;
   list<int> cl_subjects_subsequence;
   cl_subjects_subsequence.push_back( subject_number );
   int i, j;
   for( i = 0; i < p_y; i++ )
   {
      for( j = 0; j < yty_cols; j++ )
         gsl_matrix_set( yty_working, i, j, YTYs[ p_y * subject_number + i ][ j ] );
      for( j = 0; j < ytd_cols; j++ )
         gsl_matrix_set( ytd_working, i, j, YTDs[ p_y * subject_number + i ][ j ] );
   }
   if( !inputs_repeated_every )
      for( i = 0; i < num_design_cols; i++ )
         for( j = 0; j < dtd_cols; j++ )
             gsl_matrix_set( dtd_working, i, j, DTDs[ num_design_cols * subject_number + i ][ j ] );
   for( j = 0; j < dim_num_obsns; j++ )
      gsl_matrix_int_set( num_obsns_working, 0, j, NOBs[ subject_number ][ j ] );
   ++iter;
   while( iter != cl_subjects.end() )
   {
      subject_number = *iter;
      for( i = 0; i < p_y; i++ )
      {
         for( j = 0; j < yty_cols; j++ )
            *gsl_matrix_ptr( yty_working, i, j ) += YTYs[ p_y * subject_number + i ][ j ];
         for( j = 0; j < ytd_cols; j++ )
            *gsl_matrix_ptr( ytd_working, i, j ) += YTDs[ p_y * subject_number + i ][ j ];
      }
      if( !inputs_repeated_every )
         for( i = 0; i < num_design_cols; i++ )
            for( j = 0; j < dtd_cols; j++ )
               *gsl_matrix_ptr( dtd_working, i, j ) += DTDs[ num_design_cols * subject_number + i ][ j ];
      for( j = 0; j < dim_num_obsns; j++ )
         *gsl_matrix_int_ptr( num_obsns_working, 0, j ) += NOBs[ subject_number ][ j ];
      ++iter;
   }
   if( find_closeness_contribution && !non_conjugate_model && !random_effects_model && !store_targets_in_cluster )
      cl_closeness_contribution = calculate_closeness_contribution( num_obsns_working, yty_working, ytd_working, dtd_working );
   cl = new Cluster_GLM_MVN( num_obsns_working, yty_working, ytd_working, dtd_working, cl_distinct, 1, cl_subjects, cl_closeness_contribution );
   if( find_closeness_contribution && ( non_conjugate_model || random_effects_model || store_targets_in_cluster ) )
      cl->set_closeness_contribution( calculate_closeness_contribution( cl ) );
   return cl;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::create_temporary_cluster_for_subjects( list<int>& cl_subjects, list<int>::iterator iter1, list<int>::iterator iter2, bool find_closeness_contribution )
{
   if( iter1 == cl_subjects.end() )
      return NULL;
   list<int> cl_subjects_subsequence;
   for( list<int>::iterator iter = iter1; iter != iter2; ++iter )
      cl_subjects_subsequence.push_back( *iter );
   return create_temporary_cluster_for_subjects( cl_subjects_subsequence, find_closeness_contribution );
}

Cluster_GLM_MVN* GLM_MVN_Clustering::create_temporary_cluster_without_subject( int subject_number, Cluster_GLM_MVN* cl1 )
{
   list<int> cl_subjects = cl1->get_subjects_allocated();
   unsigned int cl_num_subjects = cl_subjects.size();
   cl_subjects.remove( subject_number );
   if( !cl_subjects.size() )
      return NULL;
   bool cl_distinct = cl1->get_distinct();
   double cl_closeness_contribution = 0;
   gsl_matrix_memcpy( yty_working, cl1->get_yty() );
   gsl_matrix_memcpy( ytd_working, cl1->get_ytd() );
   gsl_matrix_int* cl1_num_obsns = cl1->get_num_obsns();
   int i, j;
   for( j = 0; j < dim_num_obsns; j++ )
      gsl_matrix_int_set( num_obsns_working, 0, j, gsl_matrix_int_get( cl1_num_obsns, 0, j ) );
   if( !inputs_repeated_every )
      gsl_matrix_memcpy( dtd_working, cl1->get_dtd() );
   if( cl_num_subjects != cl_subjects.size() )//i.e. subject_number is in cl1
   {
      for( i = 0; i < p_y; i++ )
      {
         for( j = 0; j < yty_cols; j++ )
            *gsl_matrix_ptr( yty_working, i, j ) -= YTYs[ p_y * subject_number + i ][ j ];
         for( j = 0; j < ytd_cols; j++ )
            *gsl_matrix_ptr( ytd_working, i, j ) -= YTDs[ p_y * subject_number + i ][ j ];
      }
      if( !inputs_repeated_every )
         for( i = 0; i < num_design_cols; i++ )
            for( j = 0; j < dtd_cols; j++ )
               *gsl_matrix_ptr( dtd_working, i, j ) -= DTDs[ num_design_cols * subject_number + i ][ j ];
      for( j = 0; j < dim_num_obsns; j++ )
         *gsl_matrix_int_ptr( num_obsns_working, 0, j ) -= NOBs[ subject_number ][ j ];
   }
//   if( !non_conjugate_model && !random_effects_model )
//      cl_closeness_contribution = calculate_closeness_contribution( num_obsns_working, yty_working, ytd_working, dtd_working );
      Cluster_GLM_MVN* cl = new Cluster_GLM_MVN( num_obsns_working, yty_working, ytd_working, dtd_working, cl_distinct, 1, cl_subjects, cl_closeness_contribution );
//   if( non_conjugate_model || random_effects_model )
   cl->set_closeness_contribution( calculate_closeness_contribution( cl ) );
   return cl;
}

Cluster_GLM_MVN* GLM_MVN_Clustering::create_temporary_cluster_with_subject( int subject_number, Cluster_GLM_MVN* cl1 )
{
   Cluster_GLM_MVN* cl;
   list<int> cl_subjects = cl1->get_subjects_allocated();
   bool cl_distinct = cl1->get_distinct();
   double cl_closeness_contribution = 0;
   gsl_matrix_memcpy( yty_working, cl1->get_yty() );
   gsl_matrix_memcpy( ytd_working, cl1->get_ytd() );
   gsl_matrix_int* cl1_num_obsns = cl1->get_num_obsns();
   int i, j;
   for( j = 0; j < dim_num_obsns; j++ )
      gsl_matrix_int_set( num_obsns_working, 0, j, gsl_matrix_int_get( cl1_num_obsns, 0, j ) );
   if( !inputs_repeated_every )
      gsl_matrix_memcpy( dtd_working, cl1->get_dtd() );
   cl_subjects.push_back( subject_number );
   if( !cl1->cluster_contains_subject( subject_number ) )
   {
      for( i = 0; i < p_y; i++ )
      {
         for( j = 0; j < yty_cols; j++ )
            *gsl_matrix_ptr( yty_working, i, j ) += YTYs[ p_y * subject_number + i ][ j ];
         for( j = 0; j < ytd_cols; j++ )
            *gsl_matrix_ptr( ytd_working, i, j ) += YTDs[ p_y * subject_number + i ][ j ];
      }
      if( !inputs_repeated_every )
         for( i = 0; i < num_design_cols; i++ )
            for( j = 0; j < dtd_cols; j++ )
               *gsl_matrix_ptr( dtd_working, i, j ) += DTDs[ num_design_cols * subject_number + i ][ j ];
      for( j = 0; j < dim_num_obsns; j++ )
         *gsl_matrix_int_ptr( num_obsns_working, 0, j ) += NOBs[ subject_number ][ j ];
   }
//   if( !non_conjugate_model  && !random_effects_model )
//      cl_closeness_contribution = calculate_closeness_contribution( num_obsns_working, yty_working, ytd_working, dtd_working );
   cl = new Cluster_GLM_MVN( num_obsns_working, yty_working, ytd_working, dtd_working, cl_distinct, 1, cl_subjects, cl_closeness_contribution );
//   if( non_conjugate_model || random_effects_model )
   cl->set_closeness_contribution( calculate_closeness_contribution( cl ) );
   return cl;
}

void GLM_MVN_Clustering::post_agglomerative_processing()
{
   if( max_map_allocation_sweeps > 0 )
      double_size_of_merger_details_array();
   stochastic_agglomeration = 0;
//   heller_algorithm = false;
   zap_array( input_merger_details, merger_details_rows_original - 1, 4 );
   bool originally_timing_agglomerative_clustering = timing_agglomerative_clustering;
   timing_agglomerative_clustering = false;//just do it once
   calculate_membership_probabilities();
   check_allocations_at_each_merger = originally_check_allocations_at_each_merger;
   if( try_best_singletons )
   {
      variable_dimension_allocation_sweeps_at_each_merger = false;
      find_subject_with_highest_new_singleton_cluster_probability();
      calculate_membership_probabilities();//to redo tree
   }
   if( originally_timing_agglomerative_clustering )
   {
      clock_t new_iteration_time = clock();
      double time_change = (double)( new_iteration_time - iteration_time ) * 1000.0 / CLOCKS_PER_SEC;
      iteration_time = new_iteration_time;
      TimingStream << 0 << "\t" << time_change << endl;
      TimingStream.close();
   }
}

void GLM_MVN_Clustering::write_clusters_to_file()
{
   if( calculate_error_covariances )
      calculate_global_error_covariances();//update this
   write_merger_details_to_file();
   write_dendrogram_to_file();
   write_dendrogram_scores_to_file();
   cluster_ptrtodbl::iterator map_iter;
   list< int > cl_subjects;
   list< int >::iterator iter2;
   int i, j, counter = 0, partition_set_number;
   ofstream ClusterStream, ClusterMeansStream, ClusterCovStream, ClusterVarStream, ClusterXStream, PartitionStream, ClusterSizeStream, SubjectStream, ClusterLabelStream, ClusterSubjectsStream, ClusterMissingValuesStream, ClusterErrorCovariancesStream, VoteStream, ClusterNearestNeighbourStream, MissingValuePredictionStream, ClusterClosenessStream;
   if( strlen( Cluster_Output_Filename ) )
      ClusterStream.open( Cluster_Output_Filename, ios::out );
   if( strlen( Cluster_Variance_Filename ) )
      ClusterVarStream.open( Cluster_Variance_Filename, ios::out );
   if( strlen( Cluster_Cov_Filename ) )
      ClusterCovStream.open( Cluster_Cov_Filename, ios::out );
   if( strlen( Cluster_Means_Filename ) )
      ClusterMeansStream.open( Cluster_Means_Filename, ios::out );
   if( strlen( Cluster_X_Output_Filename ) )
      ClusterXStream.open( Cluster_X_Output_Filename, ios::out );
   if( strlen( Partition_Output_Filename ) )
      PartitionStream.open( Partition_Output_Filename, ios::out );
   if( strlen( Cluster_Sizes_Filename ) )
      ClusterSizeStream.open( Cluster_Sizes_Filename, ios::out );
   if( strlen( Subject_Allocations_Filename ) )
      SubjectStream.open( Subject_Allocations_Filename, ios::out );
   if( strlen( Cluster_Labels_Filename ) )
      ClusterLabelStream.open( Cluster_Labels_Filename, ios::out );
   if( strlen( Cluster_Subjects_Filename ) )
      ClusterSubjectsStream.open( Cluster_Subjects_Filename, ios::out );
   if( strlen( Cluster_Closeness_Filename ) )
      ClusterClosenessStream.open( Cluster_Closeness_Filename, ios::out );
//   if( strlen( Cluster_Missing_Values_Filename ) && missing_values )
   if( missing_values )
   {
      ClusterMissingValuesStream.open( Cluster_Missing_Values_Filename, ios::out );
      MissingValuePredictionStream.open( Missing_Value_Predictions_Filename, ios::out );
   }
   if( Cluster_Error_Covariances_Filename && calculate_error_covariances )
      ClusterErrorCovariancesStream.open( Cluster_Error_Covariances_Filename, ios::out );
   if( strlen( Votes_Filename ) )
      VoteStream.open( Votes_Filename, ios::out );
   if( strlen( Cluster_Nearest_Neighbour_Filename ) )
      ClusterNearestNeighbourStream.open( Cluster_Nearest_Neighbour_Filename );
   list<Cluster_GLM_MVN*> clusterlist;
   list<Cluster_GLM_MVN*>::iterator iter, max_iter, second_iter;
   int num_clusters = cluster_map.size();
   for( map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
   {
      if( (map_iter->first)->get_mergeable() || (map_iter->first)->is_root_cluster() )
         clusterlist.push_back( (map_iter->first) );
      else
         num_clusters--;
   }

   int* dendorder = 0;
   if( dendrogram )
   { //then reorder the clusterlist according to the output in Dendrogram_Output_Filename
      int row_num, number_in_list = clusterlist.size();
      map< Cluster_GLM_MVN*, int > first_subjects;
      iter = clusterlist.begin();
      for( iter = clusterlist.begin(); iter != clusterlist.end(); ++iter )
      {
         int first_subject = (*iter)->get_first_subject_allocated();
         row_num = 0;
         while( row_num < num_data_blocks && ( dendrogram[ row_num ] ) != first_subject )
            row_num ++; //finds first_subject[ *iter ] in dendo, call its row row_num
         first_subjects[ *iter ] = row_num;
      }
      list<Cluster_GLM_MVN*> clusterlist2, clusterlist_copy = clusterlist;
      dendorder = new int[ number_in_list ];
      for( i = 0; i < number_in_list; i++ )
      {
         int row_num, lowest_row_num = INT_MAX;
         iter = clusterlist.begin();
         for( j = 0; j < number_in_list - i; j++ )
         {
            row_num = first_subjects[ *iter ] ;
            if( row_num < lowest_row_num )
            {
               max_iter = iter;
               lowest_row_num = row_num;
            }
            ++iter;
         }
         dendorder[ i ] = 0;
         iter = clusterlist_copy.begin();
         while( *iter != *max_iter )
         {
            dendorder[ i ]++;
            ++iter;
         }
         clusterlist2.push_back( *max_iter );
         clusterlist.remove( *max_iter );
      }
      clusterlist = clusterlist2;
   }


   if( strlen( Single_Subject_Nearest_Neighbour_Filename ) && single_subject_closest_subject )
   {
       ofstream SingleSubjectClosestSubjectStream( Single_Subject_Nearest_Neighbour_Filename, ios::out );
       if( SingleSubjectClosestSubjectStream )
       {
           for( i = 0; i < num_subjects; i++ )
               SingleSubjectClosestSubjectStream << single_subject_closest_subject[ i ] << endl;
       }
   }
   if( strlen( Membership_Probability_Filename ) && membership_probability)
   {
      ofstream MemProbStream( Membership_Probability_Filename, ios::out );
      if( MemProbStream )
      {
	//         calculate_membership_probabilities( &clusterlist );
         for( i = 0; i < num_subjects; i++ )
         {
            for( j = 0; j < membership_probability_dim; j++ )
               MemProbStream << membership_probability[ i ][ (dendorder && j<number_of_clusters) ? dendorder[ j ] : j ] << " ";
            MemProbStream << endl;
         }
      }
   }
   if( strlen( Misallocated_Subject_Filename ) )
   {
      ofstream MisallocatedSubjectStream( Misallocated_Subject_Filename, ios::out );
      if( MisallocatedSubjectStream )
      {
	 subjects_not_in_map_membership.sort();
	 for( iter2 = subjects_not_in_map_membership.begin(); iter2 != subjects_not_in_map_membership.end(); ++iter2 )
	    MisallocatedSubjectStream << *iter2 << endl;
      }
   }
   zap( dendorder );

   int* partition = 0;
   if( PartitionStream )
      partition = new int[ num_subjects ];

   ofstream PredStream, ResidStream;
   if( strlen( PredictionFilename ) )
      PredStream.open( PredictionFilename, ios::out );
   if( strlen( Residuals_Filename ) )
      ResidStream.open( Residuals_Filename, ios::out );
   if( PredStream && !m_star_exp )
   {
      m_star_exp = new double*[ num_experiments ];
      for( int i = 0; i < num_experiments; i++ )
         m_star_exp[ i ] = new double[ num_design_cols ];
   }
   int number_of_vs_to_average_over = mixture_of_vs == 1 ? number_of_vs : 1;
   zap_array( ave_predictions_mx, predictions_mx_rows, ave_predictions_mx_cols );
   double ***experiment_ave_predictions_mx = 0;
   if( number_of_vs_to_average_over > 1 )
   {
      ave_predictions_mx_cols = 3;
      create_array( experiment_ave_predictions_mx, effective_num_exps, test_grid_size, ave_predictions_mx_cols );
   }
   if( !heteroskedastic )
   {
      if( p_y > 1 )
         gsl_matrix_memcpy( b_star, b_matrix );
      else
         gsl_matrix_set( b_star, 0, 0, b_ );
   }

   int num_singleton_clusters = 0;
   for( iter = clusterlist.begin(); iter != clusterlist.end(); ++iter )
   {
      partition_set_number = ++counter;//(*iter)->get_smallest_subject_allocated();
//      if( (*iter)->get_mergeable() )
      {
         cl_subjects = (*iter)->get_subjects_allocated();
//         cl_subjects.sort();
         int cl_number_of_subjects = cl_subjects.size();
	 if( cl_number_of_subjects == 1 )
	    num_singleton_clusters++;
         if( strlen( Cluster_Sizes_Filename ) )
            ClusterSizeStream << cl_number_of_subjects << endl;
         string* cl_label = (*iter)->get_label();
         if( number_of_vs > 1 )
            set_v_index( (*iter)->get_v_index() );
         bool print_cluster_details_to_screen = print_to_screen && ( num_clusters <= 1500 || ( cl_label && cl_number_of_subjects > 1 ) );// o/w too many to write out to screen
	 print_cluster_details_to_screen *= ( !singleton_clusters_uniformly_distributed || cl_number_of_subjects > 1 );
         if( print_cluster_details_to_screen )
         {
            cout << cl_number_of_subjects << " subjects allocated to Cluster " << counter;
            if( cl_label && cluster_by_labels )
               cout << "  ('" << *cl_label << "')";
            if( number_of_vs > 1 )
               cout << "  (V" << current_v_index << ")";
         }
         if( PredStream.is_open() || ResidStream.is_open() )
         {
            if( number_of_vs_to_average_over > 1 )
               zero_array( experiment_ave_predictions_mx, effective_num_exps, test_grid_size, ave_predictions_mx_cols );
            prediction_count = 0;
            for( int v_num = 0; v_num < number_of_vs_to_average_over; v_num++ )
            {
               if( number_of_vs_to_average_over > 1 )
                  set_v_index( v_num );
               calculate_posterior_mean_parameters( *iter );
               if( !V_star )
                  break;
               if( ( num_experiments == 1 || treat_experiments_as_different_dimensions || correlate_experiments || correlate_columns ) )
               {
//               gsl_matrix* b_star_corr = get_b_star_correlations();
//            print_gsl_matrix( b_star_corr );
//               gsl_matrix_free( b_star_corr );
                  gsl_matrix* V_star_store = V_star;
                  for( i = 0; i < effective_num_exps; i++ )
                  {
                     current_experiment = i;
                     int experiment_shift = 0;
                     if( !treat_experiments_as_different_dimensions )
                        experiment_shift = i * num_design_cols;
		     else
		        set_active_dimension( current_experiment );
                     gsl_matrix_view V_star_i = gsl_matrix_submatrix( V_star_store, experiment_shift, experiment_shift, num_design_cols, num_design_cols );
                     V_star = &(V_star_i.matrix);
                     if( design_matrix_basis_fn_coeffs )
                     {
                        V_star = gsl_matrix_alloc( num_design_cols, num_design_cols );
                        for( int ii = 0; ii < num_design_cols; ii++ )
                           for( int jj = 0; jj <= ii; jj++ )
                           {
                              double vstar_ij = 0;
                              for( int kk = 0; kk < num_design_cols; kk++ )
			      {
				 double vstar_store_kk = gsl_matrix_get( V_star_store, kk, kk );
				 if( change_basis_variance_for_vote && ( error_prior_contribution_difference_ranks[ current_experiment ] > experiment_vote || ( experiment_vote == num_experiments && error_prior_contribution_differences[ current_experiment ] <= 0 ) || zero_vote_prob[ current_experiment ] ) )

				    vstar_store_kk = a_star_vector1[ current_experiment ];
                                 vstar_ij += design_matrix_basis_fn_coeffs[ kk ][ ii ] * vstar_store_kk * design_matrix_basis_fn_coeffs[ kk ][ jj ];
			      }
                              gsl_matrix_set( V_star, ii, jj, vstar_ij);
                              if( ii != jj )
                                 gsl_matrix_set( V_star, jj, ii, vstar_ij);
                           }
                     }
                     if( !treat_experiments_as_different_dimensions || i == 0 )
                        if( ClusterCovStream.is_open() )
                        {
                           for( int ii = 0; ii < num_design_cols; ii++ )
                           {
                              for( int jj = 0; jj < num_design_cols; jj++ )
                                 ClusterCovStream << gsl_matrix_get( V_star, ii, jj ) << " ";
                              ClusterCovStream << endl;
                           }
                        }
                     if( treat_experiments_as_different_dimensions && a_star_vector )
//                        e_sigma_sq = b_star_vector[ current_experiment ] / ( a_star_vector[ current_experiment ] - 1 );
                        e_sigma_sq = b_star_vector[ current_experiment ] / ( a_star_vector[ current_experiment ] + 1 );//use mode in case a_star < 1
                     if( ClusterVarStream.is_open() && heteroskedastic )
                     {
                        double var_current_experiment = e_sigma_sq;
                        if( normalise_targets )
                           var_current_experiment *= y_scale[ 0 ] * y_scale[ 0 ];
                        ClusterVarStream << var_current_experiment << endl;
//                         for( unsigned int ii = 0; ii < V_star->size1; ii++ )
//                         {
//                            for( unsigned int jj = 0; jj <= V_star->size2; jj++ )
//                               ClusterVarStream << gsl_matrix_get( V_star, jj, ii ) << " ";
//                            ClusterVarStream << endl;
//                         }
                     }
                     if( print_cluster_details_to_screen && heteroskedastic )
                     {
                        if( i == 0 )
                           printf (", Est(sigma^2)= %.2f", e_sigma_sq );
                        else if( heteroskedastic == 1 )
                           printf (", %.2f", e_sigma_sq );
                     }
                     if( error_prior_contribution_difference_ranks )
                     {
                        if( error_prior_contribution_difference_ranks[ current_experiment ] > experiment_vote || ( experiment_vote == num_experiments && error_prior_contribution_differences[ current_experiment ] <= 0 ) || zero_vote_prob[ current_experiment ])//prefers a_1,b_1 to a_,b_
                           VoteStream << 0;
                        else
                        {
                           VoteStream << 1;
                           if( print_cluster_details_to_screen )
                              cout << "*";
                        }
                        if( i < effective_num_exps - 1 )
                           VoteStream << " ";
                        else
                           VoteStream << endl;
                     }
                     
                     for( j = 0; j < p_y; j++ )
                     {
                        for( int jj = 0; jj < num_design_cols; jj++ )
                        {
                           double m_j_jj = m_star_exp[ j ][ jj ] = gsl_matrix_get( m_star, experiment_shift + jj, j );
                           if( normalise_targets )
                              m_j_jj = ( m_j_jj  + y_bar[ j ] ) * y_scale[ j ];
                           if( !treat_experiments_as_different_dimensions || i == 0 )
                              if( ClusterMeansStream.is_open() )
                                 ClusterMeansStream << m_j_jj << " ";
                        }
                        if( !treat_experiments_as_different_dimensions || i == 0 )
                           if( ClusterMeansStream.is_open() )
                              ClusterMeansStream << endl;;
                        set_basis_coefficients( m_star_exp[ j ] );
                        if( print_cluster_details_to_screen && include_fourier_bases )
                           cout << " (Fourier coeff=" << 2 * get_absolute_sum_basis_type_coefficients( FOURIER_BASIS, &i, 2 ) - get_absolute_sum_basis_type_coefficients( FOURIER_BASIS, &i ) << ")";
                        if( number_of_vs_to_average_over > 1 )
                           ave_predictions_mx = experiment_ave_predictions_mx[ i * p_y + j ];
                        if( PredStream.is_open() )
                        {
                           make_grid_predictions( treat_experiments_as_different_dimensions ? i: 0, j );
                           if( ave_predictions_mx )
                           {
                              if( gauss_laguerre_v || mixture_of_vs == 1 )
                              {
                                 double scaling_value = exp( log_prior_v[ v_num ] );
                                 if( gauss_laguerre_v )
                                    scaling_value *= gsl_matrix_get( w_gl, current_v_index % dim_gl, 0 );
                                 scale_array( predictions_mx, scaling_value, predictions_mx_rows, predictions_mx_cols );
                              }
			      bool model_averaging_store = model_averaging;
			      model_averaging = true;
                              update_average_predictions_mx();
			      switch_values( model_averaging, model_averaging_store );
                           }
                        }
                     }
                     if( v_num == number_of_vs_to_average_over - 1 )
                     {
                        if( ave_predictions_mx )
                           copy_array( predictions_mx, ave_predictions_mx, predictions_mx_rows, ave_predictions_mx_cols );
                        if( PredStream )
                           write_predictions( &PredStream );
                     }
                     if( ResidStream.is_open() )
                        //  find residuals for subjects
                        for( iter2 = cl_subjects.begin(); iter2 != cl_subjects.end(); ++iter2 )
                        {
                           int start = get_subject_index( *iter2 );
                           int end = get_subject_index( *iter2 + 1 );
                           int row_start = start * data_block_sizes_sum / num_data_block_sizes;
                           int row_counter = row_start;
                           int i0;
                           for( i0 = start; i0 < end; i0++ )
                           {
                              int exp_num = get_experiment_number( i0 );
                              if( exp_num == current_experiment )
                                 for( int i1 = row_counter; i1 < row_counter + data_block_size; i1++ )
                                 {
                                    calculate_obsn_residual( i1 );
                                    if( Y_hat )
                                       gsl_matrix_set( Y_hat, i1, 0, current_regression_fn_val );
                                    if( missing_values && missing_values[ i1 ][ 0 ] )
                                       gsl_matrix_set( !C1Y ? Y : C1Y, i1, 0, current_regression_fn_val );
                                 }
                              row_counter += data_block_size;
                           }
                        }
                     if( design_matrix_basis_fn_coeffs )
                        gsl_matrix_free( V_star );
                  }
                  V_star = V_star_store;
               }
               else
                  for( current_experiment = 0; current_experiment < num_experiments; current_experiment++ )
                  {
                     set_basis_coefficients( m_star_exp[ current_experiment ] );
                     if( number_of_vs_to_average_over > 1 )
                        ave_predictions_mx = experiment_ave_predictions_mx[ current_experiment ];
                     if( PredStream )
                     {
                        make_grid_predictions( 0, 0 );
                        if( ave_predictions_mx )
                        {
                           if( gauss_laguerre_v || mixture_of_vs == 1 )
                           {
                              double scaling_value = exp( log_prior_v[ v_num ] );
                              if( gauss_laguerre_v )
                                 scaling_value *= gsl_matrix_get( w_gl, current_v_index % dim_gl, 0 );
                              scale_array( predictions_mx, scaling_value, predictions_mx_rows, predictions_mx_cols );
                           }
			   bool model_averaging_store = model_averaging;
			   model_averaging = true;
			   update_average_predictions_mx();
			   switch_values( model_averaging, model_averaging_store );
                        }
                        if( v_num == number_of_vs_to_average_over - 1 )
                        {
                           if( ave_predictions_mx )
                              copy_array( predictions_mx, ave_predictions_mx, predictions_mx_rows, ave_predictions_mx_cols );
                           write_predictions( &PredStream );
                        }
                     }
                     if( ResidStream )
                        //  find residuals for subjects
                        for( iter2 = cl_subjects.begin(); iter2 != cl_subjects.end(); ++iter2 )
                        {
                           int start = get_subject_index( *iter2 );
                           int end = get_subject_index( *iter2 + 1 );
                           for( int i0 = start; i0 < end; i0++ )
                              if( get_experiment_number( i0 ) == current_experiment )
                                 for( int i = i0 * data_block_size; i < (i0+1) * data_block_size; i++ )
                                    calculate_obsn_residual( i );
                        }
                  }
            }
         }
         if( print_cluster_details_to_screen )
            cout << endl;
      }
   }
   if( print_to_screen && singleton_clusters_uniformly_distributed )
      cout << num_singleton_clusters << " subjects attributed to the background." << endl;

   if( ( ClusterClosenessStream.is_open() || ClusterNearestNeighbourStream.is_open() ) && storing_cluster_closenesses )
   {
       create_closeness_matrix();
       calculate_inter_cluster_closeness();
   }

   counter = 0;
   double cluster_merge_prior_change = log_prior_num_clusters[ number_of_clusters - 1 ] - log_prior_num_clusters[ number_of_clusters ];
   for( iter = clusterlist.begin(); iter != clusterlist.end(); ++iter )
   {
      partition_set_number = ++counter;//(*iter)->get_smallest_subject_allocated();
      if( ClusterNearestNeighbourStream.is_open() )
      {
//         calculate_closest_cluster(*iter);
         (*iter)->find_closest_cluster();
         Cluster_GLM_MVN* nearest_neighbour = (*iter)->get_closest_cluster();
         int cnn_counter = 0;
         list<Cluster_GLM_MVN*>::iterator cnn_iter = clusterlist.begin();
         while( *cnn_iter != nearest_neighbour && cnn_iter != clusterlist.end())
         {
            ++cnn_iter;
            cnn_counter++;
         }
         ClusterNearestNeighbourStream << cnn_counter+1 << endl;
      }
      if(  ClusterClosenessStream.is_open() )
      {
          for( second_iter = clusterlist.begin(); second_iter != clusterlist.end(); ++second_iter )
          {
              if( iter != second_iter )
	      {
                 double closeness = (*iter)->get_cluster_closeness( *second_iter );
                 closeness += cluster_merge_prior_change;
		 ClusterClosenessStream << closeness << " ";
	      }
              else
		ClusterClosenessStream << "0 ";
//		ClusterClosenessStream << "";//0 ";
          }
          ClusterClosenessStream << endl;
      }
      {
         cl_subjects = (*iter)->get_subjects_allocated();
         int cl_number_of_subjects = cl_subjects.size();        
         if( ClusterLabelStream.is_open() )
	 {
            string* cl_label = (*iter)->get_label();
	    if( subject_labels )
	    {
	       iter2 = cl_subjects.begin();
	       while( iter2 != cl_subjects.end() )
	       {
		  if( iter2 != cl_subjects.begin() )
		    ClusterLabelStream << "; ";
		  ClusterLabelStream << subject_labels[ *iter2 ];
		  ++iter2;
	       }
	       ClusterLabelStream << endl;
	    }
	    else if( cl_label )
	       ClusterLabelStream << *cl_label << endl;
	 }
         if( ClusterSubjectsStream.is_open()  )
         {
	       iter2 = cl_subjects.begin();
	       while( iter2 != cl_subjects.end() )
	       {
		  if( iter2 != cl_subjects.begin() )
                     ClusterSubjectsStream << " ";
		  ClusterSubjectsStream << *iter2;
		  ++iter2;
	       }
	       ClusterSubjectsStream << endl;
         }
         if( calculate_error_covariances )
         {
            if( !error_covariances )
               error_covariances = gsl_matrix_alloc( error_cov_dim, error_cov_dim );
            gsl_matrix_memcpy( error_covariances, (*iter)->update_cluster_error_covariances() );// subject_exp_num_missing_values ) );
            if( ClusterErrorCovariancesStream.is_open() )
            {
               for( i = 0; i < error_cov_dim; i++ )
               {
                  for( j = 0; j < error_cov_dim; j++ )
                  {
                     ClusterErrorCovariancesStream << gsl_matrix_get( error_covariances, i, j );
                     if( j < error_cov_dim - 1 )
                        ClusterErrorCovariancesStream << " ";
                  }
                  ClusterErrorCovariancesStream << endl;
               }
            }
         }

         iter2 = cl_subjects.begin();
         if( (*iter)->get_distinct() && cl_number_of_subjects > 1 )
         {
            if( partition )
               partition[ *iter2 ] = partition_set_number;
            iter2++;//don't write the first subject obsns to file if its 'distinct', assumed a fixed set used for clustering to.
         }
         if( delete_missing )
         {
            switch_values( Y, Y_original );
            switch_subject_and_expt_structures();
         }
         if( treat_experiments_as_different_dimensions )
            switch_values( X, X_original );
         while( iter2 != cl_subjects.end() )
         {
            if( strlen( Subject_Allocations_Filename ) )
            {
               SubjectStream << counter << "  " << *iter2 + 1;
               if( strlen( Subject_Labels_Filename ) )
               {
                  ifstream LabelFileStream( Subject_Labels_Filename, ios::in );
                  char st[20000];
                  int ctr = 0;
                  while( ctr < *iter2 + 1 && LabelFileStream && !LabelFileStream.eof() )
                  {
                     LabelFileStream.getline(st,20000);
                     ctr++;
                  }
                  if( ctr == *iter2 + 1 )
                     SubjectStream << "  " << st;
               }
               SubjectStream << endl;
            }
            if( partition )
               partition[ *iter2 ] = partition_set_number;
            int start_sub = get_subject_index( *iter2 );
            int end_sub = get_subject_index( *iter2 + 1 );
            int cluster_number = 1 + ( counter - 1 );// * p_y;
            int experiment = 0, old_experiment = 0;
            int row_start = start_sub * data_block_sizes_sum / num_data_block_sizes;
            int row_counter = row_start;

            if( subject_exp_num_missing_values )
            {
               int sub_num_missing = 0, sub_num_not_missing = data_block_sizes_sum;
               for( j = 0; j < num_experiments; j++ )
                  sub_num_missing += subject_exp_num_missing_values[ *iter2 ][ j ];
               sub_num_not_missing -= sub_num_missing;
               if( sub_num_missing )
               {
		  if( MissingValuePredictionStream.is_open() )
		  {
		     MissingValuePredictionStream << *iter2 << "\t";
		     if( subject_labels )
		        MissingValuePredictionStream << subject_labels[ *iter2 ] << " ";
		  }
                  gsl_matrix *sigma12 = NULL, *sigma22 = NULL, *sigma12_sigma22_inv = NULL;
                  bool* sub_obsn_missing = new bool[ data_block_sizes_sum ];
                  for( j = 0; j < data_block_sizes_sum; j++ )
                     sub_obsn_missing[ j ] = missing_values[ row_start + j ][ 0 ];
               
                  get_submatrix( error_covariances, sub_obsn_missing, sub_obsn_missing, sigma12, false, true);
                  get_submatrix( error_covariances, sub_obsn_missing, sub_obsn_missing, sigma22, true, true);
                  delete [] sub_obsn_missing;
                  gsl_matrix *sigma22_inv = gsl_matrix_alloc( sub_num_not_missing, sub_num_not_missing );
                  my_invert( sigma22, sigma22_inv );
                  gsl_matrix_free( sigma22 );
               
                  gsl_matrix *sub_observed_residuals = gsl_matrix_alloc( sub_num_not_missing, 1 );
                  row_counter = row_start;
                  int observed_counter = 0;
                  int i0;
                  for( i0 = start_sub; i0 < end_sub; i0++ )
                  {
                     get_experiment_number( i0 );
                     for( int i1 = row_counter; i1 < row_counter + data_block_size; i1++ )
                        if( !missing_values[ i1 ][ 0 ] )
                           gsl_matrix_set( sub_observed_residuals, observed_counter++, 0, gsl_matrix_get( residuals, i1, 0 ) );
                     row_counter += data_block_size;
                  }
                              
                  gsl_matrix_multiply( sigma12_sigma22_inv, sigma12, sigma22_inv, sub_observed_residuals );
                                 
                  observed_counter = 0;
                  row_counter = row_start;
                  for( i0 = start_sub; i0 < end_sub; i0++ )
                  {
                     get_experiment_number( i0 );
                     for( int i1 = row_counter; i1 < row_counter + data_block_size; i1++ )
                     {
                        if( missing_values[ i1 ][ 0 ] )
			{
			   double imputed_value = gsl_matrix_get( !C1Y ? Y : C1Y, i1, 0 ) + gsl_matrix_get( sigma12_sigma22_inv,observed_counter++ , 0 );
                           gsl_matrix_set( !C1Y ? Y : C1Y, i1, 0, imputed_value );
			   if( MissingValuePredictionStream.is_open() )
			      MissingValuePredictionStream << imputed_value << "\t";
			}
                     }
                     row_counter += data_block_size;
                  }
		  if( MissingValuePredictionStream.is_open() )
		     MissingValuePredictionStream << endl;
                  gsl_matrix_free( sub_observed_residuals );
                  gsl_matrix_free( sigma12 );
                  gsl_matrix_free( sigma22_inv );
               }
            }
            row_counter = row_start;

            
            for( i = start_sub; i < end_sub; i++ )
            { 
               double y_val = 0, previous_y_val = 0;
               old_experiment = experiment;
               experiment = get_experiment_number( i );
               if( equivalent_experiments )
                  experiment = equivalent_experiments[ experiment ];
               if( treat_experiments_separately || correlate_experiments || treat_experiments_as_different_dimensions )
                  cluster_number = ( counter - 1 ) * num_experiments + 1 + experiment;
               if( i == start_sub || ( i != start_sub && ( treat_experiments_separately || correlate_experiments || treat_experiments_as_different_dimensions ) && old_experiment != experiment ) )
                  ClusterStream << cluster_number;// + j;
               for( j = 0; j < p_y; j++ )
               {
                  if( use_differences || subtract_intercept )
                  {
                     y_val = previous_y_val = y_differenced_points[ i ][ j ];
                     if( log_targets )
                        y_val = inverse_log_transform( y_val, log_targets );
                     else if( logistic_transform_targets )
                        y_val = logit_transform( y_val );
                     ClusterStream << "  " << y_val;
                  }
                  for( int ii = 0; ii < data_block_size; ii++ )
                  {
                     y_val = gsl_matrix_get( Y, row_counter + ii, j);
                     if( standardize_experiments && experiment_means && experiment_sds )
                     {
                        y_val *= experiment_sds[ experiment ]; 
                        y_val += experiment_means[ experiment ];
                     }
                     if( normalise_targets )
                        y_val = ( y_val  + y_bar[ j ] ) * y_scale[ j ];
		     if( y_block_norms )
		        y_val *= y_block_norms[ i ][ j ];
                     if( use_differences || subtract_intercept )
                     {
                        y_val += previous_y_val;
                        if( !subtract_intercept )
                           previous_y_val = y_val;
                     }
                     if( log_targets )
                        y_val = inverse_log_transform( y_val, log_targets );
                     else if( logistic_transform_targets )
                        y_val = logit_transform( y_val );
                     ClusterStream << "  " << y_val;
                     if( ClusterMissingValuesStream.is_open() )
                        ClusterMissingValuesStream << missing_values[ row_counter + ii ][ j ]<< "  ";
                  }
                  if( ( i == end_sub - 1 || ( ( treat_experiments_separately || correlate_experiments || treat_experiments_as_different_dimensions ) && get_experiment_number( i+1 ) != get_experiment_number( i ) ) ) && j == p_y - 1 )
                  {
                     ClusterStream << endl;
		     if( ClusterMissingValuesStream.is_open() )
                        ClusterMissingValuesStream << endl;
                  }
               }
               if( strlen( Cluster_X_Output_Filename ) )
               {
                  ClusterXStream << cluster_number;
                  for( int ii = 0; ii < data_block_size; ii++ )
                     for( j = 0; j < p; j++ )
                        ClusterXStream << "  " << gsl_matrix_get( X, row_counter + ii, j);
                  ClusterXStream << endl;
               }
               get_experiment_number( i );
               row_counter += data_block_size;
               
            }
            iter2++;
         }
         if( delete_missing )
         {
            switch_values( Y_original, Y );
            switch_subject_and_expt_structures();
            data_block_size = 1;
         }
         if( treat_experiments_as_different_dimensions )
            switch_values( X_original, X );
      }
   }
   if( !heteroskedastic )
   {
      if( print_to_screen )
         printf ("E(sigma)= %.2f\n", e_sigma_sq );
      if( ClusterVarStream.is_open() )
         ClusterVarStream << e_sigma_sq << endl;
   }
   zap_array( experiment_ave_predictions_mx, effective_num_exps, test_grid_size, 3 );
   ave_predictions_mx = 0;
   if( ResidStream )
      write_residuals( &ResidStream );

   if( ClusterErrorCovariancesStream.is_open() )
   {
      if( global_error_covariances )
         for( i = 0; i < error_cov_dim; i++ )//finally print the prior mean matrix to this file
         {
            for( j = 0; j < error_cov_dim; j++ )
            {
               ClusterErrorCovariancesStream << gsl_matrix_get( global_error_covariances, i, j );
               if( j < error_cov_dim - 1 )
                  ClusterErrorCovariancesStream << " ";
            }
            ClusterErrorCovariancesStream << endl;
         }
   }
   if( partition )
   {
      for( i = 0; i < num_subjects; i++ )
         PartitionStream << partition[ i ] << endl;
      delete [] partition;
   }
   write_experiment_locations_to_file();
}

void GLM_MVN_Clustering::print_label_probabilities()
{
   int num_rows = unmergeable_cluster_deque.size();
   int num_cols = labels.size();
   if( num_rows && num_cols )
   {
      int row = 0, col = 0;
      double prob, prob_sum, max_prob, min_prob_diff;
      string max_string, *sptr;
      str_to_int labels1, labels2, labels3;
      double** lift_matrix;
      create_array( lift_matrix, num_rows, 2 );
      for( int i = 0; i < num_rows; i++ )
         lift_matrix[ i ][ 0 ] = lift_matrix[ i ][ 1 ] = 0;

      // find the number of clusters for each label type (for printing out)
      for( cluster_ptrtodbl::iterator map_iter = cluster_map.begin(); map_iter != cluster_map.end(); ++map_iter )
         if( (map_iter->first)->get_mergeable() )
         {
            string* cl_label = (map_iter->first)->get_label();
            if( cl_label )
            {
               if( labels1.find( *cl_label ) == labels1.end() )
                  labels1[ *cl_label ] = 1;
               else
                  labels1[ *cl_label ]++;
            }
         }

      for( cluster_ptrs::iterator iter = unmergeable_cluster_deque.begin(); iter != unmergeable_cluster_deque.end(); ++iter )
      {
         prob_sum = 0;
         max_prob = 0;
         min_prob_diff = 1;
         col = 0;
         for( str_to_int::iterator iter2 = labels.begin(); iter2 != labels.end(); iter2++ )
         {
            pair< Cluster_GLM_MVN*, string > clstr_pair( *iter, iter2->first );
            prob = mean_cluster_and_label_probability[ clstr_pair ];
            prob_sum += prob;
            if( prob > max_prob )
            {
               if( prob - max_prob < min_prob_diff )
                  min_prob_diff = prob - max_prob;
               max_prob = prob;
               max_string = iter2->first;
            }
            else if( max_prob - prob < min_prob_diff )
               min_prob_diff = max_prob - prob;
            col++;
         }
         if( prob_sum )
            lift_matrix[ row ][ 0 ] = min_prob_diff / prob_sum;

         int num_subs = (*iter)->get_num_subjects_allocated();
         if( labels2.find( max_string ) == labels2.end() )
            labels2[ max_string ] = num_subs;
         else
            labels2[ max_string ] += num_subs;
         sptr = (*iter)->get_label();
         if( sptr )
	 {
            if( *sptr != max_string )
            {
               number_misclassified += num_subs;
               if( labels3.find( max_string ) == labels3.end() )
                  labels3[ max_string ] = num_subs;
               else
                  labels3[ max_string ] += num_subs;
            }
            else
            {
               number_classified += num_subs;
               lift_matrix[ row ][ 1 ] = 1;
            }
	 }
         row++;
      }

      for( str_to_int::iterator iter2 = labels2.begin(); iter2 != labels2.end(); iter2++ )
      {
         cout << iter2->second  << " predicted ";
         if( number_classified + number_misclassified )
            cout << "(" << labels3[ iter2->first ] << " wrongly) ";
         cout << "to belong to " << iter2->first << " (" << labels1[ iter2->first ] << " clusters)" << endl;
      }
      cout << endl;
      if( number_classified + number_misclassified )
      {
         cout << "    Number of subjects misclassified = " << number_misclassified << "  (out of " << number_classified + number_misclassified << ")" << endl;
         cout << "Proportion of subjects misclassified = " << (double)number_misclassified / (double)( number_classified + number_misclassified ) << endl;
      }

      if( strlen( Lift_Chart_Filename ) )
      {
         ofstream LiftStream( Lift_Chart_Filename, ios::out );
         for( int i = 0; i < num_rows; i++ )
            LiftStream << lift_matrix[ i ][ 0 ] << "   " << lift_matrix[ i ][ 1 ] << endl;
      }
      zap_array( lift_matrix, num_rows, 2 );
   }
}

void GLM_MVN_Clustering::print_deque_cluster_sizes()
{
   for( cluster_ptrs::iterator iter = mergeable_cluster_deque.begin(); iter != mergeable_cluster_deque.end(); ++iter )
      cout << (*iter)->get_num_subjects_allocated() << " ";
   cout << endl;
}

void GLM_MVN_Clustering::make_predictions()
{
   zap_array( predictions_mx, predictions_mx_rows, predictions_mx_cols );
   predictions_mx_rows = unmergeable_cluster_deque.size();
   if( !predictions_mx_rows )
      return;
   predictions_mx_cols = 2;
   predictions_update_cols = 1;
   if( p_y > 1 )
   {
      predictions_mx_cols++;
      predictions_update_cols++;
   }
   create_array( predictions_mx, predictions_mx_rows, predictions_mx_cols );
   int counter = 0;
   double y_val = 0, y_val2 = 0;
   for( cluster_ptrs::iterator iter = unmergeable_cluster_deque.begin(); iter != unmergeable_cluster_deque.end(); ++iter )
   {
      y_val = get_first_target( (*iter)->get_subjects_allocated(), variable_to_predict_over );
      if( p_y > 1 )
         y_val2 = get_first_target( (*iter)->get_subjects_allocated(), second_variable_to_predict_over );
      double pred_dens = calculate_predictive_probability( *iter );
      if( normalise_targets )
      {
         if( y_scale[ variable_to_predict_over ] > 0 )
         {
            pred_dens /= y_scale[ variable_to_predict_over ];
            y_val = ( y_val + y_bar[ variable_to_predict_over ] ) * y_scale[ variable_to_predict_over ];
         }
         if( p_y > 1 && y_scale[ second_variable_to_predict_over ] > 0 )
         {
            pred_dens /= y_scale[ second_variable_to_predict_over ];
            y_val2 = ( y_val2 + y_bar[ second_variable_to_predict_over ] ) * y_scale[ second_variable_to_predict_over ];
         }
      }
      if( log_targets )
      {
         y_val = inverse_log_transform( y_val, log_targets );
         pred_dens /= y_val;
         if( p_y > 1 )
         {
            y_val2 = inverse_log_transform( y_val2, log_targets );
            pred_dens /= y_val2;
         }
      }
      else if( logistic_transform_targets )
      {
         pred_dens *= y_val * (1-y_val );
         y_val = logit_transform( y_val );
         if( p_y > 1 )
         {
	    pred_dens *= y_val2 * (1-y_val2 );
            y_val2 = logit_transform( y_val2 );
         }
      }
      predictions_mx[ counter ][ 0 ] = y_val;
      if( p_y > 1 )
         predictions_mx[ counter ][ 1 ] = y_val2;
      predictions_mx[ counter ][ predictions_mx_cols - 1 ] = pred_dens;
      counter++;
   }
}

int GLM_MVN_Clustering::update_merger_details()
{
   int md_row = merger_details_rows + ( minimum_num_clusters - 1 ) - ( number_of_clusters - 1 );
   merger_details[ md_row ][ 0 ] = number_of_clusters - 1;
   int subj1 = most_mergeable_cluster_smallest_subject = most_mergeable_cluster->get_smallest_subject_allocated();
   int subj2 = most_mergeable_clusters_closest_smallest_subject = most_mergeable_clusters_closest->get_smallest_subject_allocated();
   if( subj2 < subj1 )
      switch_values( subj1, subj2 );//order them for neatness, so smallest subject to the left.
   if( md_write_smallest_subjects )
   {
      merger_details[ md_row ][ 1 ] = subj1;
      merger_details[ md_row ][ 2 ] = subj2;
   }
   else
   {
      int subj11, subj12, subj21, subj22;
      most_mergeable_cluster->get_first_and_last_subjects_allocated( subj11, subj12 );
      most_mergeable_clusters_closest->get_first_and_last_subjects_allocated( subj21, subj22 );
      merger_details[ md_row ][ 1 ] = subj11;
      merger_details[ md_row ][ 2 ] = subj12;
      merger_details[ md_row ][ 3 ] = subj21;
      merger_details[ md_row ][ 4 ] = subj22;
   }
   merger_details[ md_row ][ merger_details_cols - 2 ] = proposed_log_likelihood;
   merger_details[ md_row ][ merger_details_cols - 1 ] = proposed_BIC;
   return subj1;
}

void GLM_MVN_Clustering::update_merger_details_first_row()
{
   int md_row = merger_details_rows - number_of_clusters + ( minimum_num_clusters - 1 );
   merger_details[ md_row ][ 0 ] = number_of_clusters;
   for( int j = 1; j < merger_details_cols - 2; j++ )
      merger_details[ md_row ][ j ] = -1;
   merger_details[ md_row ][ merger_details_cols - 2 ] = log_likelihood;
   merger_details[ md_row ][ merger_details_cols - 1 ] = BIC;
}

void GLM_MVN_Clustering::update_dendrogram()
{
   if( !dendrogram )
   {
      dendrogram = new int[ num_subjects ];
      inverse_dendrogram = new int[ num_subjects ];
   }
   list<Cluster_GLM_MVN*> root_list = Cluster_GLM_MVN::get_root_clusters();
   int counter = 0;
   for( list<Cluster_GLM_MVN*>::iterator iter = root_list.begin(); iter != root_list.end(); ++iter )
   {
      list<int> cl_subjects = (*iter)->get_subjects_allocated();
      for( list<int>::iterator iter2 = cl_subjects.begin(); iter2 != cl_subjects.end(); ++iter2 )
      {
         dendrogram[ counter ] = *iter2;
         inverse_dendrogram[ *iter2 ] = counter++;
      }
   }
}

void GLM_MVN_Clustering::update_subjects_first_merge()
{
   list<int> cl1_subjects = most_mergeable_cluster->get_subjects_allocated();
   list<int> cl2_subjects = most_mergeable_clusters_closest->get_subjects_allocated();
   list<int>::iterator iter1 = cl1_subjects.begin();
   while( iter1 != cl1_subjects.end() )
   {
       list<int>::iterator iter2 = cl2_subjects.begin();
       while( iter2 != cl2_subjects.end() )
       {
           int sub1 = *iter1, sub2 = *iter2;
           if( sub1 < sub2 )
               switch_values( sub1, sub2 );
           subjects_first_merge[ sub1][ sub2 ] = num_subjects - number_of_clusters + 1;
           ++iter2;
       }
       ++iter1;
   }
}

void GLM_MVN_Clustering::double_size_of_merger_details_array()
{
   double **new_merger_details = 0, **new_best_merger_details = 0;
   int new_merger_details_rows = merger_details_rows + merger_details_rows_original;
   create_array( new_merger_details, new_merger_details_rows, merger_details_cols );
   if( best_merger_details )
      create_array( new_best_merger_details, new_merger_details_rows, merger_details_cols );
   int i,j;
   for( j = 0; j < merger_details_cols; j++ )
   {
      for( i = 0; i < merger_details_rows; i++ )
      {
         new_merger_details[ i ][ j ] = merger_details[ i ][ j ];
         if( best_merger_details )
            new_best_merger_details[ i ][ j ] = best_merger_details[ i ][ j ];
      }
      for( i = merger_details_rows; i < new_merger_details_rows; i++ )
      {
         new_merger_details[ i ][ j ] = merger_details[ i - merger_details_rows_original ][ j ];
         if( best_merger_details )
            new_best_merger_details[ i ][ j ] = best_merger_details[ i - merger_details_rows_original ][ j ];
      }
   }
   switch_values( merger_details, new_merger_details );
   switch_values( best_merger_details, new_best_merger_details );
   zap_array( new_merger_details, merger_details_rows, merger_details_cols );
   zap_array( new_best_merger_details, merger_details_rows, merger_details_cols );
   merger_details_rows = new_merger_details_rows;
}

void GLM_MVN_Clustering::write_merger_details_to_file()
{
   if( !strlen( Merger_Details_Filename ) || !strlen( Bare_Merger_Details_Filename ) )
      return;
   ofstream MergerDetailsStream, BareMergerDetailsStream;
   MergerDetailsStream.open( Merger_Details_Filename, ios::out );
   BareMergerDetailsStream.open( Bare_Merger_Details_Filename, ios::out );
   ofstream DendroCutpointStream;
   int i, j;
   if( strlen( Dendrogram_Cutpoint_Filename ) && !md_write_smallest_subjects )
      DendroCutpointStream.open( Dendrogram_Cutpoint_Filename, ios::out );
   int row = merger_details_rows - 1;
   for( i = 0; i < merger_details_rows; i++ )
   {
      for( j = 0; j < merger_details_cols - 2; j++ )
         MergerDetailsStream << (int)merger_details[ i ][ j ] << "  ";
      MergerDetailsStream << merger_details[ i ][ merger_details_cols - 2 ] << "  " << merger_details[ i ][ merger_details_cols - 1 ];
      MergerDetailsStream << endl;
      if( BareMergerDetailsStream.is_open() && i > (merger_details_rows-merger_details_rows_original) )
      {
	 for( j = 0; j < 4; j++ )
	    BareMergerDetailsStream << (int)merger_details[ i ][ j + 1 ] << "  ";
       BareMergerDetailsStream << endl;
     }
      if( row > 0 && DendroCutpointStream.is_open() )
      {
         int md_i1 = (int)merger_details[ row ][ 1 ];
         int md_i2 = (int)merger_details[ row ][ 2 ];
         int md_i3 = (int)merger_details[ row ][ 3 ];
         int md_i4 = (int)merger_details[ row ][ 4 ];
	 if( inverse_dendrogram[ md_i1 ] > inverse_dendrogram[ md_i2 ] )
	    switch_values( md_i1, md_i2 );
	 if( inverse_dendrogram[ md_i3 ] > inverse_dendrogram[ md_i4 ] )
	    switch_values( md_i3, md_i4 );
         if( inverse_dendrogram[ md_i2 ] > inverse_dendrogram[ md_i4 ] )
         {
            switch_values( md_i1, md_i3 );
            switch_values( md_i2, md_i4 );
         }
         DendroCutpointStream << inverse_dendrogram[ md_i3 ] + 1 << endl;
         row--;
      }
   }
}

void GLM_MVN_Clustering::sample_clusters_from_prior()
{
   if( strlen( Simulated_Data_Filename ) )
   {
      double a_store = a_;
      double b_store = b_;
      a_ = 1;
      b_ = 1;
      ofstream SimulatedDataStream( Simulated_Data_Filename, ios::out );
      if( !heteroskedastic )
         lambda = draw_lambda_from_prior();
      for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      {
         if( heteroskedastic )
            lambda = draw_lambda_from_prior();
         draw_betas_from_prior();
         set_basis_coefficients();
         list<int> cl_subjects = iter->first->get_subjects_allocated();
         for( list<int>::iterator iter0 = cl_subjects.begin(); iter0 != cl_subjects.end(); ++iter0 )
         {
            int start_sub = get_subject_index( *iter0 );
            int end_sub = get_subject_index( *iter0 + 1 );
            for( int i = start_sub; i < end_sub; i++ )
            {
               for( int ii = 0; ii < data_block_size; ii++ )
               {
                  double eta_i = 0;
                  for( int jj = 0; jj < dim_V; jj++ )
                     eta_i += gsl_matrix_get( D, i * data_block_size +ii, jj ) * gsl_matrix_get( beta, jj, 0 );
                  for( int j = 0; j < p_y; j++ )
                     gsl_matrix_set( Y, i * data_block_size + ii, j, eta_i + draw_error() );
               }
            }
         }
      }
      for( int i = 0; i < n; i++ )
      {
         for( int j = 0; j < p_y; j++ )
         {
            SimulatedDataStream << gsl_matrix_get( Y, i, j );
            if( j < p_y - 1 )
               SimulatedDataStream << "  ";
         }
         if( i < n - 1 )
            SimulatedDataStream << endl;
      }
      a_ = a_store;
      b_ = b_store;
   }
}

double GLM_MVN_Clustering::half_log_det_vstar( gsl_matrix_int* m )
{
   double d = 0;
   if( !treat_experiments_separately && !weight_experiments )
   {
      if( number_of_vs > 1 )
         d = half_logdet_v_inv[ current_v_index ];
      if( inputs_repeated_every )
      {
         int sum = 0;
         for( unsigned int i = 0; i < m->size1; i++ )
            for( unsigned int j = 0; j < m->size2; j++ )
               sum += gsl_matrix_int_get( m, i, j );
         return d + get_half_log_det_vstar( sum ) + ml_const;
      }
      else
         return d + ml_const;
   }
   int num_cols = m->size2;
   for( int i = 0; i < num_cols; i++ )
   {
      int nn_i = 0;
      if( !equivalent_experiments )
         nn_i = gsl_matrix_int_get( m, 0, i );
      else
         for( int ii = 0; ii < num_experiments; ii++ )
            if( equivalent_experiments[ ii ] == i )
               nn_i += gsl_matrix_int_get( m, 0, ii );
      if( nn_i )
      {
         if( treat_experiments_separately )
         {
            if( inputs_repeated_every )
               d += get_half_log_det_vstar( i * ( num_data_blocks + 1 ) + nn_i ) + ml_const;
            else
               d += ml_const;
            if( number_of_vs > 1 )
               d += half_logdet_v_inv[ current_v_index ];
         }
         else
            if( !correlate_experiments || !data_block_sizes )
               d += nn_i * experiment_weights[ i ] * experiment_weights[ i ];
            else
               d += nn_i;
      }
   }
   if( weight_experiments )
   {
      /*
        int floor_d = (int)floor( d );
        int ceil_d = ( floor_d < num_data_blocks ? floor_d + 1:floor_d );
        double wt1 = ( ceil_d - d ) * ( ceil_d - d );
        double wt2 = 1 - wt1;
        d = wt1 * (*half_log_det_vstars)[ floor_d ] + wt2 * (*half_log_det_vstars)[ ceil_d ];
        d += ml_const;
      */
      if( inputs_repeated_every )
         d = get_half_log_det_vstar_dbl( d ) + ml_const;
      else
         d = ml_const;
      if( number_of_vs > 1 )
         d += half_logdet_v_inv[ current_v_index ];
   }

   return d;
}

void GLM_MVN_Clustering::weight_the_experiments()
{
   zap_vector( experiment_weights )
   experiment_weights = new double[ num_experiments ];
   find_experiment_sds();
   double weight_ave = 0;
   int i, j, k;
   for( i = 0; i < num_experiments; i++ )
   {
      experiment_weights[ i ] = 1 / experiment_sds[ i ];
      weight_ave += experiment_weights[ i ] * experiment_weights[ i ];
   }
   weight_ave = sqrt( weight_ave / (double)num_experiments );
   for( i = 0; i < num_experiments; i++ )
      experiment_weights[ i ] /= weight_ave;

   if( !C1Y )
   {
      C1Y = gsl_matrix_alloc( n, p_y );
      gsl_matrix_memcpy( C1Y, Y );
   }
   if( !C1D )
   {
      C1D = gsl_matrix_alloc( n, num_design_cols );
      gsl_matrix_memcpy( C1D, D );
   }
   int row_counter = 0;
   for( int i0 = 0; i0 < num_data_blocks; i0++ )
   {
      int experiment = get_experiment_number( i0 );
      if( equivalent_experiments )
	 experiment = equivalent_experiments[ experiment ];
      double exp_wt = experiment_weights[ experiment ];
      for( i = row_counter; i < row_counter + data_block_size; i++ )
      {
         for( j = 0; j < p_y; j++ )
            *gsl_matrix_ptr( C1Y, i, j ) *= exp_wt;
         for( j = 0; j < num_design_cols; j++ )
            *gsl_matrix_ptr( C1D, i, j ) *= exp_wt;
      }
      row_counter += data_block_size;
   }
   if( data_block_sizes && correlate_experiments )
      for( i = 0; i < num_experiments; i++ )
      {
         double exp_wt_sq = experiment_weights[ i ] * experiment_weights[ i ];
         for( j = 0; j < num_design_cols; j++ )
            for( k = 0; k < num_design_cols; k++ )
               gsl_matrix_set( D_sq, i * num_design_cols + j, i * num_design_cols + k, gsl_matrix_get( D_sq, i * num_design_cols + j, i * num_design_cols + k ) * exp_wt_sq );
      }
}

void GLM_MVN_Clustering::store_closeness_contributions()
{
   if( !closeness_contributions_store )
      closeness_contributions_store = new list<double>;
   closeness_contributions_store->clear();
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( iter->first->get_mergeable() )
         closeness_contributions_store->push_back( (iter->first)->get_closeness_contribution() );
}

void GLM_MVN_Clustering::recover_closeness_contributions()
{
   list<double>::iterator iter0 = closeness_contributions_store->begin();
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      if( iter->first->get_mergeable() )
      {
         iter->first->set_closeness_contribution( *iter0 );
         ++iter0;
      }
   closeness_contributions_store->clear();
}

void GLM_MVN_Clustering::set_v_index( int index )
{
   if( index == current_v_index )
      return;
   GLM::set_v_index( index );
   vstar_map = vstar_maps[ index ];
   half_log_det_vstars = half_log_det_vstar_maps[ index ];
   current_vstar_index = current_hldv_index = -1;
}

void GLM_MVN_Clustering::propose_new_v()
{
  //   empty_vstar_map();
   switch_values( vstar_maps, vstar_maps_store );
   switch_values( vstar_map, vstar_map_store );
   switch_values( half_log_det_vstar_maps, half_log_det_vstar_maps_store );
   switch_values( half_log_det_vstars, half_log_det_vstars_store );
   switch_values( vstar_hash, vstar_hash_store );
   current_vstar_index = current_hldv_index = -1;
   if( !(preserve_tree && mcmc_sampling) )
   {
      store_closeness_contributions();
      calculate_closeness_contributions();
   }
   calculate_log_likelihood();
}

void GLM_MVN_Clustering::execute_new_v()
{
   switch_values( vstar_maps, vstar_maps_store );
   switch_values( vstar_map, vstar_map_store );
   switch_values( half_log_det_vstar_maps, half_log_det_vstar_maps_store );
   switch_values( half_log_det_vstars, half_log_det_vstars_store );
   switch_values( vstar_hash, vstar_hash_store );
   empty_vstar_map();
   switch_values( vstar_maps, vstar_maps_store );
   switch_values( vstar_map, vstar_map_store );
   switch_values( half_log_det_vstar_maps, half_log_det_vstar_maps_store );
   switch_values( half_log_det_vstars, half_log_det_vstars_store );
   switch_values( vstar_hash, vstar_hash_store );
}

void GLM_MVN_Clustering::undo_new_v()
{
   if( !(preserve_tree && mcmc_sampling) )
      recover_closeness_contributions();
   empty_vstar_map();
   switch_values( vstar_maps, vstar_maps_store );
   switch_values( vstar_map, vstar_map_store );
   switch_values( half_log_det_vstar_maps, half_log_det_vstar_maps_store );
   switch_values( half_log_det_vstars, half_log_det_vstars_store );
   switch_values( vstar_hash, vstar_hash_store );
}

void GLM_MVN_Clustering::propose_new_b()
{
   for( int i = 1; i <= num_data_blocks; i++ )
      if( heteroskedastic == 1 )
         log_prior_num_clusters[ i ] += i * lambda_prior_normalising_constant * num_experiments;
      else if( heteroskedastic == 2 )
         log_prior_num_clusters[ i ] += i * lambda_prior_normalising_constant;
      else if( !heteroskedastic )
         log_prior_num_clusters[ i ] += lambda_prior_normalising_constant;
   if( !(preserve_tree && mcmc_sampling) )
   {
      store_closeness_contributions();
      calculate_closeness_contributions();
   }
   calculate_log_likelihood();
}

void GLM_MVN_Clustering::undo_new_b()
{
   if( !(preserve_tree && mcmc_sampling) )
      recover_closeness_contributions();
   for( int i = 1; i <= num_data_blocks; i++ )
      if( heteroskedastic == 1 )
         log_prior_num_clusters[ i ] -= i * lambda_prior_normalising_constant * num_experiments;
      else if( heteroskedastic == 2 )
         log_prior_num_clusters[ i ] -= i * lambda_prior_normalising_constant;
      else if( !heteroskedastic )
         log_prior_num_clusters[ i ] -= lambda_prior_normalising_constant;
}

bool GLM_MVN_Clustering::required_vstar_of_storable_kind( long int index, bool* full )
{
   if( full && !(*full) )
      return false;
   if( random_effects_model && (random_effect_rows) )
      return false;
   return true;
}

gsl_matrix* GLM_MVN_Clustering::get_vstar( gsl_matrix_int* nn )
{
   long index = 0, shift = 1;
   bool full = true;
   int multiple = 0;
   for( unsigned int j = 0; j < nn->size2; j++ )
   {
      int nn_j = gsl_matrix_int_get( nn, 0, j );
      if( !subject_experiment_weights )
	 index += nn_j;
      else
      {
         if( data_block_sizes )
            data_block_size = data_block_sizes[ j ];
	 index += shift * (data_block_size - nn_j);
         shift *= ( num_subjects + 1 ) * data_block_size;
         if( full )
	 {
            if( nn_j % data_block_size )
               full = false;
            else
               if( j == 0 )
                  multiple = nn_j / data_block_size;
               else if( multiple != nn_j / data_block_size )
                  full = false;
	 }
      }
   }
   if( keep_vstars == 3 && required_vstar_of_storable_kind( index, &full ) )
      index = multiple;
   gsl_matrix* vstar_nn = get_vstar( index, nn, &full );
   return vstar_nn;
}

gsl_matrix* GLM_MVN_Clustering::get_vstar( long int index, gsl_matrix_int* nn, bool* full )
{
   int i, j, k;
   double new_hldv = 0;
   if( index == current_vstar_index && required_vstar_of_storable_kind( index, full ) )
      return V_star;
   if( required_vstar_of_storable_kind( index, full ) )
      current_vstar_index = index;
   else
      current_vstar_index = -INT_MAX;
   mx_numtoptr::iterator iter = vstar_map->find( index );
   if( iter != vstar_map->end() && required_vstar_of_storable_kind( index, full ) )
      V_star = iter->second;
   else
   {
      double d_ = (double)index / ave_data_block_size;
      if( correlate_experiments || !heteroskedastic )
         d_ /= (double)num_experiments;
      int vstar_rows = dim_V;
      if( random_effects_model )
      {
         if( !random_effect_variances )
         {
            random_effect_rows = correlate_experiments ? index / num_experiments : index;
            random_effect_rows /= ave_data_block_size;
         }
         vstar_rows += random_effect_rows;
	 currently_diagonal_vstar = random_effect_variances && diagonal_v && gram_schmidt && !random_effect_rows;
      }
      else
         random_effect_rows = 0;
      int expt_counter = -1, expt_limit = 0;
      if( currently_diagonal_vstar )
      {
	 if( vstar_working && (int)vstar_working->size1 != vstar_rows )
	 {
	    gsl_matrix_free( vstar_working );
	    vstar_working = 0;
	 }
         if( !vstar_working )
            vstar_working = gsl_matrix_calloc( vstar_rows, vstar_rows );
         double vstar_ii;
         for( i = 0; i < vstar_rows; i++ )
         {
	    if( nn && i == expt_limit )
            {
                expt_counter++;
                if( data_block_sizes )
                   data_block_size = data_block_sizes[ expt_counter ];
                expt_limit += num_1way_basis_fns[ expt_counter ];//knot_point_grid ? (vstar_rows/num_experiments_original) : data_block_size;
                d_ = (double) gsl_matrix_int_get( nn, 0, expt_counter ) / data_block_size;
	    }
	    vstar_ii = 1.0 / (gsl_matrix_get( V_inv, i, i ) + d_);
            gsl_matrix_set( vstar_working, i, i, vstar_ii );
            new_hldv += log( vstar_ii );
         }
         if( keep_vstars && ( keep_vstars !=3 || required_vstar_of_storable_kind( index, full ) ) )
         {
            hldv = new_hldv;
            (*half_log_det_vstars)[ index ] = 0.5 * p_y * hldv;
         }
         V_star = vstar_working;
         return V_star;
      }

      if( random_effects_model && random_effect_variances && diagonal_v && gram_schmidt )
      {
	//then go straight for the inverse using matrix inversion lemma:
	 if( vstar_working && (int)vstar_working->size1 != vstar_rows )
	 {
	    gsl_matrix_free( vstar_working );
	    vstar_working = 0;
	 }
         if( !vstar_working )
            vstar_working = gsl_matrix_calloc( vstar_rows, vstar_rows );
	 V_star = vstar_working;
	 int num_effects = random_effect_rows / ave_data_block_size;
	 list<int>::iterator cl_subjects_iter = cl_subjects_working.begin();
	 double re_prec_sum = 0;
	 while( cl_subjects_iter != cl_subjects_working.end() )
	 {
	    re_prec_sum += random_effect_posterior_precisions[ *cl_subjects_iter ];
	    ++cl_subjects_iter;
	 }
	 cl_subjects_iter = cl_subjects_working.begin();
	 for( i = 0; i < dim_V; i++ )
	 {
	   double s_ii = 1/(d_ + gsl_matrix_get( V_inv, i, i ) - re_prec_sum);
	   gsl_matrix_set( vstar_working, i, i, s_ii );
	 }
	 for( int ii = 0; ii < num_effects; ii++ )
	 {
	    double prec_i = random_effect_posterior_precisions[ *cl_subjects_iter ];
	    double v_ii_inv = gsl_matrix_get( V_inv, ii*0, ii*0 );
	    double v_m = 1/(d_+v_ii_inv-re_prec_sum);

	    double s_ij = -prec_i/(d_+v_ii_inv-re_prec_sum);//edge stuff
	    for( int rep = 0; rep < ave_data_block_size; rep++ )
	    {
	       i = dim_V + ii*ave_data_block_size + rep;
	       gsl_matrix_set( vstar_working, i, rep, s_ij );
	       gsl_matrix_set( vstar_working, rep, i, s_ij );
	    }

	    list<int>::iterator cl_subjects_iter2 = cl_subjects_working.begin();
	    for( int jj = 0; jj <= ii ; jj++ )
	    {
	       double prec_j = random_effect_posterior_precisions[ *cl_subjects_iter2 ];
	       double s_ij = v_m*prec_i*prec_j;
	       if( jj == ii )
		 s_ij += prec_i;
	       for( int rep = 0; rep < ave_data_block_size; rep++ )
	       {
		  i = dim_V + ii*ave_data_block_size + rep;
		  j = dim_V + jj*ave_data_block_size + rep;
		  gsl_matrix_set( vstar_working, i, j, s_ij );
		  gsl_matrix_set( vstar_working, j, i, s_ij );
	       }
	       ++cl_subjects_iter2;
	    }
	    ++cl_subjects_iter;
	 }
	 return V_star;
      }
      gsl_matrix* vst = NULL;
      if( g_prior && !vstar_map->empty() )
      {
         double first_index = vstar_map->begin()->first;
         gsl_matrix* first_matrix = vstar_map->begin()->second;
         if( correlate_experiments )
            first_index /= (double)num_experiments;
         double multiplier = ( v_multiplier * first_index + 1 ) / ( v_multiplier * d_ + 1 );
         if( !vstar_working )
            vstar_working = gsl_matrix_alloc( vstar_rows, vstar_rows );
         for( i = 0; i < dim_V; i++ )
            for( j = 0; j < dim_V; j++ )
               gsl_matrix_set( vstar_working, i, j, gsl_matrix_get( first_matrix, i, j ) * multiplier );
      }
      else{
         vst = gsl_matrix_calloc( vstar_rows, vstar_rows );
         if( ( !subject_experiment_weights || treat_experiments_separately ) && !treat_experiments_as_different_dimensions )
            for( i = 0; i < dim_V; i++ )
               for( j = 0; j < dim_V; j++ )
                  gsl_matrix_set( vst, i, j, gsl_matrix_get( D_sq, i, j ) * d_ + gsl_matrix_get( V_inv, i, j ) );
         else
	    if( !nn )
	       return V_star;
            else if( treat_experiments_as_different_dimensions )
            {
                for( i = 0; i < vstar_rows; i++ )
                {
                    if( nn && i == expt_limit )
                    {
                        expt_counter++;
                        if( data_block_sizes )
                            data_block_size = data_block_sizes[ expt_counter ];
                        expt_limit += num_1way_basis_fns[ expt_counter ];//knot_point_grid ? (vstar_rows/num_experiments_original) : data_block_size;
                        d_ = (double) gsl_matrix_int_get( nn, 0, expt_counter ) / data_block_size;
                    }
                    for( j = i; j < expt_limit; j++ )
                    {
                        double vst_ij = gsl_matrix_get( D_sq, i, j ) * d_ + gsl_matrix_get( V_inv, i, j );
                        gsl_matrix_set( vst, i, j, vst_ij );
                        gsl_matrix_set( vst, j, i, vst_ij );
                    }
                }
            }
	    else
	    {
	       gsl_matrix_memcpy( vst, V_inv );
	       for( i = 0; i < dim_num_obsns ; i++ )
	       {
                  double sub_exp_wt_sq = (double) gsl_matrix_int_get( nn, 0, i ) / (data_block_sizes ? data_block_sizes[ i ] : data_block_size);
		  for( j = 0; j < num_design_cols; j++ )
		     for( k = 0; k < num_design_cols; k++ )
		        gsl_matrix_set( vst, i * num_design_cols + j, i * num_design_cols + k, gsl_matrix_get( D_sq, i * num_design_cols + j, i * num_design_cols + k ) * sub_exp_wt_sq + gsl_matrix_get( V_inv, i * num_design_cols + j, i * num_design_cols + k ) );
	       }
	    }

         if( random_effects_model )
         {
            list<int>::iterator cl_subjects_iter = cl_subjects_working.begin();
            int counter = 0;
	    double vst_ij = 0;
            for( i = 0; i < random_effect_rows; i++ )
            {
               for( j = 0; j < dim_V; j++ )
               {
		  if( !random_effect_variances )
		     vst_ij = gsl_matrix_get( D_column_sums, 0, j % num_design_cols );
		  else
		     vst_ij = gsl_matrix_get( D, i, j % num_design_cols );
                  gsl_matrix_set( vst, dim_V + i, j, vst_ij );
                  gsl_matrix_set( vst, j, dim_V + i, vst_ij );
               }
               for( j = 0; j < i; j++ )
               {
                  gsl_matrix_set( vst, dim_V + i, dim_V + j, 0 );
                  gsl_matrix_set( vst, dim_V + j, dim_V + i, 0 );
               }
               if( !random_effect_variances )
                  gsl_matrix_set( vst, dim_V + i, dim_V + i, random_effects_precision + ( correlate_experiments ? inputs_repeated_every * num_experiments : inputs_repeated_every ) );
               else
               {
		 //                  while( random_effect_variances[ *cl_subjects_iter ] <= 0 )
		 //                     ++cl_subjects_iter;
                  gsl_matrix_set( vst, dim_V + i, dim_V + i, 1/random_effect_variances[ *cl_subjects_iter ] + ( correlate_experiments ? num_experiments : 1 ) );
                  counter++;
                  if( counter >= ave_data_block_size )
                  {
                     ++cl_subjects_iter;
                     counter = 0;
                  }
               }
            }
            if( vstar_working && (int)vstar_working->size1 != vstar_rows )
            {
               gsl_matrix_free( vstar_working );
               vstar_working = 0;
            }
         }
         if( !vstar_working )
            vstar_working = gsl_matrix_alloc( vstar_rows, vstar_rows );
         my_invert( vst, vstar_working );
      }
      if( vst )
      {
          if( keep_vstars && ( keep_vstars !=3 || required_vstar_of_storable_kind( index, full ) ) )// && ( index % data_block_sizes_sum == 0 ) )
         {
            gsl_matrix_memcpy( vst, vstar_working );
            (*vstar_map)[ index ] = vst;
         }
         else
            gsl_matrix_free( vst );
      }
      V_star = vstar_working;
      if( keep_vstars && ( keep_vstars !=3 || required_vstar_of_storable_kind( index, full ) ) )
      {
          hldv = 0.5 * p_y * my_lndet( V_star );
          (*half_log_det_vstars)[ index ] = hldv;
      }
   }
   return V_star;
}

void GLM_MVN_Clustering::delete_vstar( long int index )
{
   if( ( correlate_experiments ? index / num_experiments : index ) <= 2 )
      return;
   if( index == current_vstar_index )
      current_vstar_index = -1;
   mx_numtoptr::iterator iter = vstar_map->find( index );
   if( iter != vstar_map->end() )
   {
      gsl_matrix_free( iter->second );
      vstar_map->erase( iter );
   }
}

gsl_matrix* GLM_MVN_Clustering::get_vstar_dbl( double d )
{
   pair<double,long int> hash_pair ( d, current_v_index);
   map<pair<double,long int>,long int>::iterator iter = vstar_hash.find( hash_pair );
   V_star = 0;
   if( iter != vstar_hash.end() )
   {
      mx_numtoptr::iterator iter_map = vstar_map->find( iter->second );
      if( iter_map != vstar_map->end() )
      {
         V_star = iter_map->second;
         return V_star;
      }
   }

   double d_ = d / ave_data_block_size;
   if( correlate_experiments )
      d_ /= (double)num_experiments;

   gsl_matrix* vst = gsl_matrix_alloc( dim_V, dim_V );
   for( int i = 0; i < dim_V; i++ )
      for( int j = 0; j < dim_V; j++ )
         gsl_matrix_set( vst, i, j, gsl_matrix_get( D_sq, i, j ) * d_ + gsl_matrix_get( V_inv, i, j ) );
   if( !vstar_working )
      vstar_working = gsl_matrix_calloc( dim_V, dim_V );
   my_invert( vst, vstar_working );
   if( keep_vstars )
   {
      int hash_size = vstar_hash.size();
      vstar_hash[ hash_pair ] = hash_size;
      gsl_matrix_memcpy( vst, vstar_working );
      (*vstar_map)[ hash_size ] = vst;
   }
   else
      gsl_matrix_free( vst );
   V_star = vstar_working;
   return V_star;
}

int GLM_MVN_Clustering::find_position_in_cluster_map( Cluster_GLM_MVN* cl )
{
   int pos = 0;
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
       if( iter->first == cl )
          return pos;
       else
          pos++;
   cout << "Cluster " << (void*)cl << " not in map" << endl;
   exit(1);
}

void GLM_MVN_Clustering::empty_cluster_map()
{
   for( cluster_ptrtodbl::iterator iter = cluster_map.begin(); iter != cluster_map.end(); ++iter )
      delete iter->first;
   cluster_map.clear();
}

void GLM_MVN_Clustering::empty_vstar_map()
{
   for( int i = number_of_vs - 1; i >= 0; i-- )
   {
      vstar_map = vstar_maps[ i ];
      half_log_det_vstars = half_log_det_vstar_maps[ i ];
      for( mx_numtoptr::iterator iter = vstar_map->begin(); iter != vstar_map->end(); ++iter )
         gsl_matrix_free( iter->second );
      vstar_map->clear();
      half_log_det_vstars->clear();
      if( non_conjugate_model && inputs_repeated_every && ( !C1 || inputs_repeated_every == (int)C1->size1 ) )
      {
         gsl_matrix* temp_dvdt = 0;
         gsl_matrix* D_single = gsl_matrix_alloc( inputs_repeated_every, num_design_cols );
         for( int ii = 0; ii < inputs_repeated_every; ii++ )
            for( int j = 0; j < num_design_cols; j++ )
               gsl_matrix_set( D_single, ii, j, gsl_matrix_get( !C1D ? D : C1D, ii, j ) );
         gsl_matrix_multiply( temp_dvdt, D_single, V_, D_single, true );
         gsl_matrix_free( D_single );
         (*vstar_map)[ 0 ] = temp_dvdt;
      }
   }
   current_vstar_index = -INT_MAX;
   current_hldv_index = -INT_MAX;
   vstar_hash.clear();
}

double GLM_MVN_Clustering::get_half_log_det_vstar( long int index )
{
   if( index == current_hldv_index && required_vstar_of_storable_kind( index ) )
      return hldv;
   if( required_vstar_of_storable_kind( index ) )
      current_hldv_index = index;
   else
      current_hldv_index = -INT_MAX;
   inttodbl::iterator iter = half_log_det_vstars->find( index );
   if( iter != half_log_det_vstars->end() && required_vstar_of_storable_kind( index ) )
      hldv = iter->second;
   else
   {
      if( g_prior && !half_log_det_vstars->empty() )
      {
         double first_index = half_log_det_vstars->begin()->first;
         double first_half_log_det = half_log_det_vstars->begin()->second;
         double d_ = index;
         if( correlate_experiments )
         {
            first_index /= (double)num_experiments;
            d_ /= (double)num_experiments;
         }
         double multiplier = ( v_multiplier * first_index + 1 ) / ( v_multiplier * d_ + 1 );
         hldv = first_half_log_det + 0.5 * p_y * dim_V * log( multiplier );
      }
      else
      {
         if( !random_effects_model || !random_effect_variances || !diagonal_v || !gram_schmidt )//otherwise definitely have just calculated
            get_vstar( index );
         hldv = 0.5 * p_y * my_lndet( V_star );
      }
      if( keep_vstars && required_vstar_of_storable_kind( index ) )//&& ( index % data_block_sizes_sum == 0 ) )
         (*half_log_det_vstars)[ index ] = hldv;
   }
   return hldv;
}

double GLM_MVN_Clustering::get_half_log_det_vstar_dbl( double d )
{
   pair<double,long int> hash_pair ( d, current_v_index);
   map<pair<double,long int>,long int>::iterator iter = vstar_hash.find( hash_pair  );
   if( iter != vstar_hash.end() )
   {
      int index = iter->second;
      if( half_log_det_vstars->find( index ) != half_log_det_vstars->end() )
         return (*half_log_det_vstars)[ iter->second ];
   }
   hldv = 0.5 * p_y * my_lndet( get_vstar_dbl( d ) );
   if( keep_vstars )
      (*half_log_det_vstars)[ vstar_hash[ hash_pair ] ] = hldv;
   return hldv;
}

double GLM_MVN_Clustering::get_half_lndet_invvinvplusdtd( gsl_matrix* dd )
{
   gsl_matrix* mx = gsl_matrix_alloc( dim_V, dim_V );
   if( !treat_experiments_as_different_dimensions )
   {
      int expt_limit = 0, expt_counter = 0, row_counter = 0;
      for( int i = 0; i < dim_V; i++ )
      {
	 if( i == expt_limit )
	 {
	    expt_counter++;
	    row_counter = 0;
	    expt_limit += dim_V / num_experiments;//num_1way_basis_fns[ expt_counter ];//knot_point_grid ? (vstar_rows/num_experiments_original) : data_block_size;
	 }
	 for( int j = i; j < expt_limit; j++ )
	 {
	    double vst_ij = gsl_matrix_get( dd, row_counter, j ) + gsl_matrix_get( V_inv, i, j );
	    gsl_matrix_set( mx, i, j, vst_ij );
	    gsl_matrix_set( mx, j, i, vst_ij );
	 }
	 row_counter++;
      }
   }
   else
   {
      gsl_matrix_memcpy( mx, V_inv );
      gsl_matrix_add( mx, dd );
   }
   double d = -0.5 * p_y * my_lndet( mx );
//   cout << gsl_matrix_get( mx,0, 0) << "  : " << gsl_matrix_get( mx,dim_V-1, dim_V-1)<< "  : " << gsl_matrix_get( V_inv,dim_V-1, dim_V-1)<< "  : " << gsl_matrix_get( V_inv,0,0)<< "  : " << d  << endl;
   gsl_matrix_free( mx );
   return d;
}

double GLM_MVN_Clustering::get_half_lndet_invvinvplusdtd( Cluster_GLM_MVN* cl )
{
   return get_half_lndet_invvinvplusdtd( cl->get_dtd() );
}

gsl_matrix* GLM_MVN_Clustering::get_non_conjugate_precision_matrix( double sigma_sq_val, int num_obs, int *shift_ptr )
{
   if( num_obs <= storing_non_conjugate_precision_matrices && shift_ptr && x_gl && number_of_vs == 1 )
   {
      mx_numtoptr::iterator iter = vstar_map->find( *shift_ptr + num_obs * dim_gl );
      if( iter != vstar_map->end() )
      {
         V_star = iter->second;
         return V_star;
      }
   }
   gsl_matrix* dvdt = (*vstar_map)[ 0 ];
   int dvdt_size = dvdt->size1;
   int cov_mx_size = dvdt_size * num_obs;
   gsl_matrix* cov_mx = gsl_matrix_alloc( cov_mx_size, cov_mx_size );
   for( int i = 0; i < dvdt_size; i++ )
      for( int num_i = 0; num_i < num_obs; num_i++ )
         for( int j = 0; j < dvdt_size; j++ )
            for( int num_j = 0; num_j < num_obs; num_j++ )
            {
               double cov_mx_ij = gsl_matrix_get( dvdt, i, j );
               if( i == j && num_i == num_j )
                  cov_mx_ij += sigma_sq_val;
               gsl_matrix_set( cov_mx, num_i * dvdt_size + i, num_j * dvdt_size + j, cov_mx_ij );
            }
   if( vstar_working && (int)vstar_working->size1 != cov_mx_size )
   {
      gsl_matrix_free( vstar_working );
      vstar_working = 0;
   }
   if( !vstar_working )
      vstar_working = gsl_matrix_calloc( cov_mx_size, cov_mx_size );
   my_invert( cov_mx, vstar_working );
   if( num_obs <= storing_non_conjugate_precision_matrices && shift_ptr && x_gl && number_of_vs == 1 )
   {
      gsl_matrix_memcpy( cov_mx, vstar_working );
      (*vstar_map)[ *shift_ptr + num_obs * dim_gl ] = cov_mx;
   }
   else
      gsl_matrix_free( cov_mx );
   V_star = vstar_working;
   return V_star;
}

double GLM_MVN_Clustering::get_logdet_non_conjugate_precision_matrix( gsl_matrix *precision_mx, int num_obs, int *shift_ptr )
{
   if( num_obs <= storing_non_conjugate_precision_matrices && shift_ptr && x_gl && half_log_det_vstars->find( *shift_ptr + num_obs * dim_gl ) != half_log_det_vstars->end() )
      return (*half_log_det_vstars)[ *shift_ptr + num_obs * dim_gl ];
   if( num_obs <= storing_non_conjugate_precision_matrices && shift_ptr && x_gl && vstar_map->find( *shift_ptr + num_obs * dim_gl ) != vstar_map->end() )
   {
      double logdet = my_lndet( (*vstar_map)[ *shift_ptr + num_obs * dim_gl ] );
      (*half_log_det_vstars)[ *shift_ptr + num_obs * dim_gl ] = logdet;
      return logdet;
   }
   return my_lndet( precision_mx );
}

gsl_matrix_int* GLM_MVN_Clustering::get_nob_for_subject( int subject_number )
{
   for( int j = 0; j < dim_num_obsns; j++ )
      gsl_matrix_int_set( num_obsns_working, 0 , j, NOBs[ subject_number ][ j ] );
   return num_obsns_working;
}

gsl_matrix* GLM_MVN_Clustering::get_yty_for_subject( int subject_number )
{
   if(yty_cols)
   for( int i = 0; i < p_y; i++ )
      for( int j = 0; j < yty_cols; j++ )
         gsl_matrix_set( yty_working, i, j, YTYs[ p_y * subject_number + i ][ j ] );
   return yty_working;
}

gsl_matrix* GLM_MVN_Clustering::get_ytd_for_subject( int subject_number )
{
   if(ytd_cols)
   for( int i = 0; i < p_y; i++ )
      for( int j = 0; j < ytd_cols; j++ )
         gsl_matrix_set( ytd_working, i, j, YTDs[ p_y * subject_number + i ][ j ] );
   return ytd_working;
}

gsl_matrix* GLM_MVN_Clustering::get_dtd_for_subject( int subject_number )
{
   for( int i = 0; i < num_design_cols; i++ )
      for( int j = 0; j < dtd_cols ; j++ )
         gsl_matrix_set( dtd_working, i, j, DTDs[ subject_number * num_design_cols + i ][ j ] );
   return dtd_working;
}

gsl_matrix* GLM_MVN_Clustering::get_design_points( list<int>& cl_subjects_allocated, int* exp_number )
{
   gsl_matrix *ds = 0, *ds_copy = 0;
   int num_rows = 0;
   int i;
   for( list<int>::iterator iter = cl_subjects_allocated.begin(); iter != cl_subjects_allocated.end(); ++iter )
   {
      int start = get_subject_index( *iter );
      int end = get_subject_index( *iter + 1 );
      int row_counter = start * data_block_sizes_sum / num_data_block_sizes;
      for( int i0 = start; i0 < end; i0++ )
      {
         if( !exp_number || get_experiment_number( i0 ) == *exp_number )
         {
            ds_copy = ds;
            ds = gsl_matrix_alloc( num_rows + data_block_size, num_design_cols );
            for( int j = 0; j < num_design_cols; j++ )
            {
               for( i = 0; i < num_rows; i++ )
                  gsl_matrix_set( ds, i, j, gsl_matrix_get( ds_copy, i, j ) );
               for( i = num_rows; i < num_rows + data_block_size; i++ )
                  gsl_matrix_set( ds, i, j, gsl_matrix_get( ds_copy, row_counter + i - num_rows, j ) );
            }
            num_rows += data_block_size;
            if( ds_copy )
               gsl_matrix_free( ds_copy );
         }
         row_counter += data_block_size;
      }
   }
   return ds;
}

double GLM_MVN_Clustering::get_criterion_maximum()
{
   if( bic_criterion == 1 )
      return max_BIC;
   return max_log_likelihood;
}

void GLM_MVN_Clustering::write_dendrogram_to_file()
{
   if( !dendrogram || !strlen( Dendrogram_Output_Filename ) )
      return;
   ofstream DendrogramStream( Dendrogram_Output_Filename, ios::out );
   for( int i = 0; i < num_subjects; i++ )
      DendrogramStream << dendrogram[ i ] + 1 << endl;
}

void GLM_MVN_Clustering::write_dendrogram_scores_to_file()
{
   if( !dendrogram_scores || !strlen( Dendrogram_Scores_Filename ) )
      return;
   double ave_score = 0, ave_exp_score = 0;
   double max_score = get_criterion_maximum();
   ofstream DendrogramScoresStream( Dendrogram_Scores_Filename, ios::out );
   for( int i = 0; i < num_subjects; i++ )
   {
      ave_score += dendrogram_scores[ i ];
      ave_exp_score += exp( dendrogram_scores[ i ] - max_score );
      DendrogramScoresStream << dendrogram_scores[ i ] << endl;
   }
   ave_score /= (double)num_subjects;
   ave_exp_score = max_score + log(ave_exp_score) - log(num_subjects);
   if( print_to_screen )
      cout << "Average score across dendrogram = " << ave_exp_score << endl;
}

void GLM_MVN_Clustering::write_association_matrix_to_file()
{
   if( !association_matrix )
      return;
   normalise_association_matrix();
   int* assoc_arg_max = argmax_association_matrix();
   cout << "Subject pair with highest association score: (" << assoc_arg_max[0] + 1 << "," << assoc_arg_max[1] + 1 << ").       Score=" << association_matrix[ assoc_arg_max[0] ][ assoc_arg_max[1] ] << endl;
   delete [] assoc_arg_max;
   if( !strlen( Association_Matrix_Filename ) )
      return;
   ofstream AssociationStream( Association_Matrix_Filename, ios::out );
    for( int i = 0; i < num_subjects; i++ )
    {
       for( int j = 0; j < num_subjects; j++ )
          AssociationStream << association_matrix[ i ][ j ] << " ";
       AssociationStream << endl;
    }
}

void GLM_MVN_Clustering::write_subjects_first_merge_to_file()
{
   if( !subjects_first_merge || !strlen( Subjects_First_Merge_Filename ) )
      return;
   ofstream FirstMergeStream( Subjects_First_Merge_Filename, ios::out );
   int i,j;
   for( i = 0; i < num_subjects; i++ )
   {
      for( j = 0; j < i; j++ )
	 FirstMergeStream << subjects_first_merge[ i ][ j ] << " ";
      FirstMergeStream << 0 << " ";
      for( j = (i+1); j < num_subjects; j++ )
	 FirstMergeStream << subjects_first_merge[ j ][ i ] << " ";
      FirstMergeStream << endl;
   }
}

void GLM_MVN_Clustering::write_closeness_matrix_to_file() const
{
   if( !closeness_matrix )
      return;
   if( strlen( Closeness_Matrix_Filename ) )
   {
      ofstream ClosenessStream( Closeness_Matrix_Filename, ios::out );
      double *change_in_prior = 0;
      if( !euclidean_or_correlation_clustering )
      {
         change_in_prior = new double;
         *change_in_prior = log_prior_num_clusters[ number_of_clusters - 1 ] - log_prior_num_clusters[ number_of_clusters ];
      }
      write_lower_triangle_matrix( closeness_matrix, num_subjects, ClosenessStream, change_in_prior );
      zap( change_in_prior );
   }
}

void GLM_MVN_Clustering::write_ammended_closeness_matrix_to_file( const unsigned int row ) const
{
   if( !closeness_matrix || !strlen( Closeness_Matrix_Filename ) )
      return;

   ofstream ClosenessStream( Closeness_Matrix_Filename, ios::app );
   double *change_in_prior = 0;
   if( !euclidean_or_correlation_clustering )
   {
       change_in_prior = new double;
       *change_in_prior = log_prior_num_clusters[ number_of_clusters - 1 ] - log_prior_num_clusters[ number_of_clusters ];
   }
   write_row_of_lower_triangle_matrix( closeness_matrix, num_subjects, row, ClosenessStream, change_in_prior );
   zap( change_in_prior );
}

void GLM_MVN_Clustering::write_single_subject_contributions_to_file()
{
   if( !strlen( Single_Subject_Contributions_Filename ) || single_subject_clusters.empty() )
      return;
   ofstream SingleSubjectContributionsStream( Single_Subject_Contributions_Filename, ios::out );
   for( deque< Cluster_GLM_MVN* >::iterator iter = single_subject_clusters.begin(); iter != single_subject_clusters.end(); iter++ )
   {
      double d = (*iter)->get_closeness_contribution();
//      d += lambda_prior_normalising_constant*num_experiments - ( regression_n / regression_num_subjects ) * p_y * LOG_SQRT_PI;
      SingleSubjectContributionsStream << d << endl;
   }
   if( !preserve_tree )
      single_subject_clusters.clear();
}

double GLM_MVN_Clustering::calculate_gauss_laguerre_non_conjugate_ml( list<int> cl_subjects, int* exp_number )
{
   bool monte_carlo = 0;
   bool global_variance_estimate = true;
   double est_lik = 0;
   gsl_matrix *ys = NULL, *ys_transp = NULL;
   ys = get_targets( cl_subjects, exp_number );
   ys_transp = gsl_matrix_alloc( ys->size2, ys->size1 );
   gsl_matrix_transpose_memcpy( ys_transp, ys );

   int num_subs = cl_subjects.size();

   //   int num_ys = ys.get_rows();
   //   matrix ds = get_design_points( cl_subjects );
   //   matrix ys2 = ys - ds * (*get_vstar( num_subs )) * ds.transpose() * ys;
   //   matrix ys2_transp = ys2.transpose();

   //****
//     Cluster_GLM_MVN* cl = create_temporary_cluster_for_subjects( cl_subjects, cl_subjects.begin(), cl_subjects.end(), false );
//     int nn = cl->get_total_num_obsns();
//     a_star = a_star_lookup[ nn ];
//     *yty_working = *cl->get_yty();
//     *ytd_working = *cl->get_ytd();
//     if( !b_star )
//        b_star = gsl_matrix_alloc( p_y, p_y );
//     gsl_matrix_set( b_star, 0, 0,  b_ + 0.5 * ( *yty_working - *ytd_working * (*get_vstar( nn )) * yd.transpose() ).sum() );
//     delete cl;

//     for( int i = 0; i < 20; i++ )
//        cout << draw_lambda_from_posterior() << endl;
//     cout <<"--------"<<num_subs<<"----------\n" << endl;
   //****

   if( monte_carlo )
   {
      for( int i = 0; i < 1000; i++ ) // monte carlo estimation
      {
         double lam = draw_lambda_from_prior();
         gsl_matrix* prec = get_non_conjugate_precision_matrix( 1 / lam, num_subs );
         est_lik += exp( -0.5 * ( - my_lndet( prec ) + scalar_result_gsl_matrix_multiply( ys_transp, prec, ys ) ) );
//         if( !(i % 10) )
//            cout << log( est_lik / ( (double)i + 1 ) ) << endl;
      }
   gsl_matrix_free( ys );
   gsl_matrix_free( ys_transp );
      return log( est_lik / 1000 );
   }

   if( !w_gl )
   {
      create_gauss_laguerre_matrices();
      if( dim_gl == 1 && global_variance_estimate )
      {
         gsl_matrix* covs = calculate_covariances( Y );
         gsl_matrix_set( x_gl, 0, 0, gsl_matrix_get( covs, 0, 0 ) );
         gsl_matrix_free( covs );
      }
   }

   if( dim_gl == 1 )
   {
      gsl_matrix* precision_mx;
      int i = 0;
      if( !global_variance_estimate )
      {
         gsl_matrix* covs = calculate_covariances( ys );
         gsl_matrix_set( x_gl, i, 0, 1 / gsl_matrix_get( covs, 0, 0 ) );
         gsl_matrix_free( covs );
//         gsl_matrix_set( x_gl, i, 0, draw_lambda_from_posterior() );
         precision_mx = get_non_conjugate_precision_matrix( 1 / gsl_matrix_get( x_gl, i, 0 ), num_subs, NULL );
      }
      else
         precision_mx = get_non_conjugate_precision_matrix( 1 / gsl_matrix_get( x_gl, i, 0 ), num_subs, &i );
      double log_det_i = get_logdet_non_conjugate_precision_matrix( precision_mx, num_subs, &i );
      double log_lik_i = .5 * log_det_i;
      log_lik_i -= 0.5 * scalar_result_gsl_matrix_multiply( ys_transp, precision_mx, ys );

      //      log_lik_i = -0.5 * ( log( gsl_matrix_get( x_gl, i, 0 ) ) * num_ys * p_y + ( ys2_transp * ys2  ).sum()/ gsl_matrix_get( x_gl, 0, 0 ) );
      if( ys )
         gsl_matrix_free( ys );
      if( ys_transp )
         gsl_matrix_free( ys_transp );
      return log_lik_i;
   }

   for( int i = 0; i < dim_gl; i++ )
   {
      gsl_matrix* precision_mx = get_non_conjugate_precision_matrix( 1 / gsl_matrix_get( x_gl, i, 0 ), num_subs, &i );
      double log_det_i = get_logdet_non_conjugate_precision_matrix( precision_mx, num_subs, &i );
      double log_lik_i = .5 * log_det_i;
      log_lik_i -= 0.5 * scalar_result_gsl_matrix_multiply( ys_transp, precision_mx, ys );
      //      log_lik_i = -0.5 * ( log( gsl_matrix_get( x_gl, i, 0 ) ) * num_ys * p_y + ( ys2_transp * ys2  ).sum()/ gsl_matrix_get( x_gl, i, 0 ) );
      log_lik_i += get_lambda_density( gsl_matrix_get( x_gl, i, 0 ) );
      est_lik += gsl_matrix_get( w_gl, i, 0 ) * exp( log_lik_i );
   }
   if( ys )
      gsl_matrix_free( ys );
   if( ys_transp )
      gsl_matrix_free( ys_transp );
   return log( est_lik );
}

double GLM_MVN_Clustering::sum_cluster_configuration_probabilities()
{
   zap_vector( cluster_probs );
   cluster_probs_size = number_of_clusters + 1;
   cluster_probs = new double[ cluster_probs_size ];
   cluster_probs[ 0 ] = 0;
   number_of_configurations = 0;
   maximum_log_posterior = -DBL_MAX;
   int num_rows = unmergeable_cluster_deque.size();
   int i, j;
   if( num_rows && !ave_predictions_mx )
   {
      predictions_mx_rows = num_rows;
      ave_predictions_mx_cols = p_y == 1 ? 2 : 3;
      create_zeroed_array( ave_predictions_mx, predictions_mx_rows, ave_predictions_mx_cols );
   }
   double probsum = 0;
   for( i = 1; i <= number_of_clusters; i++ )
   {
      cluster_probs[ i ] = sum_cluster_configuration_probabilities( number_of_clusters, i );
      probsum += cluster_probs[ i ];
   }
   for( i = 1; i <= number_of_clusters; i++ )
      cluster_probs[ i ] /= probsum;
   cout << "Bell(" << number_of_clusters << ") = " << number_of_configurations << " possible partitions" << endl;
   cout << "Marginal likelihood across all partitions = " << probsum * exp( baseline_configuration_log_likelihood ) << endl;
   cout << "Posterior distribution of number of clusters:" << endl;
   cout << "#Clusters    Probability" << endl;
   cout << "------------------------" << endl;
   draw_histogram( cluster_probs, cluster_probs_size );
   cout << "------------------------" << endl;
   if( ave_predictions_mx )
   {
      if( model_averaging )
      {
	 int last_col = ave_predictions_mx_cols - 1;
	 for( int i = 0; i < predictions_mx_rows; i++ )
            ave_predictions_mx[ i ][ last_col ] /= probsum;
      }
      else
         for( i = 0; i < predictions_mx_rows; i++ )
            for( j = 0; j < predictions_mx_rows; j++ )
               ave_predictions_mx[ i ][ j ] = predictions_mx[ i ][ j ];
      initialise_mergeable_cluster_deque();
   }
   return probsum;
}

double GLM_MVN_Clustering::sum_cluster_configuration_probabilities( int num_subs, int num_clust, int k, int* allocations )
{
   double probs_sum = 0;
   if( !allocations )
   {
      allocations = new int[ num_subs ];
      allocations[ 0 ] = 0;
      probs_sum = 0;
   }
   int minalloc = 0, maxalloc = 0;
   for( int j = 1; j < k; j++ )
      if( maxalloc < allocations[ j ] )
         maxalloc = allocations[ j ];
   if( maxalloc < num_clust - ( num_subs - k ) )
      minalloc = num_clust - ( num_subs - k );
   if( k > 0 && maxalloc < num_clust - 1 )
      maxalloc++;
   for( allocations[ k ] = minalloc; allocations[ k ] <= maxalloc; allocations[ k ]++ )
      if( k < num_subs - 1 )
         probs_sum += sum_cluster_configuration_probabilities( num_subs, num_clust, k + 1, allocations );
      else
      {
         cluster_ptrtodbl map_of_clusters;
         for( int allocnum = 0; allocnum < num_clust; allocnum++ )
         {
            list<int> cl_subjects;
            for( int j = 0; j < num_subs; j++ )
               if( allocations[ j ] == allocnum )
                  cl_subjects.push_back( j );
            map_of_clusters[ create_temporary_cluster_for_subjects( cl_subjects ) ] = allocnum;
         }
	 number_of_configurations++;
         double log_prob = calculate_log_likelihood( map_of_clusters );
         if( num_clust == 1 )
            baseline_configuration_log_likelihood = log_prob;
         double prob = exp( log_prob - baseline_configuration_log_likelihood );
	 if( model_averaging || log_prob > maximum_log_posterior )
	 {
            if( ave_predictions_mx )
            {
               mergeable_cluster_deque.clear();
               for( cluster_ptrtodbl::iterator iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
                  if( iter->first->get_mergeable() )
                  {
                     if( iter->first->get_distinct() )
                        mergeable_cluster_deque.push_back( iter->first );
                     else
                        mergeable_cluster_deque.push_front( iter->first );
                  }
               make_predictions();
               if( model_averaging )
               {
                  int last_col = ave_predictions_mx_cols - 1;
                  for( int i = 0; i < predictions_mx_rows; i++ )
                     ave_predictions_mx[ i ][ last_col ] += predictions_mx[ i ][ last_col ] * prob;
               }
            }
	    if( !model_averaging || log_prob > maximum_log_posterior )
	    {
               for( int i = 0; i < num_subs; i++ )
                  cout << allocations[ i ] << endl;
	       cout << log_prob << "\n---------------" << endl;
	       maximum_log_posterior = log_prob;
	    }
	 }

         probs_sum += prob;
         for( cluster_ptrtodbl::iterator iter = map_of_clusters.begin(); iter != map_of_clusters.end(); ++iter )
            delete iter->first;
      }
   if( !k )
      delete [] allocations;
   return probs_sum;
}

gsl_matrix* GLM_MVN_Clustering::get_target_covariances( Cluster_GLM_MVN* cl, bool corr, bool residual_covariances )
{
   list<int> list_of_subjects = cl->get_subjects_allocated();
   return Regression::get_target_covariances( list_of_subjects, corr, residual_covariances );
}
